#include "stdafx.h"

#include "office/excel/EXLWorkbook.h"
#include "office/excel/EXLWorksheets.h"

#pragma warning( push )
#pragma warning( disable : 26493 26485 26494 )

namespace MSO::Excel {

LPDISPATCH EXLWorkbook::get_Application() {
  LPDISPATCH result;
  InvokeHelper(0x94, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
long EXLWorkbook::get_Creator() {
  long result;
  InvokeHelper(0x95, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
LPDISPATCH EXLWorkbook::get_Parent() {
  LPDISPATCH result;
  InvokeHelper(0x96, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
BOOL EXLWorkbook::get_AcceptLabelsInFormulas() {
  BOOL result;
  InvokeHelper(0x5a1, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::put_AcceptLabelsInFormulas(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x5a1, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
void EXLWorkbook::Activate() {
  InvokeHelper(0x130, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
LPDISPATCH EXLWorkbook::get_ActiveChart() {
  LPDISPATCH result;
  InvokeHelper(0xb7, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH EXLWorkbook::get_ActiveSheet() {
  LPDISPATCH result;
  InvokeHelper(0x133, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
CString EXLWorkbook::get_Author() {
  CString result;
  InvokeHelper(0x23e, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::put_Author(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x23e, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
long EXLWorkbook::get_AutoUpdateFrequency() {
  long result;
  InvokeHelper(0x5a2, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::put_AutoUpdateFrequency(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x5a2, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL EXLWorkbook::get_AutoUpdateSaveChanges() {
  BOOL result;
  InvokeHelper(0x5a3, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::put_AutoUpdateSaveChanges(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x5a3, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
long EXLWorkbook::get_ChangeHistoryDuration() {
  long result;
  InvokeHelper(0x5a4, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::put_ChangeHistoryDuration(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x5a4, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
LPDISPATCH EXLWorkbook::get_BuiltinDocumentProperties() {
  LPDISPATCH result;
  InvokeHelper(0x498, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::ChangeFileAccess(long Mode, VARIANT WritePassword, VARIANT Notify) {
  static BYTE parms[] = VTS_I4 VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x3dd, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Mode, &WritePassword, &Notify);
}
void EXLWorkbook::ChangeLink(LPCTSTR Name, LPCTSTR NewName, long Type) {
  static BYTE parms[] = VTS_BSTR VTS_BSTR VTS_I4;
  InvokeHelper(0x322, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Name, NewName, Type);
}
LPDISPATCH EXLWorkbook::get_Charts() {
  LPDISPATCH result;
  InvokeHelper(0x79, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::Close(VARIANT SaveChanges, VARIANT Filename, VARIANT RouteWorkbook) {
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x115, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &SaveChanges, &Filename, &RouteWorkbook);
}
CString EXLWorkbook::get_CodeName() {
  CString result;
  InvokeHelper(0x55d, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
CString EXLWorkbook::get__CodeName() {
  CString result;
  InvokeHelper(0x80010000, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::put__CodeName(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x80010000, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
VARIANT EXLWorkbook::get_Colors(VARIANT IndexType) {
  VARIANT result;
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0x11e, DISPATCH_PROPERTYGET, VT_VARIANT, (void*)&result, parms, &IndexType);
  return result;
}
void EXLWorkbook::put_Colors(VARIANT IndexType, VARIANT newValue) {
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x11e, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, &IndexType, &newValue);
}
LPDISPATCH EXLWorkbook::get_CommandBars() {
  LPDISPATCH result;
  InvokeHelper(0x59f, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
CString EXLWorkbook::get_Comments() {
  CString result;
  InvokeHelper(0x23f, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::put_Comments(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x23f, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
long EXLWorkbook::get_ConflictResolution() {
  long result;
  InvokeHelper(0x497, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::put_ConflictResolution(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x497, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
LPDISPATCH EXLWorkbook::get_Container() {
  LPDISPATCH result;
  InvokeHelper(0x4a6, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
BOOL EXLWorkbook::get_CreateBackup() {
  BOOL result;
  InvokeHelper(0x11f, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
LPDISPATCH EXLWorkbook::get_CustomDocumentProperties() {
  LPDISPATCH result;
  InvokeHelper(0x499, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
BOOL EXLWorkbook::get_Date1904() {
  BOOL result;
  InvokeHelper(0x193, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::put_Date1904(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x193, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
void EXLWorkbook::DeleteNumberFormat(LPCTSTR NumberFormat) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x18d, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, NumberFormat);
}
LPDISPATCH EXLWorkbook::get_DialogSheets() {
  LPDISPATCH result;
  InvokeHelper(0x2fc, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
long EXLWorkbook::get_DisplayDrawingObjects() {
  long result;
  InvokeHelper(0x194, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::put_DisplayDrawingObjects(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x194, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL EXLWorkbook::ExclusiveAccess() {
  BOOL result;
  InvokeHelper(0x490, DISPATCH_METHOD, VT_BOOL, (void*)&result, nullptr);
  return result;
}
long EXLWorkbook::get_FileFormat() {
  long result;
  InvokeHelper(0x120, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::ForwardMailer() {
  InvokeHelper(0x3cd, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
CString EXLWorkbook::get_FullName() {
  CString result;
  InvokeHelper(0x121, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
BOOL EXLWorkbook::get_HasMailer() {
  BOOL result;
  InvokeHelper(0x3d0, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::put_HasMailer(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x3d0, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL EXLWorkbook::get_HasPassword() {
  BOOL result;
  InvokeHelper(0x122, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
BOOL EXLWorkbook::get_HasRoutingSlip() {
  BOOL result;
  InvokeHelper(0x3b6, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::put_HasRoutingSlip(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x3b6, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL EXLWorkbook::get_IsAddin() {
  BOOL result;
  InvokeHelper(0x5a5, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::put_IsAddin(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x5a5, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
CString EXLWorkbook::get_Keywords() {
  CString result;
  InvokeHelper(0x241, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::put_Keywords(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x241, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
VARIANT EXLWorkbook::LinkInfo(LPCTSTR Name, long LinkInfo, VARIANT Type, VARIANT EditionRef) {
  VARIANT result;
  static BYTE parms[] = VTS_BSTR VTS_I4 VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x327, DISPATCH_METHOD, VT_VARIANT, (void*)&result, parms, Name, LinkInfo, &Type, &EditionRef);
  return result;
}
VARIANT EXLWorkbook::LinkSources(VARIANT Type) {
  VARIANT result;
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0x328, DISPATCH_METHOD, VT_VARIANT, (void*)&result, parms, &Type);
  return result;
}
LPDISPATCH EXLWorkbook::get_Mailer() {
  LPDISPATCH result;
  InvokeHelper(0x3d3, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::MergeWorkbook(VARIANT Filename) {
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0x5a6, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &Filename);
}
LPDISPATCH EXLWorkbook::get_Modules() {
  LPDISPATCH result;
  InvokeHelper(0x246, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
BOOL EXLWorkbook::get_MultiUserEditing() {
  BOOL result;
  InvokeHelper(0x491, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
CString EXLWorkbook::get_Name() {
  CString result;
  InvokeHelper(0x6e, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
LPDISPATCH EXLWorkbook::get_Names() {
  LPDISPATCH result;
  InvokeHelper(0x1ba, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH EXLWorkbook::NewWindow() {
  LPDISPATCH result;
  InvokeHelper(0x118, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
CString EXLWorkbook::get_OnSave() {
  CString result;
  InvokeHelper(0x49a, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::put_OnSave(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x49a, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
CString EXLWorkbook::get_OnSheetActivate() {
  CString result;
  InvokeHelper(0x407, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::put_OnSheetActivate(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x407, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
CString EXLWorkbook::get_OnSheetDeactivate() {
  CString result;
  InvokeHelper(0x439, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::put_OnSheetDeactivate(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x439, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
void EXLWorkbook::OpenLinks(LPCTSTR Name, VARIANT ReadOnly, VARIANT Type) {
  static BYTE parms[] = VTS_BSTR VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x323, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Name, &ReadOnly, &Type);
}
CString EXLWorkbook::get_Path() {
  CString result;
  InvokeHelper(0x123, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
BOOL EXLWorkbook::get_PersonalViewListSettings() {
  BOOL result;
  InvokeHelper(0x5a7, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::put_PersonalViewListSettings(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x5a7, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL EXLWorkbook::get_PersonalViewPrintSettings() {
  BOOL result;
  InvokeHelper(0x5a8, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::put_PersonalViewPrintSettings(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x5a8, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
LPDISPATCH EXLWorkbook::PivotCaches() {
  LPDISPATCH result;
  InvokeHelper(0x5a9, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::Post(VARIANT DestName) {
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0x48e, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &DestName);
}
BOOL EXLWorkbook::get_PrecisionAsDisplayed() {
  BOOL result;
  InvokeHelper(0x195, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::put_PrecisionAsDisplayed(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x195, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
void EXLWorkbook::__PrintOut(VARIANT From, VARIANT To, VARIANT Copies, VARIANT Preview, VARIANT ActivePrinter, VARIANT PrintToFile, VARIANT Collate) {
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x389, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &From, &To, &Copies, &Preview, &ActivePrinter, &PrintToFile, &Collate);
}
void EXLWorkbook::PrintPreview(VARIANT EnableChanges) {
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0x119, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &EnableChanges);
}
void EXLWorkbook::_Protect(VARIANT Password, VARIANT Structure, VARIANT Windows) {
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x11a, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &Password, &Structure, &Windows);
}
void EXLWorkbook::_ProtectSharing(VARIANT Filename, VARIANT Password, VARIANT WriteResPassword, VARIANT ReadOnlyRecommended, VARIANT CreateBackup, VARIANT SharingPassword) {
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x5aa, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &Filename, &Password, &WriteResPassword, &ReadOnlyRecommended, &CreateBackup, &SharingPassword);
}
BOOL EXLWorkbook::get_ProtectStructure() {
  BOOL result;
  InvokeHelper(0x24c, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
BOOL EXLWorkbook::get_ProtectWindows() {
  BOOL result;
  InvokeHelper(0x127, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
BOOL EXLWorkbook::get_ReadOnly() {
  BOOL result;
  InvokeHelper(0x128, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
BOOL EXLWorkbook::get__ReadOnlyRecommended() {
  BOOL result;
  InvokeHelper(0x129, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::RefreshAll() {
  InvokeHelper(0x5ac, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void EXLWorkbook::Reply() {
  InvokeHelper(0x3d1, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void EXLWorkbook::ReplyAll() {
  InvokeHelper(0x3d2, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void EXLWorkbook::RemoveUser(long IndexType) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x5ad, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, IndexType);
}
long EXLWorkbook::get_RevisionNumber() {
  long result;
  InvokeHelper(0x494, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::Route() {
  InvokeHelper(0x3b2, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
BOOL EXLWorkbook::get_Routed() {
  BOOL result;
  InvokeHelper(0x3b7, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
LPDISPATCH EXLWorkbook::get_RoutingSlip() {
  LPDISPATCH result;
  InvokeHelper(0x3b5, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::RunAutoMacros(long Which) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x27a, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Which);
}
void EXLWorkbook::Save() {
  InvokeHelper(0x11b, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void EXLWorkbook::_SaveAs(VARIANT Filename, VARIANT FileFormat, VARIANT Password, VARIANT WriteResPassword, VARIANT ReadOnlyRecommended, VARIANT CreateBackup, long AccessMode, VARIANT ConflictResolution, VARIANT AddToMru, VARIANT TextCodepage, VARIANT TextVisualLayout) {
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_I4 VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x11c, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &Filename, &FileFormat, &Password, &WriteResPassword, &ReadOnlyRecommended, &CreateBackup, AccessMode, &ConflictResolution, &AddToMru, &TextCodepage, &TextVisualLayout);
}
void EXLWorkbook::SaveCopyAs(VARIANT Filename) {
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0xaf, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &Filename);
}
BOOL EXLWorkbook::get_Saved() {
  BOOL result;
  InvokeHelper(0x12a, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::put_Saved(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x12a, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL EXLWorkbook::get_SaveLinkValues() {
  BOOL result;
  InvokeHelper(0x196, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::put_SaveLinkValues(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x196, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
void EXLWorkbook::SendMail(VARIANT Recipients, VARIANT Subject, VARIANT ReturnReceipt) {
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x3b3, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &Recipients, &Subject, &ReturnReceipt);
}
void EXLWorkbook::SendMailer(VARIANT FileFormat, long Priority) {
  static BYTE parms[] = VTS_VARIANT VTS_I4;
  InvokeHelper(0x3d4, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &FileFormat, Priority);
}
void EXLWorkbook::SetLinkOnData(LPCTSTR Name, VARIANT Procedure) {
  static BYTE parms[] = VTS_BSTR VTS_VARIANT;
  InvokeHelper(0x329, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Name, &Procedure);
}
LPDISPATCH EXLWorkbook::get_Sheets() {
  LPDISPATCH result;
  InvokeHelper(0x1e5, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
BOOL EXLWorkbook::get_ShowConflictHistory() {
  BOOL result;
  InvokeHelper(0x493, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::put_ShowConflictHistory(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x493, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
LPDISPATCH EXLWorkbook::get_Styles() {
  LPDISPATCH result;
  InvokeHelper(0x1ed, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
CString EXLWorkbook::get_Subject() {
  CString result;
  InvokeHelper(0x3b9, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::put_Subject(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x3b9, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
CString EXLWorkbook::get_Title() {
  CString result;
  InvokeHelper(0xc7, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::put_Title(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0xc7, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
void EXLWorkbook::Unprotect(VARIANT Password) {
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0x11d, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &Password);
}
void EXLWorkbook::UnprotectSharing(VARIANT SharingPassword) {
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0x5af, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &SharingPassword);
}
void EXLWorkbook::UpdateFromFile() {
  InvokeHelper(0x3e3, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void EXLWorkbook::UpdateLink(VARIANT Name, VARIANT Type) {
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x324, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &Name, &Type);
}
BOOL EXLWorkbook::get_UpdateRemoteReferences() {
  BOOL result;
  InvokeHelper(0x19b, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::put_UpdateRemoteReferences(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x19b, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL EXLWorkbook::get_UserControl() {
  BOOL result;
  InvokeHelper(0x4ba, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::put_UserControl(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x4ba, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
VARIANT EXLWorkbook::get_UserStatus() {
  VARIANT result;
  InvokeHelper(0x495, DISPATCH_PROPERTYGET, VT_VARIANT, (void*)&result, nullptr);
  return result;
}
LPDISPATCH EXLWorkbook::get_CustomViews() {
  LPDISPATCH result;
  InvokeHelper(0x5b0, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH EXLWorkbook::get_Windows() {
  LPDISPATCH result;
  InvokeHelper(0x1ae, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
EXLWorksheets EXLWorkbook::get_Worksheets() {
  LPDISPATCH result;
  InvokeHelper(0x1ee, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
BOOL EXLWorkbook::get_WriteReserved() {
  BOOL result;
  InvokeHelper(0x12b, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
CString EXLWorkbook::get_WriteReservedBy() {
  CString result;
  InvokeHelper(0x12c, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
LPDISPATCH EXLWorkbook::get_Excel4IntlMacroSheets() {
  LPDISPATCH result;
  InvokeHelper(0x245, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH EXLWorkbook::get_Excel4MacroSheets() {
  LPDISPATCH result;
  InvokeHelper(0x243, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
BOOL EXLWorkbook::get_TemplateRemoveExtData() {
  BOOL result;
  InvokeHelper(0x5b1, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::put_TemplateRemoveExtData(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x5b1, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
void EXLWorkbook::HighlightChangesOptions(VARIANT When, VARIANT Who, VARIANT Where) {
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x5b2, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &When, &Who, &Where);
}
BOOL EXLWorkbook::get_HighlightChangesOnScreen() {
  BOOL result;
  InvokeHelper(0x5b5, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::put_HighlightChangesOnScreen(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x5b5, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL EXLWorkbook::get_KeepChangeHistory() {
  BOOL result;
  InvokeHelper(0x5b6, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::put_KeepChangeHistory(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x5b6, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL EXLWorkbook::get_ListChangesOnNewSheet() {
  BOOL result;
  InvokeHelper(0x5b7, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::put_ListChangesOnNewSheet(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x5b7, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
void EXLWorkbook::PurgeChangeHistoryNow(long Days, VARIANT SharingPassword) {
  static BYTE parms[] = VTS_I4 VTS_VARIANT;
  InvokeHelper(0x5b8, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Days, &SharingPassword);
}
void EXLWorkbook::AcceptAllChanges(VARIANT When, VARIANT Who, VARIANT Where) {
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x5ba, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &When, &Who, &Where);
}
void EXLWorkbook::RejectAllChanges(VARIANT When, VARIANT Who, VARIANT Where) {
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x5bb, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &When, &Who, &Where);
}
void EXLWorkbook::PivotTableWizard(VARIANT SourceType, VARIANT DataStream, VARIANT TableDestination, VARIANT TableName, VARIANT RowGrand, VARIANT ColumnGrand, VARIANT SaveData, VARIANT HasAutoFormat, VARIANT AutoPage, VARIANT Reserved, VARIANT BackgroundQuery, VARIANT OptimizeCache, VARIANT PageFieldOrder, VARIANT PageFieldWrapCount, VARIANT ReadData, VARIANT Connection) {
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x2ac, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &SourceType, &DataStream, &TableDestination, &TableName, &RowGrand, &ColumnGrand, &SaveData, &HasAutoFormat, &AutoPage, &Reserved, &BackgroundQuery, &OptimizeCache, &PageFieldOrder, &PageFieldWrapCount, &ReadData, &Connection);
}
void EXLWorkbook::ResetColors() {
  InvokeHelper(0x5bc, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
LPDISPATCH EXLWorkbook::get_VBProject() {
  LPDISPATCH result;
  InvokeHelper(0x5bd, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::FollowHyperlink(LPCTSTR Address, VARIANT SubAddress, VARIANT NewWindow, VARIANT AddHistory, VARIANT ExtraInfo, VARIANT Method, VARIANT HeaderInfo) {
  static BYTE parms[] = VTS_BSTR VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x5be, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Address, &SubAddress, &NewWindow, &AddHistory, &ExtraInfo, &Method, &HeaderInfo);
}
void EXLWorkbook::AddToFavorites() {
  InvokeHelper(0x5c4, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
BOOL EXLWorkbook::get_IsInplace() {
  BOOL result;
  InvokeHelper(0x6e9, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::_PrintOut(VARIANT From, VARIANT To, VARIANT Copies, VARIANT Preview, VARIANT ActivePrinter, VARIANT PrintToFile, VARIANT Collate, VARIANT PrToFileName) {
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x6ec, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &From, &To, &Copies, &Preview, &ActivePrinter, &PrintToFile, &Collate, &PrToFileName);
}
void EXLWorkbook::WebPagePreview() {
  InvokeHelper(0x71a, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
LPDISPATCH EXLWorkbook::get_PublishObjects() {
  LPDISPATCH result;
  InvokeHelper(0x71b, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH EXLWorkbook::get_WebOptions() {
  LPDISPATCH result;
  InvokeHelper(0x71c, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::ReloadAs(long Encoding) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x71d, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Encoding);
}
LPDISPATCH EXLWorkbook::get_HTMLProject() {
  LPDISPATCH result;
  InvokeHelper(0x71f, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
BOOL EXLWorkbook::get_EnvelopeVisible() {
  BOOL result;
  InvokeHelper(0x720, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::put_EnvelopeVisible(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x720, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
long EXLWorkbook::get_CalculationVersion() {
  long result;
  InvokeHelper(0x70e, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::Dummy17(long calcid) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x7fc, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, calcid);
}
void EXLWorkbook::sblt(LPCTSTR s) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x722, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, s);
}
BOOL EXLWorkbook::get_VBASigned() {
  BOOL result;
  InvokeHelper(0x724, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
BOOL EXLWorkbook::get_ShowPivotTableFieldList() {
  BOOL result;
  InvokeHelper(0x7fe, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::put_ShowPivotTableFieldList(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x7fe, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
long EXLWorkbook::get_UpdateLinks() {
  long result;
  InvokeHelper(0x360, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::put_UpdateLinks(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x360, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
void EXLWorkbook::BreakLink(LPCTSTR Name, long Type) {
  static BYTE parms[] = VTS_BSTR VTS_I4;
  InvokeHelper(0x7ff, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Name, Type);
}
void EXLWorkbook::Dummy16() {
  InvokeHelper(0x800, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void EXLWorkbook::SaveAs(VARIANT Filename, VARIANT FileFormat, VARIANT Password,
                         VARIANT WriteResPassword, VARIANT ReadOnlyRecommended, VARIANT CreateBackup, long AccessMode,
                         VARIANT ConflictResolution, VARIANT AddToMru, VARIANT TextCodepage,
                         VARIANT TextVisualLayout, VARIANT Local) {
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_I4 VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x785, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &Filename, &FileFormat, &Password, &WriteResPassword,
               &ReadOnlyRecommended, &CreateBackup, &AccessMode, &ConflictResolution, &AddToMru, &TextCodepage, &TextVisualLayout, &Local);
}
BOOL EXLWorkbook::get_EnableAutoRecover() {
  BOOL result;
  InvokeHelper(0x801, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::put_EnableAutoRecover(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x801, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL EXLWorkbook::get_RemovePersonalInformation() {
  BOOL result;
  InvokeHelper(0x802, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::put_RemovePersonalInformation(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x802, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
CString EXLWorkbook::get_FullNameURLEncoded() {
  CString result;
  InvokeHelper(0x787, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::CheckIn(VARIANT SaveChanges, VARIANT Comments, VARIANT MakePublic) {
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x803, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &SaveChanges, &Comments, &MakePublic);
}
BOOL EXLWorkbook::CanCheckIn() {
  BOOL result;
  InvokeHelper(0x805, DISPATCH_METHOD, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::SendForReview(VARIANT Recipients, VARIANT Subject, VARIANT ShowMessage, VARIANT IncludeAttachment) {
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x806, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &Recipients, &Subject, &ShowMessage, &IncludeAttachment);
}
void EXLWorkbook::ReplyWithChanges(VARIANT ShowMessage) {
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0x809, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &ShowMessage);
}
void EXLWorkbook::EndReview() {
  InvokeHelper(0x80a, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
CString EXLWorkbook::get_Password() {
  CString result;
  InvokeHelper(0x1ad, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::put_Password(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x1ad, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
CString EXLWorkbook::get_WritePassword() {
  CString result;
  InvokeHelper(0x468, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::put_WritePassword(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x468, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
CString EXLWorkbook::get_PasswordEncryptionProvider() {
  CString result;
  InvokeHelper(0x80b, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
CString EXLWorkbook::get_PasswordEncryptionAlgorithm() {
  CString result;
  InvokeHelper(0x80c, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
long EXLWorkbook::get_PasswordEncryptionKeyLength() {
  long result;
  InvokeHelper(0x80d, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::SetPasswordEncryptionOptions(VARIANT PasswordEncryptionProvider, VARIANT PasswordEncryptionAlgorithm, VARIANT PasswordEncryptionKeyLength, VARIANT PasswordEncryptionFileProperties) {
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x80e, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &PasswordEncryptionProvider, &PasswordEncryptionAlgorithm, &PasswordEncryptionKeyLength, &PasswordEncryptionFileProperties);
}
BOOL EXLWorkbook::get_PasswordEncryptionFileProperties() {
  BOOL result;
  InvokeHelper(0x80f, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
BOOL EXLWorkbook::get_ReadOnlyRecommended() {
  BOOL result;
  InvokeHelper(0x7d5, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::put_ReadOnlyRecommended(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x7d5, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
void EXLWorkbook::Protect(VARIANT Password, VARIANT Structure, VARIANT Windows) {
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x7ed, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &Password, &Structure, &Windows);
}
LPDISPATCH EXLWorkbook::get_SmartTagOptions() {
  LPDISPATCH result;
  InvokeHelper(0x810, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::RecheckSmartTags() {
  InvokeHelper(0x811, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
LPDISPATCH EXLWorkbook::get_Permission() {
  LPDISPATCH result;
  InvokeHelper(0x8d8, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH EXLWorkbook::get_SharedWorkspace() {
  LPDISPATCH result;
  InvokeHelper(0x8d9, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH EXLWorkbook::get_Sync() {
  LPDISPATCH result;
  InvokeHelper(0x8da, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::SendFaxOverInternet(VARIANT Recipients, VARIANT Subject, VARIANT ShowMessage) {
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x8db, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &Recipients, &Subject, &ShowMessage);
}
LPDISPATCH EXLWorkbook::get_XmlNamespaces() {
  LPDISPATCH result;
  InvokeHelper(0x8dc, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH EXLWorkbook::get_XmlMaps() {
  LPDISPATCH result;
  InvokeHelper(0x8dd, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
long EXLWorkbook::XmlImport(LPCTSTR Url, LPDISPATCH* ImportMap, VARIANT Overwrite, VARIANT Destination) {
  long result;
  static BYTE parms[] = VTS_BSTR VTS_PDISPATCH VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x8de, DISPATCH_METHOD, VT_I4, (void*)&result, parms, Url, ImportMap, &Overwrite, &Destination);
  return result;
}
LPDISPATCH EXLWorkbook::get_SmartDocument() {
  LPDISPATCH result;
  InvokeHelper(0x8e1, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH EXLWorkbook::get_DocumentLibraryVersions() {
  LPDISPATCH result;
  InvokeHelper(0x8e2, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
BOOL EXLWorkbook::get_InactiveListBorderVisible() {
  BOOL result;
  InvokeHelper(0x8e3, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::put_InactiveListBorderVisible(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x8e3, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL EXLWorkbook::get_DisplayInkComments() {
  BOOL result;
  InvokeHelper(0x8e4, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::put_DisplayInkComments(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x8e4, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
long EXLWorkbook::XmlImportXml(LPCTSTR Data, LPDISPATCH* ImportMap, VARIANT Overwrite, VARIANT Destination) {
  long result;
  static BYTE parms[] = VTS_BSTR VTS_PDISPATCH VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x8e5, DISPATCH_METHOD, VT_I4, (void*)&result, parms, Data, ImportMap, &Overwrite, &Destination);
  return result;
}
void EXLWorkbook::SaveAsXMLData(LPCTSTR Filename, LPDISPATCH Map) {
  static BYTE parms[] = VTS_BSTR VTS_DISPATCH;
  InvokeHelper(0x8e6, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Filename, Map);
}
void EXLWorkbook::ToggleFormsDesign() {
  InvokeHelper(0x8e7, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
LPDISPATCH EXLWorkbook::get_ContentTypeProperties() {
  LPDISPATCH result;
  InvokeHelper(0x9d0, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH EXLWorkbook::get_Connections() {
  LPDISPATCH result;
  InvokeHelper(0x9d1, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::RemoveDocumentInformation(long RemoveDocInfoType) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x9d2, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, RemoveDocInfoType);
}
LPDISPATCH EXLWorkbook::get_Signatures() {
  LPDISPATCH result;
  InvokeHelper(0x9d4, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::CheckInWithVersion(VARIANT SaveChanges, VARIANT Comments, VARIANT MakePublic, VARIANT VersionType) {
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x9d5, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &SaveChanges, &Comments, &MakePublic, &VersionType);
}
LPDISPATCH EXLWorkbook::get_ServerPolicy() {
  LPDISPATCH result;
  InvokeHelper(0x9d7, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::LockServerFile() {
  InvokeHelper(0x9d8, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
LPDISPATCH EXLWorkbook::get_DocumentInspectors() {
  LPDISPATCH result;
  InvokeHelper(0x9d9, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH EXLWorkbook::GetWorkflowTasks() {
  LPDISPATCH result;
  InvokeHelper(0x9da, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH EXLWorkbook::GetWorkflowTemplates() {
  LPDISPATCH result;
  InvokeHelper(0x9db, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::PrintOut(VARIANT From, VARIANT To, VARIANT Copies, VARIANT Preview, VARIANT ActivePrinter, VARIANT PrintToFile, VARIANT Collate, VARIANT PrToFileName, VARIANT IgnorePrintAreas) {
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x939, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &From, &To, &Copies, &Preview, &ActivePrinter, &PrintToFile, &Collate, &PrToFileName, &IgnorePrintAreas);
}
LPDISPATCH EXLWorkbook::get_ServerViewableItems() {
  LPDISPATCH result;
  InvokeHelper(0x9dc, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH EXLWorkbook::get_TableStyles() {
  LPDISPATCH result;
  InvokeHelper(0x9dd, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
VARIANT EXLWorkbook::get_DefaultTableStyle() {
  VARIANT result;
  InvokeHelper(0x9de, DISPATCH_PROPERTYGET, VT_VARIANT, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::put_DefaultTableStyle(VARIANT newValue) {
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0x9de, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, &newValue);
}
VARIANT EXLWorkbook::get_DefaultPivotTableStyle() {
  VARIANT result;
  InvokeHelper(0x9df, DISPATCH_PROPERTYGET, VT_VARIANT, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::put_DefaultPivotTableStyle(VARIANT newValue) {
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0x9df, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, &newValue);
}
BOOL EXLWorkbook::get_CheckCompatibility() {
  BOOL result;
  InvokeHelper(0x9e0, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::put_CheckCompatibility(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x9e0, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL EXLWorkbook::get_HasVBProject() {
  BOOL result;
  InvokeHelper(0x9e1, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
LPDISPATCH EXLWorkbook::get_CustomXMLParts() {
  LPDISPATCH result;
  InvokeHelper(0x9e2, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
BOOL EXLWorkbook::get_Final() {
  BOOL result;
  InvokeHelper(0x9e3, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::put_Final(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x9e3, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
LPDISPATCH EXLWorkbook::get_Research() {
  LPDISPATCH result;
  InvokeHelper(0x9e4, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH EXLWorkbook::get_Theme() {
  LPDISPATCH result;
  InvokeHelper(0x9e5, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::ApplyTheme(LPCTSTR Filename) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x9e6, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Filename);
}
BOOL EXLWorkbook::get_Excel8CompatibilityMode() {
  BOOL result;
  InvokeHelper(0x9e7, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
BOOL EXLWorkbook::get_ConnectionsDisabled() {
  BOOL result;
  InvokeHelper(0x9e8, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::EnableConnections() {
  InvokeHelper(0x9e9, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
BOOL EXLWorkbook::get_ShowPivotChartActiveFields() {
  BOOL result;
  InvokeHelper(0x9ea, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::put_ShowPivotChartActiveFields(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x9ea, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
void EXLWorkbook::ExportAsFixedFormat(long Type, VARIANT Filename, VARIANT Quality, VARIANT IncludeDocProperties, VARIANT IgnorePrintAreas, VARIANT From, VARIANT To, VARIANT OpenAfterPublish, VARIANT FixedFormatExtClassPtr) {
  static BYTE parms[] = VTS_I4 VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x9bd, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Type, &Filename, &Quality, &IncludeDocProperties, &IgnorePrintAreas, &From, &To, &OpenAfterPublish, &FixedFormatExtClassPtr);
}
LPDISPATCH EXLWorkbook::get_IconSets() {
  LPDISPATCH result;
  InvokeHelper(0x9eb, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
CString EXLWorkbook::get_EncryptionProvider() {
  CString result;
  InvokeHelper(0x9ec, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::put_EncryptionProvider(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x9ec, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL EXLWorkbook::get_DoNotPromptForConvert() {
  BOOL result;
  InvokeHelper(0x9ed, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::put_DoNotPromptForConvert(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x9ed, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL EXLWorkbook::get_ForceFullCalculation() {
  BOOL result;
  InvokeHelper(0x9ee, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::put_ForceFullCalculation(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x9ee, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
void EXLWorkbook::ProtectSharing(VARIANT Filename, VARIANT Password, VARIANT WriteResPassword, VARIANT ReadOnlyRecommended, VARIANT CreateBackup, VARIANT SharingPassword, VARIANT FileFormat) {
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x9ef, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &Filename, &Password, &WriteResPassword, &ReadOnlyRecommended, &CreateBackup, &SharingPassword, &FileFormat);
}
LPDISPATCH EXLWorkbook::get_SlicerCaches() {
  LPDISPATCH result;
  InvokeHelper(0xb32, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH EXLWorkbook::get_ActiveSlicer() {
  LPDISPATCH result;
  InvokeHelper(0xb33, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
VARIANT EXLWorkbook::get_DefaultSlicerStyle() {
  VARIANT result;
  InvokeHelper(0xb34, DISPATCH_PROPERTYGET, VT_VARIANT, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::put_DefaultSlicerStyle(VARIANT newValue) {
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0xb34, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, &newValue);
}
void EXLWorkbook::Dummy26() {
  InvokeHelper(0xb35, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void EXLWorkbook::Dummy27() {
  InvokeHelper(0xb36, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
long EXLWorkbook::get_AccuracyVersion() {
  long result;
  InvokeHelper(0xb37, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::put_AccuracyVersion(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0xb37, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL EXLWorkbook::get_CaseSensitive() {
  BOOL result;
  InvokeHelper(0xbf0, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
BOOL EXLWorkbook::get_UseWholeCellCriteria() {
  BOOL result;
  InvokeHelper(0xbf1, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
BOOL EXLWorkbook::get_UseWildcards() {
  BOOL result;
  InvokeHelper(0xbf2, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
LPDISPATCH EXLWorkbook::get_PivotTables() {
  LPDISPATCH result;
  InvokeHelper(0x2b2, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH EXLWorkbook::get_Model() {
  LPDISPATCH result;
  InvokeHelper(0xbf3, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
BOOL EXLWorkbook::get_ChartDataPointTrack() {
  BOOL result;
  InvokeHelper(0xbb6, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::put_ChartDataPointTrack(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0xbb6, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
VARIANT EXLWorkbook::get_DefaultTimelineStyle() {
  VARIANT result;
  InvokeHelper(0xbf4, DISPATCH_PROPERTYGET, VT_VARIANT, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::put_DefaultTimelineStyle(VARIANT newValue) {
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0xbf4, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, &newValue);
}
LPDISPATCH EXLWorkbook::get_Queries() {
  LPDISPATCH result;
  InvokeHelper(0xc60, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
void EXLWorkbook::CreateForecastSheet(LPDISPATCH Timeline, LPDISPATCH Values, VARIANT ForecastStart, VARIANT ForecastEnd, VARIANT ConfInt, VARIANT Seasonality, VARIANT DataCompletion, VARIANT Aggregation, VARIANT ChartType, VARIANT ShowStatsTable) {
  static BYTE parms[] = VTS_DISPATCH VTS_DISPATCH VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0xc5f, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Timeline, Values, &ForecastStart, &ForecastEnd, &ConfInt, &Seasonality, &DataCompletion, &Aggregation, &ChartType, &ShowStatsTable);
}

} // namespace MSO::Excel

#pragma warning( pop )