#include "stdafx.h"

#include "office/excel/EXLWorksheet.h"

#include "office/excel/EXLRange.h"

#pragma warning( push )
#pragma warning( disable : 26493 26485 26494 )

namespace MSO::Excel {

LPDISPATCH EXLWorksheet::get_Application() {
  LPDISPATCH result;
  InvokeHelper(0x94, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
long EXLWorksheet::get_Creator() {
  long result;
  InvokeHelper(0x95, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
LPDISPATCH EXLWorksheet::get_Parent() {
  LPDISPATCH result;
  InvokeHelper(0x96, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
void EXLWorksheet::Activate() {
  InvokeHelper(0x130, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void EXLWorksheet::Copy(VARIANT Before, VARIANT After) {
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x227, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &Before, &After);
}
void EXLWorksheet::Delete() {
  InvokeHelper(0x75, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
CString EXLWorksheet::get_CodeName() {
  CString result;
  InvokeHelper(0x55d, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
CString EXLWorksheet::get__CodeName() {
  CString result;
  InvokeHelper(0x80010000, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
void EXLWorksheet::put__CodeName(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x80010000, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
long EXLWorksheet::get_Index() {
  long result;
  InvokeHelper(0x1e6, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void EXLWorksheet::Move(VARIANT Before, VARIANT After) {
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x27d, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &Before, &After);
}
CString EXLWorksheet::get_Name() {
  CString result;
  InvokeHelper(0x6e, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
void EXLWorksheet::put_Name(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x6e, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
LPDISPATCH EXLWorksheet::get_Next() {
  LPDISPATCH result;
  InvokeHelper(0x1f6, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
CString EXLWorksheet::get_OnDoubleClick() {
  CString result;
  InvokeHelper(0x274, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
void EXLWorksheet::put_OnDoubleClick(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x274, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
CString EXLWorksheet::get_OnSheetActivate() {
  CString result;
  InvokeHelper(0x407, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
void EXLWorksheet::put_OnSheetActivate(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x407, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
CString EXLWorksheet::get_OnSheetDeactivate() {
  CString result;
  InvokeHelper(0x439, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
void EXLWorksheet::put_OnSheetDeactivate(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x439, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
LPDISPATCH EXLWorksheet::get_PageSetup() {
  LPDISPATCH result;
  InvokeHelper(0x3e6, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH EXLWorksheet::get_Previous() {
  LPDISPATCH result;
  InvokeHelper(0x1f7, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
void EXLWorksheet::__PrintOut(VARIANT From, VARIANT To, VARIANT Copies, VARIANT Preview, VARIANT ActivePrinter, VARIANT PrintToFile, VARIANT Collate) {
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x389, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &From, &To, &Copies, &Preview, &ActivePrinter, &PrintToFile, &Collate);
}
void EXLWorksheet::PrintPreview(VARIANT EnableChanges) {
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0x119, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &EnableChanges);
}
void EXLWorksheet::_Protect(VARIANT Password, VARIANT DrawingObjects, VARIANT Contents, VARIANT Scenarios, VARIANT UserInterfaceOnly) {
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x11a, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &Password, &DrawingObjects, &Contents, &Scenarios, &UserInterfaceOnly);
}
BOOL EXLWorksheet::get_ProtectContents() {
  BOOL result;
  InvokeHelper(0x124, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
BOOL EXLWorksheet::get_ProtectDrawingObjects() {
  BOOL result;
  InvokeHelper(0x125, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
BOOL EXLWorksheet::get_ProtectionMode() {
  BOOL result;
  InvokeHelper(0x487, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
BOOL EXLWorksheet::get_ProtectScenarios() {
  BOOL result;
  InvokeHelper(0x126, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void EXLWorksheet::_SaveAs(LPCTSTR Filename, VARIANT FileFormat, VARIANT Password, VARIANT WriteResPassword, VARIANT ReadOnlyRecommended, VARIANT CreateBackup, VARIANT AddToMru, VARIANT TextCodepage, VARIANT TextVisualLayout) {
  static BYTE parms[] = VTS_BSTR VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x11c, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Filename, &FileFormat, &Password, &WriteResPassword, &ReadOnlyRecommended, &CreateBackup, &AddToMru, &TextCodepage, &TextVisualLayout);
}
void EXLWorksheet::Select(VARIANT Replace) {
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0xeb, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &Replace);
}
void EXLWorksheet::Unprotect(VARIANT Password) {
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0x11d, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &Password);
}
long EXLWorksheet::get_Visible() {
  long result;
  InvokeHelper(0x22e, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void EXLWorksheet::put_Visible(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x22e, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
LPDISPATCH EXLWorksheet::get_Shapes() {
  LPDISPATCH result;
  InvokeHelper(0x561, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
BOOL EXLWorksheet::get_TransitionExpEval() {
  BOOL result;
  InvokeHelper(0x191, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void EXLWorksheet::put_TransitionExpEval(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x191, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
LPDISPATCH EXLWorksheet::Arcs(VARIANT IndexType) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0x2f8, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, &IndexType);
  return result;
}
BOOL EXLWorksheet::get_AutoFilterMode() {
  BOOL result;
  InvokeHelper(0x318, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void EXLWorksheet::put_AutoFilterMode(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x318, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
void EXLWorksheet::SetBackgroundPicture(LPCTSTR Filename) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x4a4, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Filename);
}
LPDISPATCH EXLWorksheet::Buttons(VARIANT IndexType) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0x22d, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, &IndexType);
  return result;
}
void EXLWorksheet::Calculate() {
  InvokeHelper(0x117, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
BOOL EXLWorksheet::get_EnableCalculation() {
  BOOL result;
  InvokeHelper(0x590, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void EXLWorksheet::put_EnableCalculation(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x590, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
EXLRange EXLWorksheet::get_Cells() {
  LPDISPATCH result;
  InvokeHelper(0xee, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH EXLWorksheet::ChartObjects(VARIANT IndexType) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0x424, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, &IndexType);
  return result;
}
LPDISPATCH EXLWorksheet::CheckBoxes(VARIANT IndexType) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0x338, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, &IndexType);
  return result;
}
void EXLWorksheet::CheckSpelling(VARIANT CustomDictionary, VARIANT IgnoreUppercase, VARIANT AlwaysSuggest, VARIANT SpellLang) {
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x1f9, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &CustomDictionary, &IgnoreUppercase, &AlwaysSuggest, &SpellLang);
}
LPDISPATCH EXLWorksheet::get_CircularReference() {
  LPDISPATCH result;
  InvokeHelper(0x42d, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
void EXLWorksheet::ClearArrows() {
  InvokeHelper(0x3ca, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
EXLRange EXLWorksheet::get_Columns() {
  LPDISPATCH result;
  InvokeHelper(0xf1, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
long EXLWorksheet::get_ConsolidationFunction() {
  long result;
  InvokeHelper(0x315, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
VARIANT EXLWorksheet::get_ConsolidationOptions() {
  VARIANT result;
  InvokeHelper(0x316, DISPATCH_PROPERTYGET, VT_VARIANT, (void*)&result, nullptr);
  return result;
}
VARIANT EXLWorksheet::get_ConsolidationSources() {
  VARIANT result;
  InvokeHelper(0x317, DISPATCH_PROPERTYGET, VT_VARIANT, (void*)&result, nullptr);
  return result;
}
BOOL EXLWorksheet::get_DisplayAutomaticPageBreaks() {
  BOOL result;
  InvokeHelper(0x283, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void EXLWorksheet::put_DisplayAutomaticPageBreaks(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x283, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
LPDISPATCH EXLWorksheet::Drawings(VARIANT IndexType) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0x304, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, &IndexType);
  return result;
}
LPDISPATCH EXLWorksheet::DrawingObjects(VARIANT IndexType) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0x58, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, &IndexType);
  return result;
}
LPDISPATCH EXLWorksheet::DropDowns(VARIANT IndexType) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0x344, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, &IndexType);
  return result;
}
BOOL EXLWorksheet::get_EnableAutoFilter() {
  BOOL result;
  InvokeHelper(0x484, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void EXLWorksheet::put_EnableAutoFilter(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x484, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
long EXLWorksheet::get_EnableSelection() {
  long result;
  InvokeHelper(0x591, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void EXLWorksheet::put_EnableSelection(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x591, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL EXLWorksheet::get_EnableOutlining() {
  BOOL result;
  InvokeHelper(0x485, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void EXLWorksheet::put_EnableOutlining(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x485, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL EXLWorksheet::get_EnablePivotTable() {
  BOOL result;
  InvokeHelper(0x486, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void EXLWorksheet::put_EnablePivotTable(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x486, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
VARIANT EXLWorksheet::Evaluate(VARIANT Name) {
  VARIANT result;
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0x1, DISPATCH_METHOD, VT_VARIANT, (void*)&result, parms, &Name);
  return result;
}
VARIANT EXLWorksheet::_Evaluate(VARIANT Name) {
  VARIANT result;
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0xfffffffb, DISPATCH_METHOD, VT_VARIANT, (void*)&result, parms, &Name);
  return result;
}
BOOL EXLWorksheet::get_FilterMode() {
  BOOL result;
  InvokeHelper(0x320, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void EXLWorksheet::ResetAllPageBreaks() {
  InvokeHelper(0x592, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
LPDISPATCH EXLWorksheet::GroupBoxes(VARIANT IndexType) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0x342, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, &IndexType);
  return result;
}
LPDISPATCH EXLWorksheet::GroupObjects(VARIANT IndexType) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0x459, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, &IndexType);
  return result;
}
LPDISPATCH EXLWorksheet::Labels(VARIANT IndexType) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0x349, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, &IndexType);
  return result;
}
LPDISPATCH EXLWorksheet::Lines(VARIANT IndexType) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0x2ff, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, &IndexType);
  return result;
}
LPDISPATCH EXLWorksheet::ListBoxes(VARIANT IndexType) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0x340, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, &IndexType);
  return result;
}
LPDISPATCH EXLWorksheet::get_Names() {
  LPDISPATCH result;
  InvokeHelper(0x1ba, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH EXLWorksheet::OLEObjects(VARIANT IndexType) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0x31f, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, &IndexType);
  return result;
}
CString EXLWorksheet::get_OnCalculate() {
  CString result;
  InvokeHelper(0x271, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
void EXLWorksheet::put_OnCalculate(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x271, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
CString EXLWorksheet::get_OnData() {
  CString result;
  InvokeHelper(0x275, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
void EXLWorksheet::put_OnData(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x275, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
CString EXLWorksheet::get_OnEntry() {
  CString result;
  InvokeHelper(0x273, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
void EXLWorksheet::put_OnEntry(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x273, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
LPDISPATCH EXLWorksheet::OptionButtons(VARIANT IndexType) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0x33a, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, &IndexType);
  return result;
}
LPDISPATCH EXLWorksheet::get_Outline() {
  LPDISPATCH result;
  InvokeHelper(0x66, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH EXLWorksheet::Ovals(VARIANT IndexType) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0x321, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, &IndexType);
  return result;
}
void EXLWorksheet::Paste(VARIANT Destination, VARIANT Link) {
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0xd3, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &Destination, &Link);
}
void EXLWorksheet::_PasteSpecial(VARIANT Format, VARIANT Link, VARIANT DisplayAsIcon, VARIANT IconFileName, VARIANT IconIndex, VARIANT IconLabel) {
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x403, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &Format, &Link, &DisplayAsIcon, &IconFileName, &IconIndex, &IconLabel);
}
LPDISPATCH EXLWorksheet::Pictures(VARIANT IndexType) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0x303, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, &IndexType);
  return result;
}
LPDISPATCH EXLWorksheet::PivotTables(VARIANT IndexType) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0x2b2, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, &IndexType);
  return result;
}
LPDISPATCH EXLWorksheet::PivotTableWizard(VARIANT SourceType, VARIANT DataStream, VARIANT TableDestination, VARIANT TableName, VARIANT RowGrand, VARIANT ColumnGrand, VARIANT SaveData, VARIANT HasAutoFormat, VARIANT AutoPage, VARIANT Reserved, VARIANT BackgroundQuery, VARIANT OptimizeCache, VARIANT PageFieldOrder, VARIANT PageFieldWrapCount, VARIANT ReadData, VARIANT Connection) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x2ac, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, &SourceType, &DataStream, &TableDestination, &TableName, &RowGrand, &ColumnGrand, &SaveData, &HasAutoFormat, &AutoPage, &Reserved, &BackgroundQuery, &OptimizeCache, &PageFieldOrder, &PageFieldWrapCount, &ReadData, &Connection);
  return result;
}
LPDISPATCH EXLWorksheet::get_Range(VARIANT Cell1, VARIANT Cell2) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0xc5, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, parms, &Cell1, &Cell2);
  return result;
}
LPDISPATCH EXLWorksheet::Rectangles(VARIANT IndexType) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0x306, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, &IndexType);
  return result;
}
EXLRange EXLWorksheet::get_Rows() {
  LPDISPATCH result;
  InvokeHelper(0x102, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH EXLWorksheet::Scenarios(VARIANT IndexType) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0x38c, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, &IndexType);
  return result;
}
CString EXLWorksheet::get_ScrollArea() {
  CString result;
  InvokeHelper(0x599, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
void EXLWorksheet::put_ScrollArea(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x599, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
LPDISPATCH EXLWorksheet::ScrollBars(VARIANT IndexType) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0x33e, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, &IndexType);
  return result;
}
void EXLWorksheet::ShowAllData() {
  InvokeHelper(0x31a, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void EXLWorksheet::ShowDataForm() {
  InvokeHelper(0x199, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
LPDISPATCH EXLWorksheet::Spinners(VARIANT IndexType) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0x346, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, &IndexType);
  return result;
}
double EXLWorksheet::get_StandardHeight() {
  double result;
  InvokeHelper(0x197, DISPATCH_PROPERTYGET, VT_R8, (void*)&result, nullptr);
  return result;
}
double EXLWorksheet::get_StandardWidth() {
  double result;
  InvokeHelper(0x198, DISPATCH_PROPERTYGET, VT_R8, (void*)&result, nullptr);
  return result;
}
void EXLWorksheet::put_StandardWidth(double newValue) {
  static BYTE parms[] = VTS_R8;
  InvokeHelper(0x198, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
LPDISPATCH EXLWorksheet::TextBoxes(VARIANT IndexType) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0x309, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, &IndexType);
  return result;
}
BOOL EXLWorksheet::get_TransitionFormEntry() {
  BOOL result;
  InvokeHelper(0x192, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void EXLWorksheet::put_TransitionFormEntry(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x192, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
long EXLWorksheet::get_Type() {
  long result;
  InvokeHelper(0x6c, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
EXLRange EXLWorksheet::get_UsedRange() {
  LPDISPATCH result;
  InvokeHelper(0x19c, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH EXLWorksheet::get_HPageBreaks() {
  LPDISPATCH result;
  InvokeHelper(0x58a, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH EXLWorksheet::get_VPageBreaks() {
  LPDISPATCH result;
  InvokeHelper(0x58b, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH EXLWorksheet::get_QueryTables() {
  LPDISPATCH result;
  InvokeHelper(0x59a, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
BOOL EXLWorksheet::get_DisplayPageBreaks() {
  BOOL result;
  InvokeHelper(0x59b, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void EXLWorksheet::put_DisplayPageBreaks(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x59b, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
LPDISPATCH EXLWorksheet::get_Comments() {
  LPDISPATCH result;
  InvokeHelper(0x23f, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH EXLWorksheet::get_Hyperlinks() {
  LPDISPATCH result;
  InvokeHelper(0x571, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
void EXLWorksheet::ClearCircles() {
  InvokeHelper(0x59c, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void EXLWorksheet::CircleInvalid() {
  InvokeHelper(0x59d, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
long EXLWorksheet::get__DisplayRightToLeft() {
  long result;
  InvokeHelper(0x288, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void EXLWorksheet::put__DisplayRightToLeft(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x288, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
LPDISPATCH EXLWorksheet::get_AutoFilter() {
  LPDISPATCH result;
  InvokeHelper(0x319, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
BOOL EXLWorksheet::get_DisplayRightToLeft() {
  BOOL result;
  InvokeHelper(0x6ee, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void EXLWorksheet::put_DisplayRightToLeft(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x6ee, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
LPDISPATCH EXLWorksheet::get_Scripts() {
  LPDISPATCH result;
  InvokeHelper(0x718, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
void EXLWorksheet::_PrintOut(VARIANT From, VARIANT To, VARIANT Copies, VARIANT Preview, VARIANT ActivePrinter, VARIANT PrintToFile, VARIANT Collate, VARIANT PrToFileName) {
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x6ec, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &From, &To, &Copies, &Preview, &ActivePrinter, &PrintToFile, &Collate, &PrToFileName);
}
void EXLWorksheet::_CheckSpelling(VARIANT CustomDictionary, VARIANT IgnoreUppercase, VARIANT AlwaysSuggest, VARIANT SpellLang, VARIANT IgnoreFinalYaa, VARIANT SpellScript) {
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x719, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &CustomDictionary, &IgnoreUppercase, &AlwaysSuggest, &SpellLang, &IgnoreFinalYaa, &SpellScript);
}
LPDISPATCH EXLWorksheet::get_Tab() {
  LPDISPATCH result;
  InvokeHelper(0x411, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH EXLWorksheet::get_MailEnvelope() {
  LPDISPATCH result;
  InvokeHelper(0x7e5, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
void EXLWorksheet::SaveAs(LPCTSTR Filename, VARIANT FileFormat, VARIANT Password, VARIANT WriteResPassword, VARIANT ReadOnlyRecommended, VARIANT CreateBackup, VARIANT AddToMru, VARIANT TextCodepage, VARIANT TextVisualLayout, VARIANT Local) {
  static BYTE parms[] = VTS_BSTR VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x785, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Filename, &FileFormat, &Password, &WriteResPassword, &ReadOnlyRecommended, &CreateBackup, &AddToMru, &TextCodepage, &TextVisualLayout, &Local);
}
LPDISPATCH EXLWorksheet::get_CustomProperties() {
  LPDISPATCH result;
  InvokeHelper(0x7ee, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH EXLWorksheet::get_SmartTags() {
  LPDISPATCH result;
  InvokeHelper(0x7e0, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH EXLWorksheet::get_Protection() {
  LPDISPATCH result;
  InvokeHelper(0xb0, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
void EXLWorksheet::PasteSpecial(VARIANT Format, VARIANT Link, VARIANT DisplayAsIcon, VARIANT IconFileName, VARIANT IconIndex, VARIANT IconLabel, VARIANT NoHTMLFormatting) {
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x788, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &Format, &Link, &DisplayAsIcon, &IconFileName, &IconIndex, &IconLabel, &NoHTMLFormatting);
}
void EXLWorksheet::Protect(VARIANT Password, VARIANT DrawingObjects, VARIANT Contents, VARIANT Scenarios, VARIANT UserInterfaceOnly, VARIANT AllowFormattingCells, VARIANT AllowFormattingColumns, VARIANT AllowFormattingRows, VARIANT AllowInsertingColumns, VARIANT AllowInsertingRows, VARIANT AllowInsertingHyperlinks, VARIANT AllowDeletingColumns, VARIANT AllowDeletingRows, VARIANT AllowSorting, VARIANT AllowFiltering, VARIANT AllowUsingPivotTables) {
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x7ed, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &Password, &DrawingObjects, &Contents, &Scenarios, &UserInterfaceOnly, &AllowFormattingCells, &AllowFormattingColumns, &AllowFormattingRows, &AllowInsertingColumns, &AllowInsertingRows, &AllowInsertingHyperlinks, &AllowDeletingColumns, &AllowDeletingRows, &AllowSorting, &AllowFiltering, &AllowUsingPivotTables);
}
LPDISPATCH EXLWorksheet::get_ListObjects() {
  LPDISPATCH result;
  InvokeHelper(0x8d3, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH EXLWorksheet::XmlDataQuery(LPCTSTR XPath, VARIANT SelectionNamespaces, VARIANT Map) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_BSTR VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x8d4, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, XPath, &SelectionNamespaces, &Map);
  return result;
}
LPDISPATCH EXLWorksheet::XmlMapQuery(LPCTSTR XPath, VARIANT SelectionNamespaces, VARIANT Map) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_BSTR VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x8d7, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, XPath, &SelectionNamespaces, &Map);
  return result;
}
void EXLWorksheet::PrintOut(VARIANT From, VARIANT To, VARIANT Copies, VARIANT Preview, VARIANT ActivePrinter, VARIANT PrintToFile, VARIANT Collate, VARIANT PrToFileName, VARIANT IgnorePrintAreas) {
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x939, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &From, &To, &Copies, &Preview, &ActivePrinter, &PrintToFile, &Collate, &PrToFileName, &IgnorePrintAreas);
}
BOOL EXLWorksheet::get_EnableFormatConditionsCalculation() {
  BOOL result;
  InvokeHelper(0x9cf, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void EXLWorksheet::put_EnableFormatConditionsCalculation(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x9cf, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
LPDISPATCH EXLWorksheet::get_Sort() {
  LPDISPATCH result;
  InvokeHelper(0x370, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
void EXLWorksheet::ExportAsFixedFormat(long Type, VARIANT Filename, VARIANT Quality, VARIANT IncludeDocProperties, VARIANT IgnorePrintAreas, VARIANT From, VARIANT To, VARIANT OpenAfterPublish, VARIANT FixedFormatExtClassPtr) {
  static BYTE parms[] = VTS_I4 VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x9bd, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Type, &Filename, &Quality, &IncludeDocProperties, &IgnorePrintAreas, &From, &To, &OpenAfterPublish, &FixedFormatExtClassPtr);
}
long EXLWorksheet::get_PrintedCommentPages() {
  long result;
  InvokeHelper(0xb29, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

} // namespace MSO::Excel

#pragma warning( pop )