#include "stdafx.h"

#include "office/excel/EXLWorksheets.h"

#include "office/excel/EXLWorksheet.h"

#pragma warning( push )
#pragma warning( disable : 26493 26485 26494 )

namespace MSO::Excel {

LPDISPATCH EXLWorksheets::get_Application() {
  LPDISPATCH result;
  InvokeHelper(0x94, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

long EXLWorksheets::get_Creator() {
  long result;
  InvokeHelper(0x95, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

LPDISPATCH EXLWorksheets::get_Parent() {
  LPDISPATCH result;
  InvokeHelper(0x96, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

EXLWorksheet EXLWorksheets::Add(const EXLWorksheet& Before, const EXLWorksheet& After, VARIANT Count, VARIANT Type) {
  VARIANT vBefore(Before);
  VARIANT vAfter(After);
  LPDISPATCH result;
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0xb5, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, &vBefore, &vAfter, &Count, &Type);
  return result;
}

void EXLWorksheets::Copy(const EXLWorksheet& Before, const EXLWorksheet& After) {
  VARIANT vBefore(Before);
  VARIANT vAfter(After);
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x227, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &vBefore, &vAfter);
}
EXLWorksheets::size_type EXLWorksheets::get_Count() {
  long result;
  InvokeHelper(0x76, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void EXLWorksheets::Delete() {
  InvokeHelper(0x75, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void EXLWorksheets::FillAcrossSheets(LPDISPATCH Range, long Type) {
  static BYTE parms[] = VTS_DISPATCH VTS_I4;
  InvokeHelper(0x1d5, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Range, Type);
}
EXLWorksheet EXLWorksheets::get_Item(VARIANT IndexType) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0xaa, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, parms, &IndexType);
  return result;
}
void EXLWorksheets::Move(const EXLWorksheet& Before, const EXLWorksheet& After) {
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x27d, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &Before, &After);
}
LPUNKNOWN EXLWorksheets::get_NewEnum() {
  LPUNKNOWN result;
  InvokeHelper(0xfffffffc, DISPATCH_PROPERTYGET, VT_UNKNOWN, (void*)&result, nullptr);
  return result;
}
void EXLWorksheets::__PrintOut(VARIANT From, VARIANT To, VARIANT Copies, VARIANT Preview, VARIANT ActivePrinter, VARIANT PrintToFile, VARIANT Collate) {
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x389, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &From, &To, &Copies, &Preview, &ActivePrinter, &PrintToFile, &Collate);
}
void EXLWorksheets::PrintPreview(VARIANT EnableChanges) {
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0x119, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &EnableChanges);
}
void EXLWorksheets::Select(VARIANT Replace) {
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0xeb, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &Replace);
}
LPDISPATCH EXLWorksheets::get_HPageBreaks() {
  LPDISPATCH result;
  InvokeHelper(0x58a, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH EXLWorksheets::get_VPageBreaks() {
  LPDISPATCH result;
  InvokeHelper(0x58b, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
VARIANT EXLWorksheets::get_Visible() {
  VARIANT result;
  InvokeHelper(0x22e, DISPATCH_PROPERTYGET, VT_VARIANT, (void*)&result, nullptr);
  return result;
}
void EXLWorksheets::put_Visible(VARIANT newValue) {
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0x22e, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, &newValue);
}
LPDISPATCH EXLWorksheets::get__Default(VARIANT IndexType) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0x0, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, parms, &IndexType);
  return result;
}
void EXLWorksheets::_PrintOut(VARIANT From, VARIANT To, VARIANT Copies, VARIANT Preview, VARIANT ActivePrinter, VARIANT PrintToFile, VARIANT Collate, VARIANT PrToFileName) {
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x6ec, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &From, &To, &Copies, &Preview, &ActivePrinter, &PrintToFile, &Collate, &PrToFileName);
}
void EXLWorksheets::PrintOut(VARIANT From, VARIANT To, VARIANT Copies, VARIANT Preview, VARIANT ActivePrinter, VARIANT PrintToFile, VARIANT Collate, VARIANT PrToFileName, VARIANT IgnorePrintAreas) {
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x939, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &From, &To, &Copies, &Preview, &ActivePrinter, &PrintToFile, &Collate, &PrToFileName, &IgnorePrintAreas);
}

EXLWorksheet EXLWorksheets::Add2(const EXLWorksheet& Before, const EXLWorksheet& After, VARIANT Count, VARIANT NewLayout) {
  VARIANT vBefore(Before);
  VARIANT vAfter(After);
  LPDISPATCH result;
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0xbee, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, &vBefore, &vAfter, &Count, &NewLayout);
  return result;
}

} // namespace MSO::Excel

#pragma warning( pop )