#include "stdafx.h"

#include "office/word/WApplication.h"

#pragma warning( push )
#pragma warning( disable : 26493 26485 26494 )

namespace MSO::Word {

WApplication WApplication::get_Application() {
  LPDISPATCH result;
  InvokeHelper(0x3e8, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
long WApplication::get_Creator() {
  long result;
  InvokeHelper(0x3e9, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WApplication::get_Parent() {
  LPDISPATCH result;
  InvokeHelper(0x3ea, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
CString WApplication::get_Name() {
  CString result;
  InvokeHelper(0x0, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WApplication::get_Documents() {
  LPDISPATCH result;
  InvokeHelper(0x6, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WApplication::get_Windows() {
  LPDISPATCH result;
  InvokeHelper(0x2, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WApplication::get_ActiveDocument() {
  LPDISPATCH result;
  InvokeHelper(0x3, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WApplication::get_ActiveWindow() {
  LPDISPATCH result;
  InvokeHelper(0x4, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WApplication::get_Selection() {
  LPDISPATCH result;
  InvokeHelper(0x5, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WApplication::get_WordBasic() {
  LPDISPATCH result;
  InvokeHelper(0x1, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WApplication::get_RecentFiles() {
  LPDISPATCH result;
  InvokeHelper(0x7, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WApplication::get_NormalTemplate() {
  LPDISPATCH result;
  InvokeHelper(0x8, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WApplication::get_System() {
  LPDISPATCH result;
  InvokeHelper(0x9, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WApplication::get_AutoCorrect() {
  LPDISPATCH result;
  InvokeHelper(0xa, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WApplication::get_FontNames() {
  LPDISPATCH result;
  InvokeHelper(0xb, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WApplication::get_LandscapeFontNames() {
  LPDISPATCH result;
  InvokeHelper(0xc, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WApplication::get_PortraitFontNames() {
  LPDISPATCH result;
  InvokeHelper(0xd, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WApplication::get_Languages() {
  LPDISPATCH result;
  InvokeHelper(0xe, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WApplication::get_Assistant() {
  LPDISPATCH result;
  InvokeHelper(0xf, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WApplication::get_Browser() {
  LPDISPATCH result;
  InvokeHelper(0x10, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WApplication::get_FileConverters() {
  LPDISPATCH result;
  InvokeHelper(0x11, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WApplication::get_MailingLabel() {
  LPDISPATCH result;
  InvokeHelper(0x12, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WApplication::get_Dialogs() {
  LPDISPATCH result;
  InvokeHelper(0x13, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WApplication::get_CaptionLabels() {
  LPDISPATCH result;
  InvokeHelper(0x14, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WApplication::get_AutoCaptions() {
  LPDISPATCH result;
  InvokeHelper(0x15, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WApplication::get_AddIns() {
  LPDISPATCH result;
  InvokeHelper(0x16, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
BOOL WApplication::get_Visible() {
  BOOL result;
  InvokeHelper(0x17, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WApplication::put_Visible(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x17, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
CString WApplication::get_Version() {
  CString result;
  InvokeHelper(0x18, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
BOOL WApplication::get_ScreenUpdating() {
  BOOL result;
  InvokeHelper(0x1a, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WApplication::put_ScreenUpdating(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x1a, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WApplication::get_PrintPreview() {
  BOOL result;
  InvokeHelper(0x1b, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WApplication::put_PrintPreview(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x1b, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
LPDISPATCH WApplication::get_Tasks() {
  LPDISPATCH result;
  InvokeHelper(0x1c, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
BOOL WApplication::get_DisplayStatusBar() {
  BOOL result;
  InvokeHelper(0x1d, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WApplication::put_DisplayStatusBar(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x1d, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WApplication::get_SpecialMode() {
  BOOL result;
  InvokeHelper(0x1e, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
long WApplication::get_UsableWidth() {
  long result;
  InvokeHelper(0x21, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
long WApplication::get_UsableHeight() {
  long result;
  InvokeHelper(0x22, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
BOOL WApplication::get_MathCoprocessorAvailable() {
  BOOL result;
  InvokeHelper(0x24, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
BOOL WApplication::get_MouseAvailable() {
  BOOL result;
  InvokeHelper(0x25, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
VARIANT WApplication::get_International(long IndexType) {
  VARIANT result;
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x2e, DISPATCH_PROPERTYGET, VT_VARIANT, (void*)&result, parms, IndexType);
  return result;
}
CString WApplication::get_Build() {
  CString result;
  InvokeHelper(0x2f, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
BOOL WApplication::get_CapsLock() {
  BOOL result;
  InvokeHelper(0x30, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
BOOL WApplication::get_NumLock() {
  BOOL result;
  InvokeHelper(0x31, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
CString WApplication::get_UserName() {
  CString result;
  InvokeHelper(0x34, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
void WApplication::put_UserName(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x34, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
CString WApplication::get_UserInitials() {
  CString result;
  InvokeHelper(0x35, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
void WApplication::put_UserInitials(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x35, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
CString WApplication::get_UserAddress() {
  CString result;
  InvokeHelper(0x36, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
void WApplication::put_UserAddress(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x36, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
LPDISPATCH WApplication::get_MacroContainer() {
  LPDISPATCH result;
  InvokeHelper(0x37, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
BOOL WApplication::get_DisplayRecentFiles() {
  BOOL result;
  InvokeHelper(0x38, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WApplication::put_DisplayRecentFiles(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x38, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
LPDISPATCH WApplication::get_CommandBars() {
  LPDISPATCH result;
  InvokeHelper(0x39, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WApplication::get_SynonymInfo(LPCTSTR MSWord, VARIANT * LanguageID) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_BSTR VTS_PVARIANT;
  InvokeHelper(0x3b, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, parms, MSWord, LanguageID);
  return result;
}
LPDISPATCH WApplication::get_VBE() {
  LPDISPATCH result;
  InvokeHelper(0x3d, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
CString WApplication::get_DefaultSaveFormat() {
  CString result;
  InvokeHelper(0x40, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
void WApplication::put_DefaultSaveFormat(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x40, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
LPDISPATCH WApplication::get_ListGalleries() {
  LPDISPATCH result;
  InvokeHelper(0x41, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
CString WApplication::get_ActivePrinter() {
  CString result;
  InvokeHelper(0x42, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
void WApplication::put_ActivePrinter(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x42, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
LPDISPATCH WApplication::get_Templates() {
  LPDISPATCH result;
  InvokeHelper(0x43, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WApplication::get_CustomizationContext() {
  LPDISPATCH result;
  InvokeHelper(0x44, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
void WApplication::put_CustomizationContext(LPDISPATCH newValue) {
  static BYTE parms[] = VTS_DISPATCH;
  InvokeHelper(0x44, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
LPDISPATCH WApplication::get_KeyBindings() {
  LPDISPATCH result;
  InvokeHelper(0x45, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WApplication::get_KeysBoundTo(long KeyCategory, LPCTSTR Command, VARIANT * CommandParameter) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_I4 VTS_BSTR VTS_PVARIANT;
  InvokeHelper(0x46, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, parms, KeyCategory, Command, CommandParameter);
  return result;
}
LPDISPATCH WApplication::get_FindKey(long KeyCode, VARIANT * KeyCode2) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_I4 VTS_PVARIANT;
  InvokeHelper(0x47, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, parms, KeyCode, KeyCode2);
  return result;
}
CString WApplication::get_Caption() {
  CString result;
  InvokeHelper(0x50, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
void WApplication::put_Caption(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x50, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
CString WApplication::get_Path() {
  CString result;
  InvokeHelper(0x51, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
BOOL WApplication::get_DisplayScrollBars() {
  BOOL result;
  InvokeHelper(0x52, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WApplication::put_DisplayScrollBars(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x52, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
CString WApplication::get_StartupPath() {
  CString result;
  InvokeHelper(0x53, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
void WApplication::put_StartupPath(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x53, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
long WApplication::get_BackgroundSavingStatus() {
  long result;
  InvokeHelper(0x55, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
long WApplication::get_BackgroundPrintingStatus() {
  long result;
  InvokeHelper(0x56, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
long WApplication::get_Left() {
  long result;
  InvokeHelper(0x57, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void WApplication::put_Left(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x57, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
long WApplication::get_Top() {
  long result;
  InvokeHelper(0x58, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void WApplication::put_Top(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x58, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
long WApplication::get_Width() {
  long result;
  InvokeHelper(0x59, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void WApplication::put_Width(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x59, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
long WApplication::get_Height() {
  long result;
  InvokeHelper(0x5a, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void WApplication::put_Height(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x5a, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
long WApplication::get_WindowState() {
  long result;
  InvokeHelper(0x5b, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void WApplication::put_WindowState(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x5b, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WApplication::get_DisplayAutoCompleteTips() {
  BOOL result;
  InvokeHelper(0x5c, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WApplication::put_DisplayAutoCompleteTips(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x5c, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
LPDISPATCH WApplication::get_Options() {
  LPDISPATCH result;
  InvokeHelper(0x5d, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
long WApplication::get_DisplayAlerts() {
  long result;
  InvokeHelper(0x5e, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void WApplication::put_DisplayAlerts(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x5e, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
LPDISPATCH WApplication::get_CustomDictionaries() {
  LPDISPATCH result;
  InvokeHelper(0x5f, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
CString WApplication::get_PathSeparator() {
  CString result;
  InvokeHelper(0x60, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
void WApplication::put_StatusBar(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x61, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WApplication::get_MAPIAvailable() {
  BOOL result;
  InvokeHelper(0x62, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
BOOL WApplication::get_DisplayScreenTips() {
  BOOL result;
  InvokeHelper(0x63, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WApplication::put_DisplayScreenTips(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x63, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
long WApplication::get_EnableCancelKey() {
  long result;
  InvokeHelper(0x64, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void WApplication::put_EnableCancelKey(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x64, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WApplication::get_UserControl() {
  BOOL result;
  InvokeHelper(0x65, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WApplication::get_FileSearch() {
  LPDISPATCH result;
  InvokeHelper(0x67, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
long WApplication::get_MailSystem() {
  long result;
  InvokeHelper(0x68, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
CString WApplication::get_DefaultTableSeparator() {
  CString result;
  InvokeHelper(0x69, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
void WApplication::put_DefaultTableSeparator(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x69, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WApplication::get_ShowVisualBasicEditor() {
  BOOL result;
  InvokeHelper(0x6a, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WApplication::put_ShowVisualBasicEditor(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x6a, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
CString WApplication::get_BrowseExtraFileTypes() {
  CString result;
  InvokeHelper(0x6c, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
void WApplication::put_BrowseExtraFileTypes(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x6c, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WApplication::get_IsObjectValid(LPDISPATCH Object) {
  BOOL result;
  static BYTE parms[] = VTS_DISPATCH;
  InvokeHelper(0x6d, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, parms, Object);
  return result;
}
LPDISPATCH WApplication::get_HangulHanjaDictionaries() {
  LPDISPATCH result;
  InvokeHelper(0x6e, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WApplication::get_MailMessage() {
  LPDISPATCH result;
  InvokeHelper(0x15c, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
BOOL WApplication::get_FocusInMailHeader() {
  BOOL result;
  InvokeHelper(0x182, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WApplication::Quit(VARIANT * SaveChanges, VARIANT * OriginalFormat, VARIANT * RouteDocument) {
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x451, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, SaveChanges, OriginalFormat, RouteDocument);
}
void WApplication::ScreenRefresh() {
  InvokeHelper(0x12d, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WApplication::PrintOutOld(VARIANT * Background, VARIANT * Append, VARIANT * Range, VARIANT * OutputFileName, VARIANT * From, VARIANT * To, VARIANT * Item, VARIANT * Copies, VARIANT * Pages, VARIANT * PageType, VARIANT * PrintToFile, VARIANT * Collate, VARIANT * FileName, VARIANT * ActivePrinterMacGX, VARIANT * ManualDuplexPrint) {
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x12e, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Background, Append, Range, OutputFileName, From, To, Item, Copies, Pages, PageType, PrintToFile, Collate, FileName, ActivePrinterMacGX, ManualDuplexPrint);
}
void WApplication::LookupNameProperties(LPCTSTR Name) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x12f, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Name);
}
void WApplication::SubstituteFont(LPCTSTR UnavailableFont, LPCTSTR SubstituteFont) {
  static BYTE parms[] = VTS_BSTR VTS_BSTR;
  InvokeHelper(0x130, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, UnavailableFont, SubstituteFont);
}
BOOL WApplication::Repeat(VARIANT * Times) {
  BOOL result;
  static BYTE parms[] = VTS_PVARIANT;
  InvokeHelper(0x131, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms, Times);
  return result;
}
void WApplication::DDEExecute(long Channel, LPCTSTR Command) {
  static BYTE parms[] = VTS_I4 VTS_BSTR;
  InvokeHelper(0x136, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Channel, Command);
}
long WApplication::DDEInitiate(LPCTSTR App, LPCTSTR Topic) {
  long result;
  static BYTE parms[] = VTS_BSTR VTS_BSTR;
  InvokeHelper(0x137, DISPATCH_METHOD, VT_I4, (void*)&result, parms, App, Topic);
  return result;
}
void WApplication::DDEPoke(long Channel, LPCTSTR Item, LPCTSTR Data) {
  static BYTE parms[] = VTS_I4 VTS_BSTR VTS_BSTR;
  InvokeHelper(0x138, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Channel, Item, Data);
}
CString WApplication::DDERequest(long Channel, LPCTSTR Item) {
  CString result;
  static BYTE parms[] = VTS_I4 VTS_BSTR;
  InvokeHelper(0x139, DISPATCH_METHOD, VT_BSTR, (void*)&result, parms, Channel, Item);
  return result;
}
void WApplication::DDETerminate(long Channel) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x13a, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Channel);
}
void WApplication::DDETerminateAll() {
  InvokeHelper(0x13b, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
long WApplication::BuildKeyCode(long Arg1, VARIANT * Arg2, VARIANT * Arg3, VARIANT * Arg4) {
  long result;
  static BYTE parms[] = VTS_I4 VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x13c, DISPATCH_METHOD, VT_I4, (void*)&result, parms, Arg1, Arg2, Arg3, Arg4);
  return result;
}
CString WApplication::KeyString(long KeyCode, VARIANT * KeyCode2) {
  CString result;
  static BYTE parms[] = VTS_I4 VTS_PVARIANT;
  InvokeHelper(0x13d, DISPATCH_METHOD, VT_BSTR, (void*)&result, parms, KeyCode, KeyCode2);
  return result;
}
void WApplication::OrganizerCopy(LPCTSTR src, LPCTSTR Destination, LPCTSTR Name, long Object) {
  static BYTE parms[] = VTS_BSTR VTS_BSTR VTS_BSTR VTS_I4;
  InvokeHelper(0x13e, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, src, Destination, Name, Object);
}
void WApplication::OrganizerDelete(LPCTSTR src, LPCTSTR Name, long Object) {
  static BYTE parms[] = VTS_BSTR VTS_BSTR VTS_I4;
  InvokeHelper(0x13f, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, src, Name, Object);
}
void WApplication::OrganizerRename(LPCTSTR src, LPCTSTR Name, LPCTSTR NewName, long Object) {
  static BYTE parms[] = VTS_BSTR VTS_BSTR VTS_BSTR VTS_I4;
  InvokeHelper(0x140, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, src, Name, NewName, Object);
}
void WApplication::AddAddress(SAFEARRAY * * TagID, SAFEARRAY * * Value) {
  static BYTE parms[] = VTS_UNKNOWN VTS_UNKNOWN;
  InvokeHelper(0x141, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, TagID, Value);
}
CString WApplication::GetAddress(VARIANT * Name, VARIANT * AddressProperties, VARIANT * UseAutoText, VARIANT * DisplaySelectDialog, VARIANT * SelectDialog, VARIANT * CheckNamesDialog, VARIANT * RecentAddressesChoice, VARIANT * UpdateRecentAddresses) {
  CString result;
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x142, DISPATCH_METHOD, VT_BSTR, (void*)&result, parms, Name, AddressProperties, UseAutoText, DisplaySelectDialog, SelectDialog, CheckNamesDialog, RecentAddressesChoice, UpdateRecentAddresses);
  return result;
}
BOOL WApplication::CheckGrammar(LPCTSTR String) {
  BOOL result;
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x143, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms, String);
  return result;
}
BOOL WApplication::CheckSpelling(LPCTSTR MSWord, VARIANT * CustomDictionary, VARIANT * IgnoreUppercase, VARIANT * MainDictionary, VARIANT * CustomDictionary2, VARIANT * CustomDictionary3, VARIANT * CustomDictionary4, VARIANT * CustomDictionary5, VARIANT * CustomDictionary6, VARIANT * CustomDictionary7, VARIANT * CustomDictionary8, VARIANT * CustomDictionary9, VARIANT * CustomDictionary10) {
  BOOL result;
  static BYTE parms[] = VTS_BSTR VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x144, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms, MSWord, CustomDictionary, IgnoreUppercase, MainDictionary, CustomDictionary2, CustomDictionary3, CustomDictionary4, CustomDictionary5, CustomDictionary6, CustomDictionary7, CustomDictionary8, CustomDictionary9, CustomDictionary10);
  return result;
}
void WApplication::ResetIgnoreAll() {
  InvokeHelper(0x146, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
LPDISPATCH WApplication::GetSpellingSuggestions(LPCTSTR MSWord, VARIANT * CustomDictionary, VARIANT * IgnoreUppercase, VARIANT * MainDictionary, VARIANT * SuggestionMode, VARIANT * CustomDictionary2, VARIANT * CustomDictionary3, VARIANT * CustomDictionary4, VARIANT * CustomDictionary5, VARIANT * CustomDictionary6, VARIANT * CustomDictionary7, VARIANT * CustomDictionary8, VARIANT * CustomDictionary9, VARIANT * CustomDictionary10) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_BSTR VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x147, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, MSWord, CustomDictionary, IgnoreUppercase, MainDictionary, SuggestionMode, CustomDictionary2, CustomDictionary3, CustomDictionary4, CustomDictionary5, CustomDictionary6, CustomDictionary7, CustomDictionary8, CustomDictionary9, CustomDictionary10);
  return result;
}
void WApplication::GoBack() {
  InvokeHelper(0x148, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WApplication::Help(VARIANT * HelpType) {
  static BYTE parms[] = VTS_PVARIANT;
  InvokeHelper(0x149, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, HelpType);
}
void WApplication::AutomaticChange() {
  InvokeHelper(0x14a, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WApplication::ShowMe() {
  InvokeHelper(0x14b, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WApplication::HelpTool() {
  InvokeHelper(0x14c, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
LPDISPATCH WApplication::NewWindow() {
  LPDISPATCH result;
  InvokeHelper(0x159, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
void WApplication::ListCommands(BOOL ListAllCommands) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x15a, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, ListAllCommands);
}
void WApplication::ShowClipboard() {
  InvokeHelper(0x15d, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WApplication::OnTime(VARIANT * When, LPCTSTR Name, VARIANT * Tolerance) {
  static BYTE parms[] = VTS_PVARIANT VTS_BSTR VTS_PVARIANT;
  InvokeHelper(0x15e, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, When, Name, Tolerance);
}
void WApplication::NextLetter() {
  InvokeHelper(0x15f, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
short WApplication::MountVolume(LPCTSTR Zone, LPCTSTR Server, LPCTSTR Volume, VARIANT * User, VARIANT * UserPassword, VARIANT * VolumePassword) {
  short result;
  static BYTE parms[] = VTS_BSTR VTS_BSTR VTS_BSTR VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x161, DISPATCH_METHOD, VT_I2, (void*)&result, parms, Zone, Server, Volume, User, UserPassword, VolumePassword);
  return result;
}
CString WApplication::CleanString(LPCTSTR String) {
  CString result;
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x162, DISPATCH_METHOD, VT_BSTR, (void*)&result, parms, String);
  return result;
}
void WApplication::SendFax() {
  InvokeHelper(0x164, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WApplication::ChangeFileOpenDirectory(LPCTSTR Path) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x165, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Path);
}
void WApplication::RunOld(LPCTSTR MacroName) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x166, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, MacroName);
}
void WApplication::GoForward() {
  InvokeHelper(0x167, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WApplication::Move(long Left, long Top) {
  static BYTE parms[] = VTS_I4 VTS_I4;
  InvokeHelper(0x168, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Left, Top);
}
void WApplication::Resize(long Width, long Height) {
  static BYTE parms[] = VTS_I4 VTS_I4;
  InvokeHelper(0x169, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Width, Height);
}
float WApplication::InchesToPoints(float Inches) {
  float result;
  static BYTE parms[] = VTS_R4;
  InvokeHelper(0x172, DISPATCH_METHOD, VT_R4, (void*)&result, parms, Inches);
  return result;
}
float WApplication::CentimetersToPoints(float Centimeters) {
  float result;
  static BYTE parms[] = VTS_R4;
  InvokeHelper(0x173, DISPATCH_METHOD, VT_R4, (void*)&result, parms, Centimeters);
  return result;
}
float WApplication::MillimetersToPoints(float Millimeters) {
  float result;
  static BYTE parms[] = VTS_R4;
  InvokeHelper(0x174, DISPATCH_METHOD, VT_R4, (void*)&result, parms, Millimeters);
  return result;
}
float WApplication::PicasToPoints(float Picas) {
  float result;
  static BYTE parms[] = VTS_R4;
  InvokeHelper(0x175, DISPATCH_METHOD, VT_R4, (void*)&result, parms, Picas);
  return result;
}
float WApplication::LinesToPoints(float Lines) {
  float result;
  static BYTE parms[] = VTS_R4;
  InvokeHelper(0x176, DISPATCH_METHOD, VT_R4, (void*)&result, parms, Lines);
  return result;
}
float WApplication::PointsToInches(float Points) {
  float result;
  static BYTE parms[] = VTS_R4;
  InvokeHelper(0x17c, DISPATCH_METHOD, VT_R4, (void*)&result, parms, Points);
  return result;
}
float WApplication::PointsToCentimeters(float Points) {
  float result;
  static BYTE parms[] = VTS_R4;
  InvokeHelper(0x17d, DISPATCH_METHOD, VT_R4, (void*)&result, parms, Points);
  return result;
}
float WApplication::PointsToMillimeters(float Points) {
  float result;
  static BYTE parms[] = VTS_R4;
  InvokeHelper(0x17e, DISPATCH_METHOD, VT_R4, (void*)&result, parms, Points);
  return result;
}
float WApplication::PointsToPicas(float Points) {
  float result;
  static BYTE parms[] = VTS_R4;
  InvokeHelper(0x17f, DISPATCH_METHOD, VT_R4, (void*)&result, parms, Points);
  return result;
}
float WApplication::PointsToLines(float Points) {
  float result;
  static BYTE parms[] = VTS_R4;
  InvokeHelper(0x180, DISPATCH_METHOD, VT_R4, (void*)&result, parms, Points);
  return result;
}
void WApplication::Activate() {
  InvokeHelper(0x181, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
float WApplication::PointsToPixels(float Points, VARIANT * fVertical) {
  float result;
  static BYTE parms[] = VTS_R4 VTS_PVARIANT;
  InvokeHelper(0x183, DISPATCH_METHOD, VT_R4, (void*)&result, parms, Points, fVertical);
  return result;
}
float WApplication::PixelsToPoints(float Pixels, VARIANT * fVertical) {
  float result;
  static BYTE parms[] = VTS_R4 VTS_PVARIANT;
  InvokeHelper(0x184, DISPATCH_METHOD, VT_R4, (void*)&result, parms, Pixels, fVertical);
  return result;
}
void WApplication::KeyboardLatin() {
  InvokeHelper(0x190, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WApplication::KeyboardBidi() {
  InvokeHelper(0x191, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WApplication::ToggleKeyboard() {
  InvokeHelper(0x192, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
long WApplication::Keyboard(long LangId) {
  long result;
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x1be, DISPATCH_METHOD, VT_I4, (void*)&result, parms, LangId);
  return result;
}
CString WApplication::ProductCode() {
  CString result;
  InvokeHelper(0x194, DISPATCH_METHOD, VT_BSTR, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WApplication::DefaultWebOptions() {
  LPDISPATCH result;
  InvokeHelper(0x195, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
void WApplication::DiscussionSupport(VARIANT * Range, VARIANT * cid, VARIANT * piCSE) {
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x197, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Range, cid, piCSE);
}
void WApplication::SetDefaultTheme(LPCTSTR Name, long DocumentType) {
  static BYTE parms[] = VTS_BSTR VTS_I4;
  InvokeHelper(0x19e, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Name, DocumentType);
}
CString WApplication::GetDefaultTheme(long DocumentType) {
  CString result;
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x1a0, DISPATCH_METHOD, VT_BSTR, (void*)&result, parms, DocumentType);
  return result;
}
LPDISPATCH WApplication::get_EmailOptions() {
  LPDISPATCH result;
  InvokeHelper(0x185, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
long WApplication::get_Language() {
  long result;
  InvokeHelper(0x187, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WApplication::get_COMAddIns() {
  LPDISPATCH result;
  InvokeHelper(0x6f, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
BOOL WApplication::get_CheckLanguage() {
  BOOL result;
  InvokeHelper(0x70, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WApplication::put_CheckLanguage(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x70, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
LPDISPATCH WApplication::get_LanguageSettings() {
  LPDISPATCH result;
  InvokeHelper(0x193, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
BOOL WApplication::get_Dummy1() {
  BOOL result;
  InvokeHelper(0x196, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WApplication::get_AnswerWizard() {
  LPDISPATCH result;
  InvokeHelper(0x199, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
long WApplication::get_FeatureInstall() {
  long result;
  InvokeHelper(0x1bf, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void WApplication::put_FeatureInstall(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x1bf, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
void WApplication::PrintOut2000(VARIANT * Background, VARIANT * Append, VARIANT * Range, VARIANT * OutputFileName, VARIANT * From, VARIANT * To, VARIANT * Item, VARIANT * Copies, VARIANT * Pages, VARIANT * PageType, VARIANT * PrintToFile, VARIANT * Collate, VARIANT * FileName, VARIANT * ActivePrinterMacGX, VARIANT * ManualDuplexPrint, VARIANT * PrintZoomColumn, VARIANT * PrintZoomRow, VARIANT * PrintZoomPaperWidth, VARIANT * PrintZoomPaperHeight) {
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x1bc, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Background, Append, Range, OutputFileName, From, To, Item, Copies, Pages, PageType, PrintToFile, Collate, FileName, ActivePrinterMacGX, ManualDuplexPrint, PrintZoomColumn, PrintZoomRow, PrintZoomPaperWidth, PrintZoomPaperHeight);
}
VARIANT WApplication::Run(LPCTSTR MacroName, VARIANT * varg1, VARIANT * varg2, VARIANT * varg3, VARIANT * varg4, VARIANT * varg5, VARIANT * varg6, VARIANT * varg7, VARIANT * varg8, VARIANT * varg9, VARIANT * varg10, VARIANT * varg11, VARIANT * varg12, VARIANT * varg13, VARIANT * varg14, VARIANT * varg15, VARIANT * varg16, VARIANT * varg17, VARIANT * varg18, VARIANT * varg19, VARIANT * varg20, VARIANT * varg21, VARIANT * varg22, VARIANT * varg23, VARIANT * varg24, VARIANT * varg25, VARIANT * varg26, VARIANT * varg27, VARIANT * varg28, VARIANT * varg29, VARIANT * varg30) {
  VARIANT result;
  static BYTE parms[] = VTS_BSTR VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x1bd, DISPATCH_METHOD, VT_VARIANT, (void*)&result, parms, MacroName, varg1, varg2, varg3, varg4, varg5, varg6, varg7, varg8, varg9, varg10, varg11, varg12, varg13, varg14, varg15, varg16, varg17, varg18, varg19, varg20, varg21, varg22, varg23, varg24, varg25, varg26, varg27, varg28, varg29, varg30);
  return result;
}
void WApplication::PrintOut(VARIANT * Background, VARIANT * Append, VARIANT * Range, VARIANT * OutputFileName, VARIANT * From, VARIANT * To, VARIANT * Item, VARIANT * Copies, VARIANT * Pages, VARIANT * PageType, VARIANT * PrintToFile, VARIANT * Collate, VARIANT * FileName, VARIANT * ActivePrinterMacGX, VARIANT * ManualDuplexPrint, VARIANT * PrintZoomColumn, VARIANT * PrintZoomRow, VARIANT * PrintZoomPaperWidth, VARIANT * PrintZoomPaperHeight) {
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x1c0, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Background, Append, Range, OutputFileName, From, To, Item, Copies, Pages, PageType, PrintToFile, Collate, FileName, ActivePrinterMacGX, ManualDuplexPrint, PrintZoomColumn, PrintZoomRow, PrintZoomPaperWidth, PrintZoomPaperHeight);
}
long WApplication::get_AutomationSecurity() {
  long result;
  InvokeHelper(0x1c1, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void WApplication::put_AutomationSecurity(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x1c1, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
LPDISPATCH WApplication::get_FileDialog(long FileDialogType) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x1c2, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, parms, FileDialogType);
  return result;
}
CString WApplication::get_EmailTemplate() {
  CString result;
  InvokeHelper(0x1c3, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
void WApplication::put_EmailTemplate(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x1c3, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WApplication::get_ShowWindowsInTaskbar() {
  BOOL result;
  InvokeHelper(0x1c4, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WApplication::put_ShowWindowsInTaskbar(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x1c4, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
LPDISPATCH WApplication::get_NewDocument() {
  LPDISPATCH result;
  InvokeHelper(0x1c6, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
BOOL WApplication::get_ShowStartupDialog() {
  BOOL result;
  InvokeHelper(0x1c7, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WApplication::put_ShowStartupDialog(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x1c7, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
LPDISPATCH WApplication::get_AutoCorrectEmail() {
  LPDISPATCH result;
  InvokeHelper(0x1c8, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WApplication::get_TaskPanes() {
  LPDISPATCH result;
  InvokeHelper(0x1c9, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
BOOL WApplication::get_DefaultLegalBlackline() {
  BOOL result;
  InvokeHelper(0x1cb, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WApplication::put_DefaultLegalBlackline(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x1cb, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WApplication::Dummy2() {
  BOOL result;
  InvokeHelper(0x1ca, DISPATCH_METHOD, VT_BOOL, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WApplication::get_SmartTagRecognizers() {
  LPDISPATCH result;
  InvokeHelper(0x1cc, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WApplication::get_SmartTagTypes() {
  LPDISPATCH result;
  InvokeHelper(0x1cd, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WApplication::get_XMLNamespaces() {
  LPDISPATCH result;
  InvokeHelper(0x1cf, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
void WApplication::PutFocusInMailHeader() {
  InvokeHelper(0x1d0, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
BOOL WApplication::get_ArbitraryXMLSupportAvailable() {
  BOOL result;
  InvokeHelper(0x1d1, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
CString WApplication::get_BuildFull() {
  CString result;
  InvokeHelper(0x1d2, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
CString WApplication::get_BuildFeatureCrew() {
  CString result;
  InvokeHelper(0x1d3, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
void WApplication::LoadMasterList(LPCTSTR FileName) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x1d5, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, FileName);
}
LPDISPATCH WApplication::CompareDocuments(LPDISPATCH OriginalDocument, LPDISPATCH RevisedDocument, long Destination, long Granularity, BOOL CompareFormatting, BOOL CompareCaseChanges, BOOL CompareWhitespace, BOOL CompareTables, BOOL CompareHeaders, BOOL CompareFootnotes, BOOL CompareTextboxes, BOOL CompareFields, BOOL CompareComments, BOOL CompareMoves, LPCTSTR RevisedAuthor, BOOL IgnoreAllComparisonWarnings) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_DISPATCH VTS_DISPATCH VTS_I4 VTS_I4 VTS_BOOL VTS_BOOL VTS_BOOL VTS_BOOL VTS_BOOL VTS_BOOL VTS_BOOL VTS_BOOL VTS_BOOL VTS_BOOL VTS_BSTR VTS_BOOL;
  InvokeHelper(0x1d6, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, OriginalDocument, RevisedDocument, Destination, Granularity, CompareFormatting, CompareCaseChanges, CompareWhitespace, CompareTables, CompareHeaders, CompareFootnotes, CompareTextboxes, CompareFields, CompareComments, CompareMoves, RevisedAuthor, IgnoreAllComparisonWarnings);
  return result;
}
LPDISPATCH WApplication::MergeDocuments(LPDISPATCH OriginalDocument, LPDISPATCH RevisedDocument, long Destination, long Granularity, BOOL CompareFormatting, BOOL CompareCaseChanges, BOOL CompareWhitespace, BOOL CompareTables, BOOL CompareHeaders, BOOL CompareFootnotes, BOOL CompareTextboxes, BOOL CompareFields, BOOL CompareComments, BOOL CompareMoves, LPCTSTR OriginalAuthor, LPCTSTR RevisedAuthor, long FormatFrom) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_DISPATCH VTS_DISPATCH VTS_I4 VTS_I4 VTS_BOOL VTS_BOOL VTS_BOOL VTS_BOOL VTS_BOOL VTS_BOOL VTS_BOOL VTS_BOOL VTS_BOOL VTS_BOOL VTS_BSTR VTS_BSTR VTS_I4;
  InvokeHelper(0x1d7, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, OriginalDocument, RevisedDocument, Destination, Granularity, CompareFormatting, CompareCaseChanges, CompareWhitespace, CompareTables, CompareHeaders, CompareFootnotes, CompareTextboxes, CompareFields, CompareComments, CompareMoves, OriginalAuthor, RevisedAuthor, FormatFrom);
  return result;
}
LPDISPATCH WApplication::get_Bibliography() {
  LPDISPATCH result;
  InvokeHelper(0x1d8, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
BOOL WApplication::get_ShowStylePreviews() {
  BOOL result;
  InvokeHelper(0x1d9, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WApplication::put_ShowStylePreviews(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x1d9, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WApplication::get_RestrictLinkedStyles() {
  BOOL result;
  InvokeHelper(0x1da, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WApplication::put_RestrictLinkedStyles(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x1da, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
LPDISPATCH WApplication::get_OMathAutoCorrect() {
  LPDISPATCH result;
  InvokeHelper(0x1db, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
BOOL WApplication::get_DisplayDocumentInformationPanel() {
  BOOL result;
  InvokeHelper(0x1dc, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WApplication::put_DisplayDocumentInformationPanel(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x1dc, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
LPDISPATCH WApplication::get_Assistance() {
  LPDISPATCH result;
  InvokeHelper(0x1dd, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
BOOL WApplication::get_OpenAttachmentsInFullScreen() {
  BOOL result;
  InvokeHelper(0x1de, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WApplication::put_OpenAttachmentsInFullScreen(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x1de, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
long WApplication::get_ActiveEncryptionSession() {
  long result;
  InvokeHelper(0x1df, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
BOOL WApplication::get_DontResetInsertionPointProperties() {
  BOOL result;
  InvokeHelper(0x1e0, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WApplication::put_DontResetInsertionPointProperties(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x1e0, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
LPDISPATCH WApplication::get_SmartArtLayouts() {
  LPDISPATCH result;
  InvokeHelper(0x1e1, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WApplication::get_SmartArtQuickStyles() {
  LPDISPATCH result;
  InvokeHelper(0x1e2, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WApplication::get_SmartArtColors() {
  LPDISPATCH result;
  InvokeHelper(0x1e3, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
void WApplication::ThreeWayMerge(LPDISPATCH LocalDocument, LPDISPATCH ServerDocument, LPDISPATCH BaseDocument, BOOL FavorSource) {
  static BYTE parms[] = VTS_DISPATCH VTS_DISPATCH VTS_DISPATCH VTS_BOOL;
  InvokeHelper(0x1e4, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, LocalDocument, ServerDocument, BaseDocument, FavorSource);
}
void WApplication::Dummy4() {
  InvokeHelper(0x1e5, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
LPDISPATCH WApplication::get_UndoRecord() {
  LPDISPATCH result;
  InvokeHelper(0x1e6, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WApplication::get_PickerDialog() {
  LPDISPATCH result;
  InvokeHelper(0x1e9, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WApplication::get_ProtectedViewWindows() {
  LPDISPATCH result;
  InvokeHelper(0x1ea, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WApplication::get_ActiveProtectedViewWindow() {
  LPDISPATCH result;
  InvokeHelper(0x1eb, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
BOOL WApplication::get_IsSandboxed() {
  BOOL result;
  InvokeHelper(0x1ec, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
long WApplication::get_FileValidation() {
  long result;
  InvokeHelper(0x1ed, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void WApplication::put_FileValidation(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x1ed, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WApplication::get_ChartDataPointTrack() {
  BOOL result;
  InvokeHelper(0x1ee, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WApplication::put_ChartDataPointTrack(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x1ee, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WApplication::get_ShowAnimation() {
  BOOL result;
  InvokeHelper(0x1ef, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WApplication::put_ShowAnimation(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x1ef, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

} // namespace MSO::Word

#pragma warning( pop )