#include "stdafx.h"

#include "office/word/WBookmarks.h"

#include "office/word/WBookmark.h"
#include "office/word/WApplication.h"

#pragma warning( push )
#pragma warning( disable : 26493 26485 26494 )

namespace MSO::Word {

LPUNKNOWN WBookmarks::get_NewEnum() {
  LPUNKNOWN result;
  InvokeHelper(0xfffffffc, DISPATCH_PROPERTYGET, VT_UNKNOWN, (void*)&result, nullptr);
  return result;
}
long WBookmarks::get_Count() {
  long result;
  InvokeHelper(0x2, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
long WBookmarks::get_DefaultSorting() {
  long result;
  InvokeHelper(0x3, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void WBookmarks::put_DefaultSorting(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x3, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WBookmarks::get_ShowHidden() {
  BOOL result;
  InvokeHelper(0x4, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WBookmarks::put_ShowHidden(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x4, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
WApplication WBookmarks::get_Application() {
  LPDISPATCH result;
  InvokeHelper(0x3e8, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
long WBookmarks::get_Creator() {
  long result;
  InvokeHelper(0x3e9, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WBookmarks::get_Parent() {
  LPDISPATCH result;
  InvokeHelper(0x3ea, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
WBookmark WBookmarks::get_Item(VARIANT IndexType) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_PVARIANT;
  InvokeHelper(0x0, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, &IndexType);
  return result;
}
WBookmark WBookmarks::Add(LPCTSTR Name, VARIANT * Range) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_BSTR VTS_PVARIANT;
  InvokeHelper(0x5, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, Name, Range);
  return result;
}
BOOL WBookmarks::Exists(LPCTSTR Name) {
  BOOL result;
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x6, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms, Name);
  return result;
}

} // namespace MSO::Word

#pragma warning( pop )