#include "stdafx.h"

#include "office/word/WCell.h"

#include "office/word/WApplication.h"
#include "office/word/WRange.h"
#include "office/word/WColumn.h"
#include "office/word/WRow.h"

#pragma warning( push )
#pragma warning( disable : 26493 26485 26494 )

namespace MSO::Word {

WRange WCell::get_Range() {
  LPDISPATCH result;
  InvokeHelper(0x0, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
WApplication WCell::get_Application() {
  LPDISPATCH result;
  InvokeHelper(0x3e8, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
long WCell::get_Creator() {
  long result;
  InvokeHelper(0x3e9, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WCell::get_Parent() {
  LPDISPATCH result;
  InvokeHelper(0x3ea, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
long WCell::get_RowIndex() {
  long result;
  InvokeHelper(0x4, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
long WCell::get_ColumnIndex() {
  long result;
  InvokeHelper(0x5, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
float WCell::get_Width() {
  float result;
  InvokeHelper(0x6, DISPATCH_PROPERTYGET, VT_R4, (void*)&result, nullptr);
  return result;
}
void WCell::put_Width(float newValue) {
  static BYTE parms[] = VTS_R4;
  InvokeHelper(0x6, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
float WCell::get_Height() {
  float result;
  InvokeHelper(0x7, DISPATCH_PROPERTYGET, VT_R4, (void*)&result, nullptr);
  return result;
}
void WCell::put_Height(float newValue) {
  static BYTE parms[] = VTS_R4;
  InvokeHelper(0x7, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
long WCell::get_HeightRule() {
  long result;
  InvokeHelper(0x8, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void WCell::put_HeightRule(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x8, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
long WCell::get_VerticalAlignment() {
  long result;
  InvokeHelper(0x450, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void WCell::put_VerticalAlignment(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x450, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
WColumn WCell::get_Column() {
  LPDISPATCH result;
  InvokeHelper(0x65, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
WRow WCell::get_Row() {
  LPDISPATCH result;
  InvokeHelper(0x66, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WCell::get_Next() {
  LPDISPATCH result;
  InvokeHelper(0x67, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WCell::get_Previous() {
  LPDISPATCH result;
  InvokeHelper(0x68, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WCell::get_Shading() {
  LPDISPATCH result;
  InvokeHelper(0x69, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WCell::get_Borders() {
  LPDISPATCH result;
  InvokeHelper(0x44c, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
void WCell::put_Borders(LPDISPATCH newValue) {
  static BYTE parms[] = VTS_DISPATCH;
  InvokeHelper(0x44c, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
void WCell::Select() {
  InvokeHelper(0xffff, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WCell::Delete(VARIANT * ShiftCells) {
  static BYTE parms[] = VTS_PVARIANT;
  InvokeHelper(0xc8, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, ShiftCells);
}
void WCell::Formula(VARIANT * Formula, VARIANT * NumFormat) {
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0xc9, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Formula, NumFormat);
}
void WCell::SetWidth(float ColumnWidth, long RulerStyle) {
  static BYTE parms[] = VTS_R4 VTS_I4;
  InvokeHelper(0xca, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, ColumnWidth, RulerStyle);
}
void WCell::SetHeight(VARIANT * RowHeight, long HeightRule) {
  static BYTE parms[] = VTS_PVARIANT VTS_I4;
  InvokeHelper(0xcb, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, RowHeight, HeightRule);
}
void WCell::Merge(LPDISPATCH MergeTo) {
  static BYTE parms[] = VTS_DISPATCH;
  InvokeHelper(0xcc, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, MergeTo);
}
void WCell::Split(VARIANT * NumRows, VARIANT * NumColumns) {
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0xcd, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, NumRows, NumColumns);
}
void WCell::AutoSum() {
  InvokeHelper(0xce, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
LPDISPATCH WCell::get_Tables() {
  LPDISPATCH result;
  InvokeHelper(0x6a, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
long WCell::get_NestingLevel() {
  long result;
  InvokeHelper(0x6b, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
BOOL WCell::get_WordWrap() {
  BOOL result;
  InvokeHelper(0x6c, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WCell::put_WordWrap(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x6c, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
float WCell::get_PreferredWidth() {
  float result;
  InvokeHelper(0x6d, DISPATCH_PROPERTYGET, VT_R4, (void*)&result, nullptr);
  return result;
}
void WCell::put_PreferredWidth(float newValue) {
  static BYTE parms[] = VTS_R4;
  InvokeHelper(0x6d, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WCell::get_FitText() {
  BOOL result;
  InvokeHelper(0x6e, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WCell::put_FitText(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x6e, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
float WCell::get_TopPadding() {
  float result;
  InvokeHelper(0x6f, DISPATCH_PROPERTYGET, VT_R4, (void*)&result, nullptr);
  return result;
}
void WCell::put_TopPadding(float newValue) {
  static BYTE parms[] = VTS_R4;
  InvokeHelper(0x6f, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
float WCell::get_BottomPadding() {
  float result;
  InvokeHelper(0x70, DISPATCH_PROPERTYGET, VT_R4, (void*)&result, nullptr);
  return result;
}
void WCell::put_BottomPadding(float newValue) {
  static BYTE parms[] = VTS_R4;
  InvokeHelper(0x70, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
float WCell::get_LeftPadding() {
  float result;
  InvokeHelper(0x71, DISPATCH_PROPERTYGET, VT_R4, (void*)&result, nullptr);
  return result;
}
void WCell::put_LeftPadding(float newValue) {
  static BYTE parms[] = VTS_R4;
  InvokeHelper(0x71, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
float WCell::get_RightPadding() {
  float result;
  InvokeHelper(0x72, DISPATCH_PROPERTYGET, VT_R4, (void*)&result, nullptr);
  return result;
}
void WCell::put_RightPadding(float newValue) {
  static BYTE parms[] = VTS_R4;
  InvokeHelper(0x72, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
CString WCell::get_ID() {
  CString result;
  InvokeHelper(0x73, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
void WCell::put_ID(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x73, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
long WCell::get_PreferredWidthType() {
  long result;
  InvokeHelper(0x74, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void WCell::put_PreferredWidthType(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x74, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

} // namespace MSO::Word

#pragma warning( pop )