#include "stdafx.h"

#include "office/word/WColumn.h"

#include "office/word/WApplication.h"

#pragma warning( push )
#pragma warning( disable : 26493 26485 26494 )

namespace MSO::Word {

LPDISPATCH WColumn::get_Application() {
  LPDISPATCH result;
  InvokeHelper(0x3e8, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
long WColumn::get_Creator() {
  long result;
  InvokeHelper(0x3e9, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WColumn::get_Parent() {
  LPDISPATCH result;
  InvokeHelper(0x3ea, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
float WColumn::get_Width() {
  float result;
  InvokeHelper(0x3, DISPATCH_PROPERTYGET, VT_R4, (void*)&result, nullptr);
  return result;
}
void WColumn::put_Width(float newValue) {
  static BYTE parms[] = VTS_R4;
  InvokeHelper(0x3, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WColumn::get_IsFirst() {
  BOOL result;
  InvokeHelper(0x4, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
BOOL WColumn::get_IsLast() {
  BOOL result;
  InvokeHelper(0x5, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
long WColumn::get_Index() {
  long result;
  InvokeHelper(0x6, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WColumn::get_Cells() {
  LPDISPATCH result;
  InvokeHelper(0x64, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WColumn::get_Borders() {
  LPDISPATCH result;
  InvokeHelper(0x44c, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
void WColumn::put_Borders(LPDISPATCH newValue) {
  static BYTE parms[] = VTS_DISPATCH;
  InvokeHelper(0x44c, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
LPDISPATCH WColumn::get_Shading() {
  LPDISPATCH result;
  InvokeHelper(0x66, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WColumn::get_Next() {
  LPDISPATCH result;
  InvokeHelper(0x67, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WColumn::get_Previous() {
  LPDISPATCH result;
  InvokeHelper(0x68, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
void WColumn::Select() {
  InvokeHelper(0xffff, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WColumn::Delete() {
  InvokeHelper(0xc8, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WColumn::SetWidth(float ColumnWidth, long RulerStyle) {
  static BYTE parms[] = VTS_R4 VTS_I4;
  InvokeHelper(0xc9, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, ColumnWidth, RulerStyle);
}
void WColumn::AutoFit() {
  InvokeHelper(0xca, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WColumn::SortOld(VARIANT * ExcludeHeader, VARIANT * SortFieldType, VARIANT * SortOrder, VARIANT * CaseSensitive, VARIANT * LanguageID) {
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0xcb, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, ExcludeHeader, SortFieldType, SortOrder, CaseSensitive, LanguageID);
}
void WColumn::Sort(VARIANT * ExcludeHeader, VARIANT * SortFieldType, VARIANT * SortOrder, VARIANT * CaseSensitive, VARIANT * BidiSort, VARIANT * IgnoreThe, VARIANT * IgnoreKashida, VARIANT * IgnoreDiacritics, VARIANT * IgnoreHe, VARIANT * LanguageID) {
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0xcc, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, ExcludeHeader, SortFieldType, SortOrder, CaseSensitive, BidiSort, IgnoreThe, IgnoreKashida, IgnoreDiacritics, IgnoreHe, LanguageID);
}
long WColumn::get_NestingLevel() {
  long result;
  InvokeHelper(0x69, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
float WColumn::get_PreferredWidth() {
  float result;
  InvokeHelper(0x6a, DISPATCH_PROPERTYGET, VT_R4, (void*)&result, nullptr);
  return result;
}
void WColumn::put_PreferredWidth(float newValue) {
  static BYTE parms[] = VTS_R4;
  InvokeHelper(0x6a, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
long WColumn::get_PreferredWidthType() {
  long result;
  InvokeHelper(0x6b, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void WColumn::put_PreferredWidthType(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x6b, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

} // namespace MSO::Word

#pragma warning( pop )