#include "stdafx.h"

#include "office/word/WColumns.h"

#include "office/word/WApplication.h"
#include "office/word/WColumn.h"

#pragma warning( push )
#pragma warning( disable : 26493 26485 26494 )

namespace MSO::Word {

LPUNKNOWN WColumns::get_NewEnum() {
  LPUNKNOWN result;
  InvokeHelper(0xfffffffc, DISPATCH_PROPERTYGET, VT_UNKNOWN, (void*)&result, nullptr);
  return result;
}
long WColumns::get_Count() {
  long result;
  InvokeHelper(0x2, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
WApplication WColumns::get_Application() {
  LPDISPATCH result;
  InvokeHelper(0x3e8, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
long WColumns::get_Creator() {
  long result;
  InvokeHelper(0x3e9, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WColumns::get_Parent() {
  LPDISPATCH result;
  InvokeHelper(0x3ea, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
WColumn WColumns::get_First() {
  LPDISPATCH result;
  InvokeHelper(0x64, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
WColumn WColumns::get_Last() {
  LPDISPATCH result;
  InvokeHelper(0x65, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
float WColumns::get_Width() {
  float result;
  InvokeHelper(0x3, DISPATCH_PROPERTYGET, VT_R4, (void*)&result, nullptr);
  return result;
}
void WColumns::put_Width(float newValue) {
  static BYTE parms[] = VTS_R4;
  InvokeHelper(0x3, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
LPDISPATCH WColumns::get_Borders() {
  LPDISPATCH result;
  InvokeHelper(0x44c, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
void WColumns::put_Borders(LPDISPATCH newValue) {
  static BYTE parms[] = VTS_DISPATCH;
  InvokeHelper(0x44c, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
LPDISPATCH WColumns::get_Shading() {
  LPDISPATCH result;
  InvokeHelper(0x67, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
WColumn WColumns::get_Item(long IndexType) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x0, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, IndexType);
  return result;
}
WColumn WColumns::Add(VARIANT * BeforeColumn) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_PVARIANT;
  InvokeHelper(0x5, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, BeforeColumn);
  return result;
}
void WColumns::Select() {
  InvokeHelper(0xc7, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WColumns::Delete() {
  InvokeHelper(0xc8, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WColumns::SetWidth(float ColumnWidth, long RulerStyle) {
  static BYTE parms[] = VTS_R4 VTS_I4;
  InvokeHelper(0xc9, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, ColumnWidth, RulerStyle);
}
void WColumns::AutoFit() {
  InvokeHelper(0xca, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WColumns::DistributeWidth() {
  InvokeHelper(0xcb, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
long WColumns::get_NestingLevel() {
  long result;
  InvokeHelper(0x68, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
float WColumns::get_PreferredWidth() {
  float result;
  InvokeHelper(0x69, DISPATCH_PROPERTYGET, VT_R4, (void*)&result, nullptr);
  return result;
}
void WColumns::put_PreferredWidth(float newValue) {
  static BYTE parms[] = VTS_R4;
  InvokeHelper(0x69, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
long WColumns::get_PreferredWidthType() {
  long result;
  InvokeHelper(0x6a, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void WColumns::put_PreferredWidthType(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x6a, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

} // namespace MSO::Word

#pragma warning( pop )