#include "stdafx.h"

#include "office/word/WRow.h"

#include "office/word/WApplication.h"

#pragma warning( push )
#pragma warning( disable : 26493 26485 26494 )

namespace MSO::Word {

LPDISPATCH WRow::get_Range() {
  LPDISPATCH result;
  InvokeHelper(0x0, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WRow::get_Application() {
  LPDISPATCH result;
  InvokeHelper(0x3e8, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
long WRow::get_Creator() {
  long result;
  InvokeHelper(0x3e9, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WRow::get_Parent() {
  LPDISPATCH result;
  InvokeHelper(0x3ea, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
long WRow::get_AllowBreakAcrossPages() {
  long result;
  InvokeHelper(0x3, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void WRow::put_AllowBreakAcrossPages(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x3, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
long WRow::get_Alignment() {
  long result;
  InvokeHelper(0x4, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void WRow::put_Alignment(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x4, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
long WRow::get_HeadingFormat() {
  long result;
  InvokeHelper(0x5, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void WRow::put_HeadingFormat(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x5, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
float WRow::get_SpaceBetweenColumns() {
  float result;
  InvokeHelper(0x6, DISPATCH_PROPERTYGET, VT_R4, (void*)&result, nullptr);
  return result;
}
void WRow::put_SpaceBetweenColumns(float newValue) {
  static BYTE parms[] = VTS_R4;
  InvokeHelper(0x6, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
float WRow::get_Height() {
  float result;
  InvokeHelper(0x7, DISPATCH_PROPERTYGET, VT_R4, (void*)&result, nullptr);
  return result;
}
void WRow::put_Height(float newValue) {
  static BYTE parms[] = VTS_R4;
  InvokeHelper(0x7, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
long WRow::get_HeightRule() {
  long result;
  InvokeHelper(0x8, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void WRow::put_HeightRule(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x8, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
float WRow::get_LeftIndent() {
  float result;
  InvokeHelper(0x9, DISPATCH_PROPERTYGET, VT_R4, (void*)&result, nullptr);
  return result;
}
void WRow::put_LeftIndent(float newValue) {
  static BYTE parms[] = VTS_R4;
  InvokeHelper(0x9, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WRow::get_IsLast() {
  BOOL result;
  InvokeHelper(0xa, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
BOOL WRow::get_IsFirst() {
  BOOL result;
  InvokeHelper(0xb, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
long WRow::get_Index() {
  long result;
  InvokeHelper(0xc, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WRow::get_Cells() {
  LPDISPATCH result;
  InvokeHelper(0x64, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WRow::get_Borders() {
  LPDISPATCH result;
  InvokeHelper(0x44c, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
void WRow::put_Borders(LPDISPATCH newValue) {
  static BYTE parms[] = VTS_DISPATCH;
  InvokeHelper(0x44c, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
LPDISPATCH WRow::get_Shading() {
  LPDISPATCH result;
  InvokeHelper(0x67, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WRow::get_Next() {
  LPDISPATCH result;
  InvokeHelper(0x68, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WRow::get_Previous() {
  LPDISPATCH result;
  InvokeHelper(0x69, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
void WRow::Select() {
  InvokeHelper(0xffff, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WRow::Delete() {
  InvokeHelper(0xc8, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WRow::SetLeftIndent(float LeftIndent, long RulerStyle) {
  static BYTE parms[] = VTS_R4 VTS_I4;
  InvokeHelper(0xca, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, LeftIndent, RulerStyle);
}
void WRow::SetHeight(float RowHeight, long HeightRule) {
  static BYTE parms[] = VTS_R4 VTS_I4;
  InvokeHelper(0xcb, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, RowHeight, HeightRule);
}
LPDISPATCH WRow::ConvertToTextOld(VARIANT * Separator) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_PVARIANT;
  InvokeHelper(0x10, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, Separator);
  return result;
}
LPDISPATCH WRow::ConvertToText(VARIANT * Separator, VARIANT * NestedTables) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x12, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, Separator, NestedTables);
  return result;
}
long WRow::get_NestingLevel() {
  long result;
  InvokeHelper(0x6a, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
CString WRow::get_ID() {
  CString result;
  InvokeHelper(0x6b, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
void WRow::put_ID(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x6b, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

} // namespace MSO::Word

#pragma warning( pop )