#include "stdafx.h"

#include "office/word/WRows.h"

#include "office/word/WApplication.h"

#pragma warning( push )
#pragma warning( disable : 26493 26485 26494 )

namespace MSO::Word {

LPUNKNOWN WRows::get_NewEnum() {
  LPUNKNOWN result;
  InvokeHelper(0xfffffffc, DISPATCH_PROPERTYGET, VT_UNKNOWN, (void*)&result, nullptr);
  return result;
}
long WRows::get_Count() {
  long result;
  InvokeHelper(0x2, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
long WRows::get_AllowBreakAcrossPages() {
  long result;
  InvokeHelper(0x3, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void WRows::put_AllowBreakAcrossPages(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x3, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
long WRows::get_Alignment() {
  long result;
  InvokeHelper(0x4, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void WRows::put_Alignment(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x4, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
long WRows::get_HeadingFormat() {
  long result;
  InvokeHelper(0x5, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void WRows::put_HeadingFormat(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x5, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
float WRows::get_SpaceBetweenColumns() {
  float result;
  InvokeHelper(0x6, DISPATCH_PROPERTYGET, VT_R4, (void*)&result, nullptr);
  return result;
}
void WRows::put_SpaceBetweenColumns(float newValue) {
  static BYTE parms[] = VTS_R4;
  InvokeHelper(0x6, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
float WRows::get_Height() {
  float result;
  InvokeHelper(0x7, DISPATCH_PROPERTYGET, VT_R4, (void*)&result, nullptr);
  return result;
}
void WRows::put_Height(float newValue) {
  static BYTE parms[] = VTS_R4;
  InvokeHelper(0x7, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
long WRows::get_HeightRule() {
  long result;
  InvokeHelper(0x8, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void WRows::put_HeightRule(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x8, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
float WRows::get_LeftIndent() {
  float result;
  InvokeHelper(0x9, DISPATCH_PROPERTYGET, VT_R4, (void*)&result, nullptr);
  return result;
}
void WRows::put_LeftIndent(float newValue) {
  static BYTE parms[] = VTS_R4;
  InvokeHelper(0x9, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
LPDISPATCH WRows::get_First() {
  LPDISPATCH result;
  InvokeHelper(0xa, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WRows::get_Last() {
  LPDISPATCH result;
  InvokeHelper(0xb, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WRows::get_Application() {
  LPDISPATCH result;
  InvokeHelper(0x3e8, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
long WRows::get_Creator() {
  long result;
  InvokeHelper(0x3e9, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WRows::get_Parent() {
  LPDISPATCH result;
  InvokeHelper(0x3ea, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WRows::get_Borders() {
  LPDISPATCH result;
  InvokeHelper(0x44c, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
void WRows::put_Borders(LPDISPATCH newValue) {
  static BYTE parms[] = VTS_DISPATCH;
  InvokeHelper(0x44c, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
LPDISPATCH WRows::get_Shading() {
  LPDISPATCH result;
  InvokeHelper(0x66, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WRows::get_Item(long IndexType) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x0, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, IndexType);
  return result;
}
LPDISPATCH WRows::Add(VARIANT * BeforeRow) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_PVARIANT;
  InvokeHelper(0x64, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, BeforeRow);
  return result;
}
void WRows::Select() {
  InvokeHelper(0xc7, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WRows::Delete() {
  InvokeHelper(0xc8, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WRows::SetLeftIndent(float LeftIndent, long RulerStyle) {
  static BYTE parms[] = VTS_R4 VTS_I4;
  InvokeHelper(0xca, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, LeftIndent, RulerStyle);
}
void WRows::SetHeight(float RowHeight, long HeightRule) {
  static BYTE parms[] = VTS_R4 VTS_I4;
  InvokeHelper(0xcb, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, RowHeight, HeightRule);
}
LPDISPATCH WRows::ConvertToTextOld(VARIANT * Separator) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_PVARIANT;
  InvokeHelper(0x10, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, Separator);
  return result;
}
void WRows::DistributeHeight() {
  InvokeHelper(0xce, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
LPDISPATCH WRows::ConvertToText(VARIANT * Separator, VARIANT * NestedTables) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0xd2, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, Separator, NestedTables);
  return result;
}
long WRows::get_WrapAroundText() {
  long result;
  InvokeHelper(0xc, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void WRows::put_WrapAroundText(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0xc, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
float WRows::get_DistanceTop() {
  float result;
  InvokeHelper(0xd, DISPATCH_PROPERTYGET, VT_R4, (void*)&result, nullptr);
  return result;
}
void WRows::put_DistanceTop(float newValue) {
  static BYTE parms[] = VTS_R4;
  InvokeHelper(0xd, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
float WRows::get_DistanceBottom() {
  float result;
  InvokeHelper(0xe, DISPATCH_PROPERTYGET, VT_R4, (void*)&result, nullptr);
  return result;
}
void WRows::put_DistanceBottom(float newValue) {
  static BYTE parms[] = VTS_R4;
  InvokeHelper(0xe, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
float WRows::get_DistanceLeft() {
  float result;
  InvokeHelper(0x14, DISPATCH_PROPERTYGET, VT_R4, (void*)&result, nullptr);
  return result;
}
void WRows::put_DistanceLeft(float newValue) {
  static BYTE parms[] = VTS_R4;
  InvokeHelper(0x14, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
float WRows::get_DistanceRight() {
  float result;
  InvokeHelper(0x15, DISPATCH_PROPERTYGET, VT_R4, (void*)&result, nullptr);
  return result;
}
void WRows::put_DistanceRight(float newValue) {
  static BYTE parms[] = VTS_R4;
  InvokeHelper(0x15, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
float WRows::get_HorizontalPosition() {
  float result;
  InvokeHelper(0xf, DISPATCH_PROPERTYGET, VT_R4, (void*)&result, nullptr);
  return result;
}
void WRows::put_HorizontalPosition(float newValue) {
  static BYTE parms[] = VTS_R4;
  InvokeHelper(0xf, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
float WRows::get_VerticalPosition() {
  float result;
  InvokeHelper(0x11, DISPATCH_PROPERTYGET, VT_R4, (void*)&result, nullptr);
  return result;
}
void WRows::put_VerticalPosition(float newValue) {
  static BYTE parms[] = VTS_R4;
  InvokeHelper(0x11, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
long WRows::get_RelativeHorizontalPosition() {
  long result;
  InvokeHelper(0x12, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void WRows::put_RelativeHorizontalPosition(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x12, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
long WRows::get_RelativeVerticalPosition() {
  long result;
  InvokeHelper(0x13, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void WRows::put_RelativeVerticalPosition(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x13, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
long WRows::get_AllowOverlap() {
  long result;
  InvokeHelper(0x16, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void WRows::put_AllowOverlap(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x16, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
long WRows::get_NestingLevel() {
  long result;
  InvokeHelper(0x67, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
long WRows::get_TableDirection() {
  long result;
  InvokeHelper(0x68, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void WRows::put_TableDirection(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x68, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

} // namespace MSO::Word

#pragma warning( pop )