#include "stdafx.h"

#include "office/word/WTable.h"

#include "office/word/WApplication.h"
#include "office/word/WTables.h"
#include "office/word/WRange.h"
#include "office/word/WRows.h"
#include "office/word/WColumns.h"
#include "office/word/WCell.h"

#pragma warning( push )
#pragma warning( disable : 26493 26485 26494 )

namespace MSO::Word {

WRange WTable::get_Range() {
  LPDISPATCH result;
  InvokeHelper(0x0, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

WApplication WTable::get_Application() {
  LPDISPATCH result;
  InvokeHelper(0x3e8, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

long WTable::get_Creator() {
  long result;
  InvokeHelper(0x3e9, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

LPDISPATCH WTable::get_Parent() {
  LPDISPATCH result;
  InvokeHelper(0x3ea, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

WColumns WTable::get_Columns() {
  LPDISPATCH result;
  InvokeHelper(0x64, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

WRows WTable::get_Rows() {
  LPDISPATCH result;
  InvokeHelper(0x65, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH WTable::get_Borders() {
  LPDISPATCH result;
  InvokeHelper(0x44c, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

void WTable::put_Borders(LPDISPATCH newValue) {
  static BYTE parms[] = VTS_DISPATCH;
  InvokeHelper(0x44c, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

LPDISPATCH WTable::get_Shading() {
  LPDISPATCH result;
  InvokeHelper(0x68, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

BOOL WTable::get_Uniform() {
  BOOL result;
  InvokeHelper(0x69, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

long WTable::get_AutoFormatType() {
  long result;
  InvokeHelper(0x6a, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

void WTable::Select() {
  InvokeHelper(0xc8, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}

void WTable::Delete() {
  InvokeHelper(0x9, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}

void WTable::SortOld(VARIANT * ExcludeHeader, VARIANT * FieldNumber, VARIANT * SortFieldType, VARIANT * SortOrder, VARIANT * FieldNumber2, VARIANT * SortFieldType2, VARIANT * SortOrder2, VARIANT * FieldNumber3, VARIANT * SortFieldType3, VARIANT * SortOrder3, VARIANT * CaseSensitive, VARIANT * LanguageID) {
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0xa, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, ExcludeHeader, FieldNumber, SortFieldType, SortOrder, FieldNumber2, SortFieldType2, SortOrder2, FieldNumber3, SortFieldType3, SortOrder3, CaseSensitive, LanguageID);
}

void WTable::SortAscending() {
  InvokeHelper(0xc, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}

void WTable::SortDescending() {
  InvokeHelper(0xd, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}

void WTable::AutoFormat(VARIANT * Format, VARIANT * ApplyBorders, VARIANT * ApplyShading, VARIANT * ApplyFont,
      VARIANT * ApplyColor, VARIANT * ApplyHeadingRows, VARIANT * ApplyLastRow,
      VARIANT * ApplyFirstColumn, VARIANT * ApplyLastColumn, VARIANT * AutoFit) {
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0xe, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Format, ApplyBorders, ApplyShading, ApplyFont, ApplyColor, ApplyHeadingRows, ApplyLastRow, ApplyFirstColumn, ApplyLastColumn, AutoFit);
}

void WTable::UpdateAutoFormat() {
  InvokeHelper(0xf, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}

LPDISPATCH WTable::ConvertToTextOld(VARIANT * Separator) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_PVARIANT;
  InvokeHelper(0x10, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, Separator);
  return result;
}

WCell WTable::Cell(long Row, long Column) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_I4 VTS_I4;
  InvokeHelper(0x11, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, Row, Column);
  return result;
}

LPDISPATCH WTable::Split(VARIANT * BeforeRow) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_PVARIANT;
  InvokeHelper(0x12, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, BeforeRow);
  return result;
}

LPDISPATCH WTable::ConvertToText(VARIANT * Separator, VARIANT * NestedTables) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x13, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, Separator, NestedTables);
  return result;
}

void WTable::AutoFitBehavior(long Behavior) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x14, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Behavior);
}

void WTable::Sort(VARIANT * ExcludeHeader, VARIANT * FieldNumber, VARIANT * SortFieldType, VARIANT * SortOrder,
      VARIANT * FieldNumber2, VARIANT * SortFieldType2, VARIANT * SortOrder2, VARIANT * FieldNumber3,
      VARIANT * SortFieldType3, VARIANT * SortOrder3, VARIANT * CaseSensitive, VARIANT * BidiSort, VARIANT * IgnoreThe,
      VARIANT * IgnoreKashida, VARIANT * IgnoreDiacritics, VARIANT * IgnoreHe, VARIANT * LanguageID) {
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x17, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, ExcludeHeader, FieldNumber, SortFieldType, SortOrder, FieldNumber2, SortFieldType2, SortOrder2, FieldNumber3, SortFieldType3, SortOrder3, CaseSensitive, BidiSort, IgnoreThe, IgnoreKashida, IgnoreDiacritics, IgnoreHe, LanguageID);
}

WTables WTable::get_Tables() {
  LPDISPATCH result;
  InvokeHelper(0x6b, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

long WTable::get_NestingLevel() {
  long result;
  InvokeHelper(0x6c, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

BOOL WTable::get_AllowPageBreaks() {
  BOOL result;
  InvokeHelper(0x6d, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void WTable::put_AllowPageBreaks(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x6d, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WTable::get_AllowAutoFit() {
  BOOL result;
  InvokeHelper(0x6e, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WTable::put_AllowAutoFit(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x6e, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

float WTable::get_PreferredWidth() {
  float result;
  InvokeHelper(0x6f, DISPATCH_PROPERTYGET, VT_R4, (void*)&result, nullptr);
  return result;
}

void WTable::put_PreferredWidth(float newValue) {
  static BYTE parms[] = VTS_R4;
  InvokeHelper(0x6f, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

long WTable::get_PreferredWidthType() {
  long result;
  InvokeHelper(0x70, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

void WTable::put_PreferredWidthType(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x70, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

float WTable::get_TopPadding() {
  float result;
  InvokeHelper(0x71, DISPATCH_PROPERTYGET, VT_R4, (void*)&result, nullptr);
  return result;
}

void WTable::put_TopPadding(float newValue) {
  static BYTE parms[] = VTS_R4;
  InvokeHelper(0x71, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

float WTable::get_BottomPadding() {
  float result;
  InvokeHelper(0x72, DISPATCH_PROPERTYGET, VT_R4, (void*)&result, nullptr);
  return result;
}

void WTable::put_BottomPadding(float newValue) {
  static BYTE parms[] = VTS_R4;
  InvokeHelper(0x72, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

float WTable::get_LeftPadding() {
  float result;
  InvokeHelper(0x73, DISPATCH_PROPERTYGET, VT_R4, (void*)&result, nullptr);
  return result;
}

void WTable::put_LeftPadding(float newValue) {
  static BYTE parms[] = VTS_R4;
  InvokeHelper(0x73, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

float WTable::get_RightPadding() {
  float result;
  InvokeHelper(0x74, DISPATCH_PROPERTYGET, VT_R4, (void*)&result, nullptr);
  return result;
}

void WTable::put_RightPadding(float newValue) {
  static BYTE parms[] = VTS_R4;
  InvokeHelper(0x74, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

float WTable::get_Spacing() {
  float result;
  InvokeHelper(0x75, DISPATCH_PROPERTYGET, VT_R4, (void*)&result, nullptr);
  return result;
}

void WTable::put_Spacing(float newValue) {
  static BYTE parms[] = VTS_R4;
  InvokeHelper(0x75, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

long WTable::get_TableDirection() {
  long result;
  InvokeHelper(0x76, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

void WTable::put_TableDirection(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x76, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

CString WTable::get_ID() {
  CString result;
  InvokeHelper(0x77, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}

void WTable::put_ID(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x77, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

VARIANT WTable::get_Style() {
  VARIANT result;
  InvokeHelper(0xc9, DISPATCH_PROPERTYGET, VT_VARIANT, (void*)&result, nullptr);
  return result;
}

void WTable::put_Style(VARIANT * newValue) {
  static BYTE parms[] = VTS_PVARIANT;
  InvokeHelper(0xc9, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

BOOL WTable::get_ApplyStyleHeadingRows() {
  BOOL result;
  InvokeHelper(0xca, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void WTable::put_ApplyStyleHeadingRows(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0xca, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

BOOL WTable::get_ApplyStyleLastRow() {
  BOOL result;
  InvokeHelper(0xcb, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void WTable::put_ApplyStyleLastRow(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0xcb, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

BOOL WTable::get_ApplyStyleFirstColumn() {
  BOOL result;
  InvokeHelper(0xcc, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void WTable::put_ApplyStyleFirstColumn(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0xcc, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

BOOL WTable::get_ApplyStyleLastColumn() {
  BOOL result;
  InvokeHelper(0xcd, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void WTable::put_ApplyStyleLastColumn(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0xcd, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

BOOL WTable::get_ApplyStyleRowBands() {
  BOOL result;
  InvokeHelper(0xce, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void WTable::put_ApplyStyleRowBands(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0xce, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

BOOL WTable::get_ApplyStyleColumnBands() {
  BOOL result;
  InvokeHelper(0xcf, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void WTable::put_ApplyStyleColumnBands(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0xcf, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

void WTable::ApplyStyleDirectFormatting(LPCTSTR StyleName) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0xd0, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, StyleName);
}

CString WTable::get_Title() {
  CString result;
  InvokeHelper(0xd1, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}

void WTable::put_Title(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0xd1, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

CString WTable::get_Descr() {
  CString result;
  InvokeHelper(0xd2, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}

void WTable::put_Descr(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0xd2, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

} // namespace MSO::Word

#pragma warning( pop )