#include "stdafx.h"

#include "office/word/WTables.h"

#include "office/word/WApplication.h"
#include "office/word/WTable.h"
#include "office/word/WRange.h"

#pragma warning( push )
#pragma warning( disable : 26493 26485 26494 )

namespace MSO::Word {

LPUNKNOWN WTables::get_NewEnum() {
  LPUNKNOWN result;
  InvokeHelper(0xfffffffc, DISPATCH_PROPERTYGET, VT_UNKNOWN, (void*)&result, nullptr);
  return result;
}

long WTables::get_Count() {
  long result;
  InvokeHelper(0x2, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

WApplication WTables::get_Application() {
  LPDISPATCH result;
  InvokeHelper(0x3e8, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

long WTables::get_Creator() {
  long result;
  InvokeHelper(0x3e9, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

LPDISPATCH WTables::get_Parent() {
  LPDISPATCH result;
  InvokeHelper(0x3ea, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

WTable WTables::get_Item(long IndexType) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x0, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, IndexType);
  return result;
}

WTable WTables::AddOld(LPDISPATCH Range, long NumRows, long NumColumns) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_DISPATCH VTS_I4 VTS_I4;
  InvokeHelper(0x4, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, Range, NumRows, NumColumns);
  return result;
}

WTable WTables::Add(WRange Range, long NumRows, long NumColumns, VARIANT* DefaultTableBehavior, VARIANT* AutoFitBehavior) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_DISPATCH VTS_I4 VTS_I4 VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0xc8, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, Range.m_lpDispatch, NumRows, NumColumns, DefaultTableBehavior, AutoFitBehavior);
  return result;
}

long WTables::get_NestingLevel() {
  long result;
  InvokeHelper(0x64, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

} // namespace MSO::Word

#pragma warning( pop )