#pragma once
// EXLRanges wrapper class

#include "office/VariantableDispatch.hpp"
#include "office/MSCollection.hpp"

namespace MSO::Excel {
  class EXLRange;

class EXLRanges :
  public VariantableDispatch,
  public MSCollection<EXLRanges, EXLRange> {
public:
  EXLRanges() = default;
  EXLRanges(LPDISPATCH pDispatch) : VariantableDispatch(pDispatch) {}
  EXLRanges(const EXLRanges& dispatchSrc) : VariantableDispatch(dispatchSrc) {}

public:
  LPDISPATCH get_Application();
  long get_Creator();
  LPDISPATCH get_Parent();
  LPDISPATCH get__Default(VARIANT IndexType);
  LPUNKNOWN get_NewEnum();
  LPDISPATCH get_Item(VARIANT IndexType);
  long get_Count();
};

} // namespace MSO::Excel
