#include "stdafx.h"

#include "office/excel/EXLApplication.h"
#include "office/excel/EXLWorkbooks.h"
#include "office/excel/EXLWorkbook.h"

#pragma warning( push )
#pragma warning( disable : 26493 26485 26494 )

namespace MSO::Excel {

EXLApplication EXLApplication::get_Application() {
  LPDISPATCH result;
  InvokeHelper(0x94, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

long EXLApplication::get_Creator() {
  long result;
  InvokeHelper(0x95, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

LPDISPATCH EXLApplication::get_Parent() {
  LPDISPATCH result;
  InvokeHelper(0x96, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH EXLApplication::get_ActiveCell() {
  LPDISPATCH result;
  InvokeHelper(0x131, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH EXLApplication::get_ActiveChart() {
  LPDISPATCH result;
  InvokeHelper(0xb7, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH EXLApplication::get_ActiveDialog() {
  LPDISPATCH result;
  InvokeHelper(0x32f, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH EXLApplication::get_ActiveMenuBar() {
  LPDISPATCH result;
  InvokeHelper(0x2f6, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

CString EXLApplication::get_ActivePrinter() {
  CString result;
  InvokeHelper(0x132, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_ActivePrinter(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x132, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

LPDISPATCH EXLApplication::get_ActiveSheet() {
  LPDISPATCH result;
  InvokeHelper(0x133, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH EXLApplication::get_ActiveWindow() {
  LPDISPATCH result;
  InvokeHelper(0x2f7, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH EXLApplication::get_ActiveWorkbook() {
  LPDISPATCH result;
  InvokeHelper(0x134, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH EXLApplication::get_AddIns() {
  LPDISPATCH result;
  InvokeHelper(0x225, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH EXLApplication::get_Assistant() {
  LPDISPATCH result;
  InvokeHelper(0x59e, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

void EXLApplication::Calculate() {
  InvokeHelper(0x117, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}

LPDISPATCH EXLApplication::get_Cells() {
  LPDISPATCH result;
  InvokeHelper(0xee, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH EXLApplication::get_Charts() {
  LPDISPATCH result;
  InvokeHelper(0x79, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH EXLApplication::get_Columns() {
  LPDISPATCH result;
  InvokeHelper(0xf1, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH EXLApplication::get_CommandBars() {
  LPDISPATCH result;
  InvokeHelper(0x59f, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

long EXLApplication::get_DDEAppReturnCode() {
  long result;
  InvokeHelper(0x14c, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

void EXLApplication::DDEExecute(long Channel, LPCTSTR String) {
  static BYTE parms[] = VTS_I4 VTS_BSTR;
  InvokeHelper(0x14d, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Channel, String);
}

long EXLApplication::DDEInitiate(LPCTSTR App, LPCTSTR Topic) {
  long result;
  static BYTE parms[] = VTS_BSTR VTS_BSTR;
  InvokeHelper(0x14e, DISPATCH_METHOD, VT_I4, (void*)&result, parms, App, Topic);
  return result;
}

void EXLApplication::DDEPoke(long Channel, VARIANT Item, VARIANT Data) {
  static BYTE parms[] = VTS_I4 VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x14f, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Channel, &Item, &Data);
}

VARIANT EXLApplication::DDERequest(long Channel, LPCTSTR Item) {
  VARIANT result;
  static BYTE parms[] = VTS_I4 VTS_BSTR;
  InvokeHelper(0x150, DISPATCH_METHOD, VT_VARIANT, (void*)&result, parms, Channel, Item);
  return result;
}

void EXLApplication::DDETerminate(long Channel) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x151, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Channel);
}

LPDISPATCH EXLApplication::get_DialogSheets() {
  LPDISPATCH result;
  InvokeHelper(0x2fc, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

VARIANT EXLApplication::Evaluate(VARIANT Name) {
  VARIANT result;
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0x1, DISPATCH_METHOD, VT_VARIANT, (void*)&result, parms, &Name);
  return result;
}

VARIANT EXLApplication::_Evaluate(VARIANT Name) {
  VARIANT result;
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0xfffffffb, DISPATCH_METHOD, VT_VARIANT, (void*)&result, parms, &Name);
  return result;
}

VARIANT EXLApplication::ExecuteExcel4Macro(LPCTSTR String) {
  VARIANT result;
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x15e, DISPATCH_METHOD, VT_VARIANT, (void*)&result, parms, String);
  return result;
}

LPDISPATCH EXLApplication::Intersect(LPDISPATCH Arg1, LPDISPATCH Arg2, VARIANT Arg3, VARIANT Arg4, VARIANT Arg5, VARIANT Arg6, VARIANT Arg7, VARIANT Arg8, VARIANT Arg9, VARIANT 
                                     Arg10, VARIANT Arg11, VARIANT Arg12, VARIANT Arg13, VARIANT Arg14, VARIANT Arg15, VARIANT Arg16, VARIANT Arg17, VARIANT Arg18, VARIANT Arg19, 
VARIANT Arg20, VARIANT Arg21, VARIANT Arg22, VARIANT Arg23, VARIANT Arg24, VARIANT Arg25, VARIANT Arg26, VARIANT Arg27, VARIANT Arg28, VARIANT Arg29, VARIANT Arg30) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_DISPATCH VTS_DISPATCH VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x2fe, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, Arg1, Arg2, &Arg3, &Arg4, &Arg5, &Arg6, &Arg7, &Arg8, &Arg9, &Arg10, &Arg11, &Arg12, &Arg13, &Arg14, &Arg15, &Arg16, &Arg17, &Arg18, &Arg19, &Arg20, &Arg21, &Arg22, &Arg23, &Arg24, &Arg25, &Arg26, &Arg27, &Arg28, &Arg29, &Arg30);
  return result;
}

LPDISPATCH EXLApplication::get_MenuBars() {
  LPDISPATCH result;
  InvokeHelper(0x24d, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH EXLApplication::get_Modules() {
  LPDISPATCH result;
  InvokeHelper(0x246, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH EXLApplication::get_Names() {
  LPDISPATCH result;
  InvokeHelper(0x1ba, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH EXLApplication::get_Range(VARIANT Cell1, VARIANT Cell2) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0xc5, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, parms, &Cell1, &Cell2);
  return result;
}

LPDISPATCH EXLApplication::get_Rows() {
  LPDISPATCH result;
  InvokeHelper(0x102, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

VARIANT EXLApplication::Run(VARIANT Macro, VARIANT Arg1, VARIANT Arg2, VARIANT Arg3, VARIANT Arg4, VARIANT Arg5, VARIANT Arg6, VARIANT Arg7, VARIANT Arg8, VARIANT Arg9, VARIANT Arg10, VARIANT Arg11, VARIANT Arg12, VARIANT Arg13, VARIANT Arg14, VARIANT Arg15, VARIANT Arg16, VARIANT Arg17, VARIANT Arg18, VARIANT Arg19, VARIANT Arg20, VARIANT Arg21, VARIANT Arg22, VARIANT Arg23, VARIANT Arg24, VARIANT Arg25, VARIANT Arg26, VARIANT Arg27, VARIANT Arg28, VARIANT Arg29, VARIANT Arg30) {
  VARIANT result;
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x103, DISPATCH_METHOD, VT_VARIANT, (void*)&result, parms, &Macro, &Arg1, &Arg2, &Arg3, &Arg4, &Arg5, &Arg6, &Arg7, &Arg8, &Arg9, &Arg10, &Arg11, &Arg12, &Arg13, &Arg14, &Arg15, &Arg16, &Arg17, &Arg18, &Arg19, &Arg20, &Arg21, &Arg22, &Arg23, &Arg24, &Arg25, &Arg26, &Arg27, &Arg28, &Arg29, &Arg30);
  return result;
}
VARIANT EXLApplication::_Run2(VARIANT Macro, VARIANT Arg1, VARIANT Arg2, VARIANT Arg3, VARIANT Arg4, VARIANT Arg5, VARIANT Arg6, VARIANT Arg7, VARIANT Arg8, VARIANT Arg9, VARIANT Arg10, VARIANT Arg11, VARIANT Arg12, VARIANT Arg13, VARIANT Arg14, VARIANT Arg15, VARIANT Arg16, VARIANT Arg17, VARIANT Arg18, VARIANT Arg19, VARIANT Arg20, VARIANT Arg21, VARIANT Arg22, VARIANT Arg23, VARIANT Arg24, VARIANT Arg25, VARIANT Arg26, VARIANT Arg27, VARIANT Arg28, VARIANT Arg29, VARIANT Arg30) {
  VARIANT result;
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x326, DISPATCH_METHOD, VT_VARIANT, (void*)&result, parms, &Macro, &Arg1, &Arg2, &Arg3, &Arg4, &Arg5, &Arg6, &Arg7, &Arg8, &Arg9, &Arg10, &Arg11, &Arg12, &Arg13, &Arg14, &Arg15, &Arg16, &Arg17, &Arg18, &Arg19, &Arg20, &Arg21, &Arg22, &Arg23, &Arg24, &Arg25, &Arg26, &Arg27, &Arg28, &Arg29, &Arg30);
  return result;
}

LPDISPATCH EXLApplication::get_Selection() {
  LPDISPATCH result;
  InvokeHelper(0x93, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

void EXLApplication::SendKeys(VARIANT Keys, VARIANT Wait) {
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x17f, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &Keys, &Wait);
}

LPDISPATCH EXLApplication::get_Sheets() {
  LPDISPATCH result;
  InvokeHelper(0x1e5, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH EXLApplication::get_ShortcutMenus(long IndexType) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x308, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, parms, IndexType);
  return result;
}

LPDISPATCH EXLApplication::get_ThisWorkbook() {
  LPDISPATCH result;
  InvokeHelper(0x30a, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH EXLApplication::get_Toolbars() {
  LPDISPATCH result;
  InvokeHelper(0x228, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH EXLApplication::Union(LPDISPATCH Arg1, LPDISPATCH Arg2, VARIANT Arg3, VARIANT Arg4, VARIANT Arg5, VARIANT Arg6, VARIANT Arg7, VARIANT Arg8, VARIANT Arg9, VARIANT Arg10, VARIANT Arg11, VARIANT Arg12, VARIANT Arg13, VARIANT Arg14, VARIANT Arg15, VARIANT Arg16, VARIANT Arg17, VARIANT Arg18, VARIANT Arg19, VARIANT Arg20, VARIANT Arg21, VARIANT Arg22, VARIANT Arg23, VARIANT Arg24, VARIANT Arg25, VARIANT Arg26, VARIANT Arg27, VARIANT Arg28, VARIANT Arg29, VARIANT Arg30) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_DISPATCH VTS_DISPATCH VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x30b, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, Arg1, Arg2, &Arg3, &Arg4, &Arg5, &Arg6, &Arg7, &Arg8, &Arg9, &Arg10, &Arg11, &Arg12, &Arg13, &Arg14, &Arg15, &Arg16, &Arg17, &Arg18, &Arg19, &Arg20, &Arg21, &Arg22, &Arg23, &Arg24, &Arg25, &Arg26, &Arg27, &Arg28, &Arg29, &Arg30);
  return result;
}

LPDISPATCH EXLApplication::get_Windows() {
  LPDISPATCH result;
  InvokeHelper(0x1ae, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

EXLWorkbooks EXLApplication::get_Workbooks() {
  LPDISPATCH result;
  InvokeHelper(0x23c, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH EXLApplication::get_WorksheetFunction() {
  LPDISPATCH result;
  InvokeHelper(0x5a0, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH EXLApplication::get_Worksheets() {
  LPDISPATCH result;
  InvokeHelper(0x1ee, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH EXLApplication::get_Excel4IntlMacroSheets() {
  LPDISPATCH result;
  InvokeHelper(0x245, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH EXLApplication::get_Excel4MacroSheets() {
  LPDISPATCH result;
  InvokeHelper(0x243, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

void EXLApplication::ActivateMicrosoftApp(long IndexType) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x447, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, IndexType);
}

void EXLApplication::AddChartAutoFormat(VARIANT Chart, LPCTSTR Name, VARIANT Description) {
  static BYTE parms[] = VTS_VARIANT VTS_BSTR VTS_VARIANT;
  InvokeHelper(0xd8, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &Chart, Name, &Description);
}

void EXLApplication::AddCustomList(VARIANT ListArray, VARIANT ByRow) {
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x30c, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &ListArray, &ByRow);
}

BOOL EXLApplication::get_AlertBeforeOverwriting() {
  BOOL result;
  InvokeHelper(0x3a2, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_AlertBeforeOverwriting(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x3a2, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

CString EXLApplication::get_AltStartupPath() {
  CString result;
  InvokeHelper(0x139, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_AltStartupPath(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x139, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

BOOL EXLApplication::get_AskToUpdateLinks() {
  BOOL result;
  InvokeHelper(0x3e0, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_AskToUpdateLinks(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x3e0, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

BOOL EXLApplication::get_EnableAnimations() {
  BOOL result;
  InvokeHelper(0x49c, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_EnableAnimations(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x49c, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

LPDISPATCH EXLApplication::get_AutoCorrect() {
  LPDISPATCH result;
  InvokeHelper(0x479, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

long EXLApplication::get_Build() {
  long result;
  InvokeHelper(0x13a, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

BOOL EXLApplication::get_CalculateBeforeSave() {
  BOOL result;
  InvokeHelper(0x13b, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_CalculateBeforeSave(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x13b, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

long EXLApplication::get_Calculation() {
  long result;
  InvokeHelper(0x13c, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_Calculation(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x13c, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

VARIANT EXLApplication::get_Caller(VARIANT IndexType) {
  VARIANT result;
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0x13d, DISPATCH_PROPERTYGET, VT_VARIANT, (void*)&result, parms, &IndexType);
  return result;
}

BOOL EXLApplication::get_CanPlaySounds() {
  BOOL result;
  InvokeHelper(0x13e, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

BOOL EXLApplication::get_CanRecordSounds() {
  BOOL result;
  InvokeHelper(0x13f, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

CString EXLApplication::get_Caption() {
  CString result;
  InvokeHelper(0x8b, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_Caption(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x8b, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

BOOL EXLApplication::get_CellDragAndDrop() {
  BOOL result;
  InvokeHelper(0x140, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_CellDragAndDrop(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x140, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

double EXLApplication::CentimetersToPoints(double Centimeters) {
  double result;
  static BYTE parms[] = VTS_R8;
  InvokeHelper(0x43e, DISPATCH_METHOD, VT_R8, (void*)&result, parms, Centimeters);
  return result;
}

BOOL EXLApplication::CheckSpelling(LPCTSTR Word, VARIANT CustomDictionary, VARIANT IgnoreUppercase) {
  BOOL result;
  static BYTE parms[] = VTS_BSTR VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x1f9, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms, Word, &CustomDictionary, &IgnoreUppercase);
  return result;
}

VARIANT EXLApplication::get_ClipboardFormats(VARIANT IndexType) {
  VARIANT result;
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0x141, DISPATCH_PROPERTYGET, VT_VARIANT, (void*)&result, parms, &IndexType);
  return result;
}

BOOL EXLApplication::get_DisplayClipboardWindow() {
  BOOL result;
  InvokeHelper(0x142, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_DisplayClipboardWindow(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x142, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

BOOL EXLApplication::get_ColorButtons() {
  BOOL result;
  InvokeHelper(0x16d, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_ColorButtons(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x16d, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

long EXLApplication::get_CommandUnderlines() {
  long result;
  InvokeHelper(0x143, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_CommandUnderlines(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x143, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

BOOL EXLApplication::get_ConstrainNumeric() {
  BOOL result;
  InvokeHelper(0x144, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_ConstrainNumeric(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x144, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

VARIANT EXLApplication::ConvertFormula(VARIANT Formula, long FromReferenceStyle, VARIANT ToReferenceStyle, VARIANT ToAbsolute, VARIANT RelativeTo) {
  VARIANT result;
  static BYTE parms[] = VTS_VARIANT VTS_I4 VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x145, DISPATCH_METHOD, VT_VARIANT, (void*)&result, parms, &Formula, FromReferenceStyle, &ToReferenceStyle, &ToAbsolute, &RelativeTo);
  return result;
}

BOOL EXLApplication::get_CopyObjectsWithCells() {
  BOOL result;
  InvokeHelper(0x3df, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_CopyObjectsWithCells(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x3df, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

long EXLApplication::get_Cursor() {
  long result;
  InvokeHelper(0x489, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_Cursor(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x489, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

long EXLApplication::get_CustomListCount() {
  long result;
  InvokeHelper(0x313, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

long EXLApplication::get_CutCopyMode() {
  long result;
  InvokeHelper(0x14a, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_CutCopyMode(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x14a, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

long EXLApplication::get_DataEntryMode() {
  long result;
  InvokeHelper(0x14b, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_DataEntryMode(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x14b, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

VARIANT EXLApplication::Dummy1(VARIANT Arg1, VARIANT Arg2, VARIANT Arg3, VARIANT Arg4) {
  VARIANT result;
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x6f6, DISPATCH_METHOD, VT_VARIANT, (void*)&result, parms, &Arg1, &Arg2, &Arg3, &Arg4);
  return result;
}

VARIANT EXLApplication::Dummy2(VARIANT Arg1, VARIANT Arg2, VARIANT Arg3, VARIANT Arg4, VARIANT Arg5, VARIANT Arg6, VARIANT Arg7, VARIANT Arg8) {
  VARIANT result;
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x6f7, DISPATCH_METHOD, VT_VARIANT, (void*)&result, parms, &Arg1, &Arg2, &Arg3, &Arg4, &Arg5, &Arg6, &Arg7, &Arg8);
  return result;
}

VARIANT EXLApplication::Dummy3() {
  VARIANT result;
  InvokeHelper(0x6f8, DISPATCH_METHOD, VT_VARIANT, (void*)&result, nullptr);
  return result;
}

VARIANT EXLApplication::Dummy4(VARIANT Arg1, VARIANT Arg2, VARIANT Arg3, VARIANT Arg4, VARIANT Arg5, VARIANT Arg6, VARIANT Arg7, VARIANT Arg8, VARIANT Arg9, VARIANT Arg10, VARIANT 
Arg11, VARIANT Arg12, VARIANT Arg13, VARIANT Arg14, VARIANT Arg15) {
  VARIANT result;
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x6f9, DISPATCH_METHOD, VT_VARIANT, (void*)&result, parms, &Arg1, &Arg2, &Arg3, &Arg4, &Arg5, &Arg6, &Arg7, &Arg8, &Arg9, &Arg10, &Arg11, &Arg12, &Arg13, &Arg14, &Arg15);
  return result;
}

VARIANT EXLApplication::Dummy5(VARIANT Arg1, VARIANT Arg2, VARIANT Arg3, VARIANT Arg4, VARIANT Arg5, VARIANT Arg6, VARIANT Arg7, VARIANT Arg8, VARIANT Arg9, VARIANT Arg10, VARIANT Arg11, VARIANT Arg12, VARIANT Arg13) {
  VARIANT result;
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x6fa, DISPATCH_METHOD, VT_VARIANT, (void*)&result, parms, &Arg1, &Arg2, &Arg3, &Arg4, &Arg5, &Arg6, &Arg7, &Arg8, &Arg9, &Arg10, &Arg11, &Arg12, &Arg13);
  return result;
}

VARIANT EXLApplication::Dummy6() {
  VARIANT result;
  InvokeHelper(0x6fb, DISPATCH_METHOD, VT_VARIANT, (void*)&result, nullptr);
  return result;
}

VARIANT EXLApplication::Dummy7() {
  VARIANT result;
  InvokeHelper(0x6fc, DISPATCH_METHOD, VT_VARIANT, (void*)&result, nullptr);
  return result;
}

VARIANT EXLApplication::Dummy8(VARIANT Arg1) {
  VARIANT result;
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0x6fd, DISPATCH_METHOD, VT_VARIANT, (void*)&result, parms, &Arg1);
  return result;
}

VARIANT EXLApplication::Dummy9() {
  VARIANT result;
  InvokeHelper(0x6fe, DISPATCH_METHOD, VT_VARIANT, (void*)&result, nullptr);
  return result;
}

BOOL EXLApplication::Dummy10(VARIANT arg) {
  BOOL result;
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0x6ff, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms, &arg);
  return result;
}

void EXLApplication::Dummy11() {
  InvokeHelper(0x700, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}

CString EXLApplication::get__Default() {
  CString result;
  InvokeHelper(0x0, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}

CString EXLApplication::get_DefaultFilePath() {
  CString result;
  InvokeHelper(0x40e, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_DefaultFilePath(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x40e, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

void EXLApplication::DeleteChartAutoFormat(LPCTSTR Name) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0xd9, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Name);
}

void EXLApplication::DeleteCustomList(long ListNum) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x30f, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, ListNum);
}

LPDISPATCH EXLApplication::get_Dialogs() {
  LPDISPATCH result;
  InvokeHelper(0x2f9, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

BOOL EXLApplication::get_DisplayAlerts() {
  BOOL result;
  InvokeHelper(0x157, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_DisplayAlerts(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x157, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

BOOL EXLApplication::get_DisplayFormulaBar() {
  BOOL result;
  InvokeHelper(0x158, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_DisplayFormulaBar(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x158, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

BOOL EXLApplication::get_DisplayFullScreen() {
  BOOL result;
  InvokeHelper(0x425, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_DisplayFullScreen(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x425, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

BOOL EXLApplication::get_DisplayNoteIndicator() {
  BOOL result;
  InvokeHelper(0x159, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_DisplayNoteIndicator(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x159, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

long EXLApplication::get_DisplayCommentIndicator() {
  long result;
  InvokeHelper(0x4ac, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_DisplayCommentIndicator(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x4ac, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

BOOL EXLApplication::get_DisplayExcel4Menus() {
  BOOL result;
  InvokeHelper(0x39f, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_DisplayExcel4Menus(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x39f, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

BOOL EXLApplication::get_DisplayRecentFiles() {
  BOOL result;
  InvokeHelper(0x39e, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_DisplayRecentFiles(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x39e, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

BOOL EXLApplication::get_DisplayScrollBars() {
  BOOL result;
  InvokeHelper(0x15a, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_DisplayScrollBars(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x15a, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

BOOL EXLApplication::get_DisplayStatusBar() {
  BOOL result;
  InvokeHelper(0x15b, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_DisplayStatusBar(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x15b, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

void EXLApplication::DoubleClick() {
  InvokeHelper(0x15d, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}

BOOL EXLApplication::get_EditDirectlyInCell() {
  BOOL result;
  InvokeHelper(0x3a1, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_EditDirectlyInCell(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x3a1, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

BOOL EXLApplication::get_EnableAutoComplete() {
  BOOL result;
  InvokeHelper(0x49b, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_EnableAutoComplete(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x49b, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

long EXLApplication::get_EnableCancelKey() {
  long result;
  InvokeHelper(0x448, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_EnableCancelKey(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x448, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

BOOL EXLApplication::get_EnableSound() {
  BOOL result;
  InvokeHelper(0x4ad, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_EnableSound(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x4ad, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

BOOL EXLApplication::get_EnableTipWizard() {
  BOOL result;
  InvokeHelper(0x428, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_EnableTipWizard(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x428, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

VARIANT EXLApplication::get_FileConverters(VARIANT Index1, VARIANT Index2) {
  VARIANT result;
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x3a3, DISPATCH_PROPERTYGET, VT_VARIANT, (void*)&result, parms, &Index1, &Index2);
  return result;
}

LPDISPATCH EXLApplication::get_FileSearch() {
  LPDISPATCH result;
  InvokeHelper(0x4b0, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH EXLApplication::get_FileFind() {
  LPDISPATCH result;
  InvokeHelper(0x4b1, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

void EXLApplication::_FindFile() {
  InvokeHelper(0x42c, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}

BOOL EXLApplication::get_FixedDecimal() {
  BOOL result;
  InvokeHelper(0x15f, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_FixedDecimal(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x15f, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

long EXLApplication::get_FixedDecimalPlaces() {
  long result;
  InvokeHelper(0x160, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_FixedDecimalPlaces(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x160, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

VARIANT EXLApplication::GetCustomListContents(long ListNum) {
  VARIANT result;
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x312, DISPATCH_METHOD, VT_VARIANT, (void*)&result, parms, ListNum);
  return result;
}

long EXLApplication::GetCustomListNum(VARIANT ListArray) {
  long result;
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0x311, DISPATCH_METHOD, VT_I4, (void*)&result, parms, &ListArray);
  return result;
}

VARIANT EXLApplication::GetOpenFilename(VARIANT FileFilter, VARIANT FilterIndex, VARIANT Title, VARIANT ButtonText, VARIANT MultiSelect) {
  VARIANT result;
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x433, DISPATCH_METHOD, VT_VARIANT, (void*)&result, parms, &FileFilter, &FilterIndex, &Title, &ButtonText, &MultiSelect);
  return result;
}

VARIANT EXLApplication::GetSaveAsFilename(VARIANT InitialFilename, VARIANT FileFilter, VARIANT FilterIndex, VARIANT Title, VARIANT ButtonText) {
  VARIANT result;
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x434, DISPATCH_METHOD, VT_VARIANT, (void*)&result, parms, &InitialFilename, &FileFilter, &FilterIndex, &Title, &ButtonText);
  return result;
}

void EXLApplication::Goto(VARIANT Reference, VARIANT Scroll) {
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x1db, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &Reference, &Scroll);
}

double EXLApplication::get_Height() {
  double result;
  InvokeHelper(0x7b, DISPATCH_PROPERTYGET, VT_R8, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_Height(double newValue) {
  static BYTE parms[] = VTS_R8;
  InvokeHelper(0x7b, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

void EXLApplication::Help(VARIANT HelpFile, VARIANT HelpContextID) {
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x162, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &HelpFile, &HelpContextID);
}

BOOL EXLApplication::get_IgnoreRemoteRequests() {
  BOOL result;
  InvokeHelper(0x164, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_IgnoreRemoteRequests(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x164, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

double EXLApplication::InchesToPoints(double Inches) {
  double result;
  static BYTE parms[] = VTS_R8;
  InvokeHelper(0x43f, DISPATCH_METHOD, VT_R8, (void*)&result, parms, Inches);
  return result;
}

VARIANT EXLApplication::InputBox(LPCTSTR Prompt, VARIANT Title, VARIANT Default, VARIANT Left, VARIANT Top, VARIANT HelpFile, VARIANT HelpContextID, VARIANT Type) {
  VARIANT result;
  static BYTE parms[] = VTS_BSTR VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x165, DISPATCH_METHOD, VT_VARIANT, (void*)&result, parms, Prompt, &Title, &Default, &Left, &Top, &HelpFile, &HelpContextID, &Type);
  return result;
}

BOOL EXLApplication::get_Interactive() {
  BOOL result;
  InvokeHelper(0x169, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_Interactive(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x169, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

VARIANT EXLApplication::get_International(VARIANT IndexType) {
  VARIANT result;
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0x16a, DISPATCH_PROPERTYGET, VT_VARIANT, (void*)&result, parms, &IndexType);
  return result;
}

BOOL EXLApplication::get_Iteration() {
  BOOL result;
  InvokeHelper(0x16b, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_Iteration(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x16b, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

BOOL EXLApplication::get_LargeButtons() {
  BOOL result;
  InvokeHelper(0x16c, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_LargeButtons(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x16c, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

double EXLApplication::get_Left() {
  double result;
  InvokeHelper(0x7f, DISPATCH_PROPERTYGET, VT_R8, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_Left(double newValue) {
  static BYTE parms[] = VTS_R8;
  InvokeHelper(0x7f, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

CString EXLApplication::get_LibraryPath() {
  CString result;
  InvokeHelper(0x16e, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}

void EXLApplication::_MacroOptions(VARIANT Macro, VARIANT Description, VARIANT HasMenu, VARIANT MenuText, VARIANT HasShortcutKey, VARIANT ShortcutKey, VARIANT Category, VARIANT 
StatusBar, VARIANT HelpContextID, VARIANT HelpFile) {
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x46f, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &Macro, &Description, &HasMenu, &MenuText, &HasShortcutKey, &ShortcutKey, &Category, &StatusBar, &HelpContextID, &HelpFile);
}

void EXLApplication::MailLogoff() {
  InvokeHelper(0x3b1, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}

void EXLApplication::MailLogon(VARIANT Name, VARIANT Password, VARIANT DownloadNewMail) {
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x3af, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &Name, &Password, &DownloadNewMail);
}

VARIANT EXLApplication::get_MailSession() {
  VARIANT result;
  InvokeHelper(0x3ae, DISPATCH_PROPERTYGET, VT_VARIANT, (void*)&result, nullptr);
  return result;
}

long EXLApplication::get_MailSystem() {
  long result;
  InvokeHelper(0x3cb, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

BOOL EXLApplication::get_MathCoprocessorAvailable() {
  BOOL result;
  InvokeHelper(0x16f, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

double EXLApplication::get_MaxChange() {
  double result;
  InvokeHelper(0x170, DISPATCH_PROPERTYGET, VT_R8, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_MaxChange(double newValue) {
  static BYTE parms[] = VTS_R8;
  InvokeHelper(0x170, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

long EXLApplication::get_MaxIterations() {
  long result;
  InvokeHelper(0x171, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_MaxIterations(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x171, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

long EXLApplication::get_MemoryFree() {
  long result;
  InvokeHelper(0x172, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

long EXLApplication::get_MemoryTotal() {
  long result;
  InvokeHelper(0x173, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

long EXLApplication::get_MemoryUsed() {
  long result;
  InvokeHelper(0x174, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

BOOL EXLApplication::get_MouseAvailable() {
  BOOL result;
  InvokeHelper(0x175, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

BOOL EXLApplication::get_MoveAfterReturn() {
  BOOL result;
  InvokeHelper(0x176, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_MoveAfterReturn(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x176, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

long EXLApplication::get_MoveAfterReturnDirection() {
  long result;
  InvokeHelper(0x478, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_MoveAfterReturnDirection(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x478, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

LPDISPATCH EXLApplication::get_RecentFiles() {
  LPDISPATCH result;
  InvokeHelper(0x4b2, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

CString EXLApplication::get_Name() {
  CString result;
  InvokeHelper(0x6e, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}

LPDISPATCH EXLApplication::NextLetter() {
  LPDISPATCH result;
  InvokeHelper(0x3cc, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

CString EXLApplication::get_NetworkTemplatesPath() {
  CString result;
  InvokeHelper(0x184, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}

LPDISPATCH EXLApplication::get_ODBCErrors() {
  LPDISPATCH result;
  InvokeHelper(0x4b3, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

long EXLApplication::get_ODBCTimeout() {
  long result;
  InvokeHelper(0x4b4, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_ODBCTimeout(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x4b4, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

CString EXLApplication::get_OnCalculate() {
  CString result;
  InvokeHelper(0x271, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_OnCalculate(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x271, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

CString EXLApplication::get_OnData() {
  CString result;
  InvokeHelper(0x275, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_OnData(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x275, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

CString EXLApplication::get_OnDoubleClick() {
  CString result;
  InvokeHelper(0x274, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_OnDoubleClick(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x274, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

CString EXLApplication::get_OnEntry() {
  CString result;
  InvokeHelper(0x273, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_OnEntry(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x273, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

void EXLApplication::OnKey(LPCTSTR Key, VARIANT Procedure) {
  static BYTE parms[] = VTS_BSTR VTS_VARIANT;
  InvokeHelper(0x272, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Key, &Procedure);
}

void EXLApplication::OnRepeat(LPCTSTR Text, LPCTSTR Procedure) {
  static BYTE parms[] = VTS_BSTR VTS_BSTR;
  InvokeHelper(0x301, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Text, Procedure);
}

CString EXLApplication::get_OnSheetActivate() {
  CString result;
  InvokeHelper(0x407, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_OnSheetActivate(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x407, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}


CString EXLApplication::get_OnSheetDeactivate() {
  CString result;
  InvokeHelper(0x439, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_OnSheetDeactivate(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x439, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

void EXLApplication::OnTime(VARIANT EarliestTime, LPCTSTR Procedure, VARIANT LatestTime, VARIANT Schedule) {
  static BYTE parms[] = VTS_VARIANT VTS_BSTR VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x270, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &EarliestTime, Procedure, &LatestTime, &Schedule);
}

void EXLApplication::OnUndo(LPCTSTR Text, LPCTSTR Procedure) {
  static BYTE parms[] = VTS_BSTR VTS_BSTR;
  InvokeHelper(0x302, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Text, Procedure);
}

CString EXLApplication::get_OnWindow() {
  CString result;
  InvokeHelper(0x26f, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_OnWindow(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x26f, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

CString EXLApplication::get_OperatingSystem() {
  CString result;
  InvokeHelper(0x177, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}

CString EXLApplication::get_OrganizationName() {
  CString result;
  InvokeHelper(0x178, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}

CString EXLApplication::get_Path() {
  CString result;
  InvokeHelper(0x123, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}

CString EXLApplication::get_PathSeparator() {
  CString result;
  InvokeHelper(0x179, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}

VARIANT EXLApplication::get_PreviousSelections(VARIANT IndexType) {
  VARIANT result;
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0x17a, DISPATCH_PROPERTYGET, VT_VARIANT, (void*)&result, parms, &IndexType);
  return result;
}

BOOL EXLApplication::get_PivotTableSelection() {
  BOOL result;
  InvokeHelper(0x4b5, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_PivotTableSelection(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x4b5, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

BOOL EXLApplication::get_PromptForSummaryInfo() {
  BOOL result;
  InvokeHelper(0x426, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_PromptForSummaryInfo(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x426, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

void EXLApplication::Quit() {
  InvokeHelper(0x12e, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}

void EXLApplication::RecordMacro(VARIANT BasicCode, VARIANT XlmCode) {
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x305, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &BasicCode, &XlmCode);
}

BOOL EXLApplication::get_RecordRelative() {
  BOOL result;
  InvokeHelper(0x17b, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

long EXLApplication::get_ReferenceStyle() {
  long result;
  InvokeHelper(0x17c, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_ReferenceStyle(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x17c, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

VARIANT EXLApplication::get_RegisteredFunctions(VARIANT Index1, VARIANT Index2) {
  VARIANT result;
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x307, DISPATCH_PROPERTYGET, VT_VARIANT, (void*)&result, parms, &Index1, &Index2);
  return result;
}

BOOL EXLApplication::RegisterXLL(LPCTSTR Filename) {
  BOOL result;
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x1e, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms, Filename);
  return result;
}

void EXLApplication::Repeat() {
  InvokeHelper(0x12d, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}

void EXLApplication::ResetTipWizard() {
  InvokeHelper(0x3a0, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}

BOOL EXLApplication::get_RollZoom() {
  BOOL result;
  InvokeHelper(0x4b6, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_RollZoom(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x4b6, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

void EXLApplication::Save(VARIANT Filename) {
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0x11b, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &Filename);
}

void EXLApplication::SaveWorkspace(VARIANT Filename) {
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0xd4, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &Filename);
}

BOOL EXLApplication::get_ScreenUpdating() {
  BOOL result;
  InvokeHelper(0x17e, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_ScreenUpdating(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x17e, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

void EXLApplication::SetDefaultChart(VARIANT FormatName, VARIANT Gallery) {
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0xdb, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &FormatName, &Gallery);
}

long EXLApplication::get_SheetsInNewWorkbook() {
  long result;
  InvokeHelper(0x3e1, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_SheetsInNewWorkbook(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x3e1, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

BOOL EXLApplication::get_ShowChartTipNames() {
  BOOL result;
  InvokeHelper(0x4b7, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_ShowChartTipNames(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x4b7, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

BOOL EXLApplication::get_ShowChartTipValues() {
  BOOL result;
  InvokeHelper(0x4b8, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_ShowChartTipValues(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x4b8, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

CString EXLApplication::get_StandardFont() {
  CString result;
  InvokeHelper(0x39c, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_StandardFont(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x39c, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

double EXLApplication::get_StandardFontSize() {
  double result;
  InvokeHelper(0x39d, DISPATCH_PROPERTYGET, VT_R8, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_StandardFontSize(double newValue) {
  static BYTE parms[] = VTS_R8;
  InvokeHelper(0x39d, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

CString EXLApplication::get_StartupPath() {
  CString result;
  InvokeHelper(0x181, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}

VARIANT EXLApplication::get_StatusBar() {
  VARIANT result;
  InvokeHelper(0x182, DISPATCH_PROPERTYGET, VT_VARIANT, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_StatusBar(VARIANT newValue) {
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0x182, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, &newValue);
}

CString EXLApplication::get_TemplatesPath() {
  CString result;
  InvokeHelper(0x17d, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}

BOOL EXLApplication::get_ShowToolTips() {
  BOOL result;
  InvokeHelper(0x183, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_ShowToolTips(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x183, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

double EXLApplication::get_Top() {
  double result;
  InvokeHelper(0x7e, DISPATCH_PROPERTYGET, VT_R8, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_Top(double newValue) {
  static BYTE parms[] = VTS_R8;
  InvokeHelper(0x7e, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

long EXLApplication::get_DefaultSaveFormat() {
  long result;
  InvokeHelper(0x4b9, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_DefaultSaveFormat(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x4b9, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

CString EXLApplication::get_TransitionMenuKey() {
  CString result;
  InvokeHelper(0x136, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_TransitionMenuKey(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x136, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

long EXLApplication::get_TransitionMenuKeyAction() {
  long result;
  InvokeHelper(0x137, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_TransitionMenuKeyAction(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x137, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

BOOL EXLApplication::get_TransitionNavigKeys() {
  BOOL result;
  InvokeHelper(0x138, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_TransitionNavigKeys(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x138, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

void EXLApplication::Undo() {
  InvokeHelper(0x12f, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}

double EXLApplication::get_UsableHeight() {
  double result;
  InvokeHelper(0x185, DISPATCH_PROPERTYGET, VT_R8, (void*)&result, nullptr);
  return result;
}

double EXLApplication::get_UsableWidth() {
  double result;
  InvokeHelper(0x186, DISPATCH_PROPERTYGET, VT_R8, (void*)&result, nullptr);
  return result;
}

BOOL EXLApplication::get_UserControl() {
  BOOL result;
  InvokeHelper(0x4ba, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_UserControl(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x4ba, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

CString EXLApplication::get_UserName() {
  CString result;
  InvokeHelper(0x187, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_UserName(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x187, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

CString EXLApplication::get_Value() {
  CString result;
  InvokeHelper(0x6, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}

LPDISPATCH EXLApplication::get_VBE() {
  LPDISPATCH result;
  InvokeHelper(0x4bb, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

CString EXLApplication::get_Version() {
  CString result;
  InvokeHelper(0x188, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}

BOOL EXLApplication::get_Visible() {
  BOOL result;
  InvokeHelper(0x22e, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_Visible(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x22e, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

void EXLApplication::Volatile(VARIANT Volatile) {
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0x314, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &Volatile);
}

void EXLApplication::_Wait(VARIANT Time) {
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0x189, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &Time);
}

double EXLApplication::get_Width() {
  double result;
  InvokeHelper(0x7a, DISPATCH_PROPERTYGET, VT_R8, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_Width(double newValue) {
  static BYTE parms[] = VTS_R8;
  InvokeHelper(0x7a, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

BOOL EXLApplication::get_WindowsForPens() {
  BOOL result;
  InvokeHelper(0x18b, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

long EXLApplication::get_WindowState() {
  long result;
  InvokeHelper(0x18c, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_WindowState(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x18c, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

long EXLApplication::get_UILanguage() {
  long result;
  InvokeHelper(0x2, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_UILanguage(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x2, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

long EXLApplication::get_DefaultSheetDirection() {
  long result;
  InvokeHelper(0xe5, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_DefaultSheetDirection(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0xe5, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

long EXLApplication::get_CursorMovement() {
  long result;
  InvokeHelper(0xe8, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_CursorMovement(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0xe8, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

BOOL EXLApplication::get_ControlCharacters() {
  BOOL result;
  InvokeHelper(0xe9, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_ControlCharacters(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0xe9, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
VARIANT EXLApplication::_WSFunction(VARIANT Arg1, VARIANT Arg2, VARIANT Arg3, VARIANT Arg4, VARIANT Arg5, VARIANT Arg6, VARIANT Arg7, VARIANT Arg8, VARIANT Arg9, VARIANT Arg10, VARIANT Arg11, VARIANT Arg12, VARIANT Arg13, VARIANT Arg14, VARIANT Arg15, VARIANT Arg16, VARIANT Arg17, VARIANT Arg18, VARIANT Arg19, VARIANT Arg20, VARIANT Arg21, VARIANT Arg22, VARIANT Arg23, VARIANT Arg24, VARIANT Arg25, VARIANT Arg26, VARIANT Arg27, VARIANT Arg28, VARIANT Arg29, VARIANT Arg30) {
  VARIANT result;
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0xa9, DISPATCH_METHOD, VT_VARIANT, (void*)&result, parms, &Arg1, &Arg2, &Arg3, &Arg4, &Arg5, &Arg6, &Arg7, &Arg8, &Arg9, &Arg10, &Arg11, &Arg12, &Arg13, &Arg14, &Arg15, &Arg16, &Arg17, &Arg18, &Arg19, &Arg20, &Arg21, &Arg22, &Arg23, &Arg24, &Arg25, &Arg26, &Arg27, &Arg28, &Arg29, &Arg30);
  return result;
}

BOOL EXLApplication::get_EnableEvents() {
  BOOL result;
  InvokeHelper(0x4bc, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_EnableEvents(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x4bc, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

BOOL EXLApplication::get_DisplayInfoWindow() {
  BOOL result;
  InvokeHelper(0x4bd, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_DisplayInfoWindow(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x4bd, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

BOOL EXLApplication::Wait(VARIANT Time) {
  BOOL result;
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0x6ea, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms, &Time);
  return result;
}

BOOL EXLApplication::get_ExtendList() {
  BOOL result;
  InvokeHelper(0x701, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_ExtendList(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x701, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

LPDISPATCH EXLApplication::get_OLEDBErrors() {
  LPDISPATCH result;
  InvokeHelper(0x702, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

CString EXLApplication::GetPhonetic(VARIANT Text) {
  CString result;
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0x703, DISPATCH_METHOD, VT_BSTR, (void*)&result, parms, &Text);
  return result;
}

LPDISPATCH EXLApplication::get_COMAddIns() {
  LPDISPATCH result;
  InvokeHelper(0x704, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH EXLApplication::get_DefaultWebOptions() {
  LPDISPATCH result;
  InvokeHelper(0x705, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

CString EXLApplication::get_ProductCode() {
  CString result;
  InvokeHelper(0x706, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}

CString EXLApplication::get_UserLibraryPath() {
  CString result;
  InvokeHelper(0x707, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}

BOOL EXLApplication::get_AutoPercentEntry() {
  BOOL result;
  InvokeHelper(0x708, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_AutoPercentEntry(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x708, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

LPDISPATCH EXLApplication::get_LanguageSettings() {
  LPDISPATCH result;
  InvokeHelper(0x709, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH EXLApplication::get_Dummy101() {
  LPDISPATCH result;
  InvokeHelper(0x70a, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

void EXLApplication::Dummy12(LPDISPATCH p1, LPDISPATCH p2) {
  static BYTE parms[] = VTS_DISPATCH VTS_DISPATCH;
  InvokeHelper(0x70b, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, p1, p2);
}

LPDISPATCH EXLApplication::get_AnswerWizard() {
  LPDISPATCH result;
  InvokeHelper(0x70c, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

void EXLApplication::CalculateFull() {
  InvokeHelper(0x70d, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}

BOOL EXLApplication::FindFile() {
  BOOL result;
  InvokeHelper(0x6eb, DISPATCH_METHOD, VT_BOOL, (void*)&result, nullptr);
  return result;
}

long EXLApplication::get_CalculationVersion() {
  long result;
  InvokeHelper(0x70e, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

BOOL EXLApplication::get_ShowWindowsInTaskbar() {
  BOOL result;
  InvokeHelper(0x70f, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_ShowWindowsInTaskbar(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x70f, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

long EXLApplication::get_FeatureInstall() {
  long result;
  InvokeHelper(0x710, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_FeatureInstall(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x710, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

BOOL EXLApplication::get_Ready() {
  BOOL result;
  InvokeHelper(0x78c, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
VARIANT EXLApplication::Dummy13(VARIANT Arg1, VARIANT Arg2, VARIANT Arg3, VARIANT Arg4, VARIANT Arg5, VARIANT Arg6, VARIANT Arg7, VARIANT Arg8, VARIANT Arg9, VARIANT Arg10, VARIANT Arg11, VARIANT Arg12, VARIANT Arg13, VARIANT Arg14, VARIANT Arg15, VARIANT Arg16, VARIANT Arg17, VARIANT Arg18, VARIANT Arg19, VARIANT Arg20, VARIANT Arg21, VARIANT Arg22, 
VARIANT Arg23, VARIANT Arg24, VARIANT Arg25, VARIANT Arg26, VARIANT Arg27, VARIANT Arg28, VARIANT Arg29, VARIANT Arg30) {
  VARIANT result;
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0x78d, DISPATCH_METHOD, VT_VARIANT, (void*)&result, parms, &Arg1, &Arg2, &Arg3, &Arg4, &Arg5, &Arg6, &Arg7, &Arg8, &Arg9, &Arg10, &Arg11, &Arg12, &Arg13, &Arg14, &Arg15, &Arg16, &Arg17, &Arg18, &Arg19, &Arg20, &Arg21, &Arg22, &Arg23, &Arg24, &Arg25, &Arg26, &Arg27, &Arg28, &Arg29, &Arg30);
  return result;
}

LPDISPATCH EXLApplication::get_FindFormat() {
  LPDISPATCH result;
  InvokeHelper(0x78e, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

void EXLApplication::putref_FindFormat(LPDISPATCH newValue) {
  static BYTE parms[] = VTS_DISPATCH;
  InvokeHelper(0x78e, DISPATCH_PROPERTYPUTREF, VT_EMPTY, nullptr, parms, newValue);
}

LPDISPATCH EXLApplication::get_ReplaceFormat() {
  LPDISPATCH result;
  InvokeHelper(0x78f, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

void EXLApplication::putref_ReplaceFormat(LPDISPATCH newValue) {
  static BYTE parms[] = VTS_DISPATCH;
  InvokeHelper(0x78f, DISPATCH_PROPERTYPUTREF, VT_EMPTY, nullptr, parms, newValue);
}

LPDISPATCH EXLApplication::get_UsedObjects() {
  LPDISPATCH result;
  InvokeHelper(0x790, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

long EXLApplication::get_CalculationState() {
  long result;
  InvokeHelper(0x791, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

long EXLApplication::get_CalculationInterruptKey() {
  long result;
  InvokeHelper(0x792, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_CalculationInterruptKey(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x792, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

LPDISPATCH EXLApplication::get_Watches() {
  LPDISPATCH result;
  InvokeHelper(0x793, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

BOOL EXLApplication::get_DisplayFunctionToolTips() {
  BOOL result;
  InvokeHelper(0x794, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_DisplayFunctionToolTips(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x794, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

long EXLApplication::get_AutomationSecurity() {
  long result;
  InvokeHelper(0x795, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_AutomationSecurity(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x795, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

LPDISPATCH EXLApplication::get_FileDialog(long fileDialogType) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x796, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, parms, fileDialogType);
  return result;
}

void EXLApplication::Dummy14() {
  InvokeHelper(0x798, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}

void EXLApplication::CalculateFullRebuild() {
  InvokeHelper(0x799, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}

BOOL EXLApplication::get_DisplayPasteOptions() {
  BOOL result;
  InvokeHelper(0x79a, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_DisplayPasteOptions(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x79a, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

BOOL EXLApplication::get_DisplayInsertOptions() {
  BOOL result;
  InvokeHelper(0x79b, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_DisplayInsertOptions(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x79b, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

BOOL EXLApplication::get_GenerateGetPivotData() {
  BOOL result;
  InvokeHelper(0x79c, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_GenerateGetPivotData(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x79c, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

LPDISPATCH EXLApplication::get_AutoRecover() {
  LPDISPATCH result;
  InvokeHelper(0x79d, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

long EXLApplication::get_Hwnd() {
  long result;
  InvokeHelper(0x79e, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

long EXLApplication::get_Hinstance() {
  long result;
  InvokeHelper(0x79f, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

void EXLApplication::CheckAbort(VARIANT KeepAbort) {
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0x7a0, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &KeepAbort);
}

LPDISPATCH EXLApplication::get_ErrorCheckingOptions() {
  LPDISPATCH result;
  InvokeHelper(0x7a2, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

BOOL EXLApplication::get_AutoFormatAsYouTypeReplaceHyperlinks() {
  BOOL result;
  InvokeHelper(0x7a3, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_AutoFormatAsYouTypeReplaceHyperlinks(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x7a3, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

LPDISPATCH EXLApplication::get_SmartTagRecognizers() {
  LPDISPATCH result;
  InvokeHelper(0x7a4, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH EXLApplication::get_NewWorkbook() {
  LPDISPATCH result;
  InvokeHelper(0x61d, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH EXLApplication::get_SpellingOptions() {
  LPDISPATCH result;
  InvokeHelper(0x7a5, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH EXLApplication::get_Speech() {
  LPDISPATCH result;
  InvokeHelper(0x7a6, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

BOOL EXLApplication::get_MapPaperSize() {
  BOOL result;
  InvokeHelper(0x7a7, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_MapPaperSize(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x7a7, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

BOOL EXLApplication::get_ShowStartupDialog() {
  BOOL result;
  InvokeHelper(0x7a8, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_ShowStartupDialog(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x7a8, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

CString EXLApplication::get_DecimalSeparator() {
  CString result;
  InvokeHelper(0x711, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_DecimalSeparator(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x711, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

CString EXLApplication::get_ThousandsSeparator() {
  CString result;
  InvokeHelper(0x712, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_ThousandsSeparator(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x712, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

BOOL EXLApplication::get_UseSystemSeparators() {
  BOOL result;
  InvokeHelper(0x7a9, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_UseSystemSeparators(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x7a9, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

LPDISPATCH EXLApplication::get_ThisCell() {
  LPDISPATCH result;
  InvokeHelper(0x7aa, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH EXLApplication::get_RTD() {
  LPDISPATCH result;
  InvokeHelper(0x7ab, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

BOOL EXLApplication::get_DisplayDocumentActionTaskPane() {
  BOOL result;
  InvokeHelper(0x8cb, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_DisplayDocumentActionTaskPane(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x8cb, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

void EXLApplication::DisplayXMLSourcePane(VARIANT XmlMap) {
  static BYTE parms[] = VTS_VARIANT;
  InvokeHelper(0x8cc, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &XmlMap);
}

BOOL EXLApplication::get_ArbitraryXMLSupportAvailable() {
  BOOL result;
  InvokeHelper(0x8ce, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

VARIANT EXLApplication::Support(LPDISPATCH Object, long ID, VARIANT arg) {
  VARIANT result;
  static BYTE parms[] = VTS_DISPATCH VTS_I4 VTS_VARIANT;
  InvokeHelper(0x8cf, DISPATCH_METHOD, VT_VARIANT, (void*)&result, parms, Object, ID, &arg);
  return result;
}

VARIANT EXLApplication::Dummy20(long grfCompareFunctions) {
  VARIANT result;
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x945, DISPATCH_METHOD, VT_VARIANT, (void*)&result, parms, grfCompareFunctions);
  return result;
}

long EXLApplication::get_MeasurementUnit() {
  long result;
  InvokeHelper(0x947, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_MeasurementUnit(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x947, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

BOOL EXLApplication::get_ShowSelectionFloaties() {
  BOOL result;
  InvokeHelper(0x948, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_ShowSelectionFloaties(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x948, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

BOOL EXLApplication::get_ShowMenuFloaties() {
  BOOL result;
  InvokeHelper(0x949, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_ShowMenuFloaties(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x949, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

BOOL EXLApplication::get_ShowDevTools() {
  BOOL result;
  InvokeHelper(0x94a, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_ShowDevTools(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x94a, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

BOOL EXLApplication::get_EnableLivePreview() {
  BOOL result;
  InvokeHelper(0x94b, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_EnableLivePreview(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x94b, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

BOOL EXLApplication::get_DisplayDocumentInformationPanel() {
  BOOL result;
  InvokeHelper(0x94c, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_DisplayDocumentInformationPanel(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x94c, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

BOOL EXLApplication::get_AlwaysUseClearType() {
  BOOL result;
  InvokeHelper(0x94d, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_AlwaysUseClearType(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x94d, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

BOOL EXLApplication::get_WarnOnFunctionNameConflict() {
  BOOL result;
  InvokeHelper(0x94e, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_WarnOnFunctionNameConflict(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x94e, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

long EXLApplication::get_FormulaBarHeight() {
  long result;
  InvokeHelper(0x94f, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_FormulaBarHeight(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x94f, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

BOOL EXLApplication::get_DisplayFormulaAutoComplete() {
  BOOL result;
  InvokeHelper(0x950, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_DisplayFormulaAutoComplete(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x950, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

long EXLApplication::get_GenerateTableRefs() {
  long result;
  InvokeHelper(0x951, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_GenerateTableRefs(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x951, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

LPDISPATCH EXLApplication::get_Assistance() {
  LPDISPATCH result;
  InvokeHelper(0x952, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
void EXLApplication::CalculateUntilAsyncQueriesDone() {
  InvokeHelper(0x953, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}

BOOL EXLApplication::get_EnableLargeOperationAlert() {
  BOOL result;
  InvokeHelper(0x954, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_EnableLargeOperationAlert(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x954, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

long EXLApplication::get_LargeOperationCellThousandCount() {
  long result;
  InvokeHelper(0x955, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_LargeOperationCellThousandCount(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x955, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

BOOL EXLApplication::get_DeferAsyncQueries() {
  BOOL result;
  InvokeHelper(0x956, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_DeferAsyncQueries(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x956, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

LPDISPATCH EXLApplication::get_MultiThreadedCalculation() {
  LPDISPATCH result;
  InvokeHelper(0x957, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

long EXLApplication::SharePointVersion(LPCTSTR bstrUrl) {
  long result;
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x958, DISPATCH_METHOD, VT_I4, (void*)&result, parms, bstrUrl);
  return result;
}

long EXLApplication::get_ActiveEncryptionSession() {
  long result;
  InvokeHelper(0x95a, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

BOOL EXLApplication::get_HighQualityModeForGraphics() {
  BOOL result;
  InvokeHelper(0x95b, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_HighQualityModeForGraphics(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x95b, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

LPDISPATCH EXLApplication::get_FileExportConverters() {
  LPDISPATCH result;
  InvokeHelper(0xad0, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH EXLApplication::get_SmartArtLayouts() {
  LPDISPATCH result;
  InvokeHelper(0xad4, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH EXLApplication::get_SmartArtQuickStyles() {
  LPDISPATCH result;
  InvokeHelper(0xad5, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH EXLApplication::get_SmartArtColors() {
  LPDISPATCH result;
  InvokeHelper(0xad6, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH EXLApplication::get_AddIns2() {
  LPDISPATCH result;
  InvokeHelper(0xad7, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

BOOL EXLApplication::get_PrintCommunication() {
  BOOL result;
  InvokeHelper(0xad8, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_PrintCommunication(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0xad8, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

void EXLApplication::MacroOptions(VARIANT Macro, VARIANT Description, VARIANT HasMenu, VARIANT MenuText, VARIANT HasShortcutKey, VARIANT ShortcutKey, VARIANT Category, VARIANT StatusBar, VARIANT HelpContextID, VARIANT HelpFile, VARIANT ArgumentDescriptions) {
  static BYTE parms[] = VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT VTS_VARIANT;
  InvokeHelper(0xad2, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, &Macro, &Description, &HasMenu, &MenuText, &HasShortcutKey, &ShortcutKey, &Category, &StatusBar, &HelpContextID, &HelpFile, &ArgumentDescriptions);
}

BOOL EXLApplication::get_UseClusterConnector() {
  BOOL result;
  InvokeHelper(0xada, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_UseClusterConnector(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0xada, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

CString EXLApplication::get_ClusterConnector() {
  CString result;
  InvokeHelper(0xadb, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_ClusterConnector(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0xadb, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

BOOL EXLApplication::get_Quitting() {
  BOOL result;
  InvokeHelper(0xadc, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

BOOL EXLApplication::get_Dummy22() {
  BOOL result;
  InvokeHelper(0xadd, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_Dummy22(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0xadd, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

BOOL EXLApplication::get_Dummy23() {
  BOOL result;
  InvokeHelper(0xade, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_Dummy23(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0xade, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

LPDISPATCH EXLApplication::get_ProtectedViewWindows() {
  LPDISPATCH result;
  InvokeHelper(0xadf, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH EXLApplication::get_ActiveProtectedViewWindow() {
  LPDISPATCH result;
  InvokeHelper(0xae0, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

BOOL EXLApplication::get_IsSandboxed() {
  BOOL result;
  InvokeHelper(0xae1, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

BOOL EXLApplication::get_SaveISO8601Dates() {
  BOOL result;
  InvokeHelper(0xae2, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_SaveISO8601Dates(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0xae2, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

VARIANT EXLApplication::get_HinstancePtr() {
  VARIANT result;
  InvokeHelper(0xae3, DISPATCH_PROPERTYGET, VT_VARIANT, (void*)&result, nullptr);
  return result;
}
long EXLApplication::get_FileValidation() {
  long result;
  InvokeHelper(0xae4, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_FileValidation(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0xae4, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

long EXLApplication::get_FileValidationPivot() {
  long result;
  InvokeHelper(0xae5, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_FileValidationPivot(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0xae5, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

BOOL EXLApplication::get_ShowQuickAnalysis() {
  BOOL result;
  InvokeHelper(0xbb2, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_ShowQuickAnalysis(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0xbb2, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

LPDISPATCH EXLApplication::get_QuickAnalysis() {
  LPDISPATCH result;
  InvokeHelper(0xbb3, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

BOOL EXLApplication::get_FlashFill() {
  BOOL result;
  InvokeHelper(0xbb4, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_FlashFill(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0xbb4, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

BOOL EXLApplication::get_EnableMacroAnimations() {
  BOOL result;
  InvokeHelper(0xbb5, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_EnableMacroAnimations(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0xbb5, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

BOOL EXLApplication::get_ChartDataPointTrack() {
  BOOL result;
  InvokeHelper(0xbb6, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_ChartDataPointTrack(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0xbb6, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

BOOL EXLApplication::get_FlashFillMode() {
  BOOL result;
  InvokeHelper(0xbb7, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_FlashFillMode(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0xbb7, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

BOOL EXLApplication::get_MergeInstances() {
  BOOL result;
  InvokeHelper(0xbb8, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_MergeInstances(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0xbb8, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

BOOL EXLApplication::get_EnableCheckFileExtensions() {
  BOOL result;
  InvokeHelper(0xc56, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void EXLApplication::put_EnableCheckFileExtensions(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0xc56, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

} // namespace MSO::Excel

#pragma warning( pop )