#include "stdafx.h"

#include "office/word/WBookmark.h"

#include "office/word/WRange.h"
#include "office/word/WApplication.h"

#pragma warning( push )
#pragma warning( disable : 26493 26485 26494 )

namespace MSO::Word {

CString WBookmark::get_Name() {
  CString result;
  InvokeHelper(0x0, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
WRange WBookmark::get_Range() {
  LPDISPATCH result;
  InvokeHelper(0x1, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
BOOL WBookmark::get_Empty() {
  BOOL result;
  InvokeHelper(0x2, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
long WBookmark::get_Start() {
  long result;
  InvokeHelper(0x3, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void WBookmark::put_Start(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x3, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
long WBookmark::get_End() {
  long result;
  InvokeHelper(0x4, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void WBookmark::put_End(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x4, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WBookmark::get_Column() {
  BOOL result;
  InvokeHelper(0x5, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
long WBookmark::get_StoryType() {
  long result;
  InvokeHelper(0x6, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
WApplication WBookmark::get_Application() {
  LPDISPATCH result;
  InvokeHelper(0x3e8, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
long WBookmark::get_Creator() {
  long result;
  InvokeHelper(0x3e9, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WBookmark::get_Parent() {
  LPDISPATCH result;
  InvokeHelper(0x3ea, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
void WBookmark::Select() {
  InvokeHelper(0xffff, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WBookmark::Delete() {
  InvokeHelper(0xb, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
LPDISPATCH WBookmark::Copy(LPCTSTR Name) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0xc, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, Name);
  return result;
}

} // namespace MSO::Word

#pragma warning( pop )