#include "stdafx.h"

#include "office/word/WDocument.h"

#include "office/word/WApplication.h"
#include "office/word/WBookmarks.h"
#include "office/word/WTables.h"

#pragma warning( push )
#pragma warning( disable : 26493 26485 26494 )

namespace MSO::Word {

CString WDocument::get_Name() {
  CString result;
  InvokeHelper(0x0, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
WApplication WDocument::get_Application() {
  LPDISPATCH result;
  InvokeHelper(0x1, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
long WDocument::get_Creator() {
  long result;
  InvokeHelper(0x3e9, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WDocument::get_Parent() {
  LPDISPATCH result;
  InvokeHelper(0x3ea, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WDocument::get_BuiltInDocumentProperties() {
  LPDISPATCH result;
  InvokeHelper(0x3e8, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WDocument::get_CustomDocumentProperties() {
  LPDISPATCH result;
  InvokeHelper(0x2, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
CString WDocument::get_Path() {
  CString result;
  InvokeHelper(0x3, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
WBookmarks WDocument::get_Bookmarks() {
  LPDISPATCH result;
  InvokeHelper(0x4, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
WTables WDocument::get_Tables() {
  LPDISPATCH result;
  InvokeHelper(0x6, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WDocument::get_Footnotes() {
  LPDISPATCH result;
  InvokeHelper(0x7, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WDocument::get_Endnotes() {
  LPDISPATCH result;
  InvokeHelper(0x8, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WDocument::get_Comments() {
  LPDISPATCH result;
  InvokeHelper(0x9, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
long WDocument::get_Type() {
  long result;
  InvokeHelper(0xa, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
BOOL WDocument::get_AutoHyphenation() {
  BOOL result;
  InvokeHelper(0xb, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_AutoHyphenation(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0xb, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WDocument::get_HyphenateCaps() {
  BOOL result;
  InvokeHelper(0xc, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_HyphenateCaps(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0xc, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
long WDocument::get_HyphenationZone() {
  long result;
  InvokeHelper(0xd, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void WDocument::put_HyphenationZone(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0xd, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
long WDocument::get_ConsecutiveHyphensLimit() {
  long result;
  InvokeHelper(0xe, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void WDocument::put_ConsecutiveHyphensLimit(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0xe, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
LPDISPATCH WDocument::get_Sections() {
  LPDISPATCH result;
  InvokeHelper(0xf, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WDocument::get_Paragraphs() {
  LPDISPATCH result;
  InvokeHelper(0x10, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WDocument::get_Words() {
  LPDISPATCH result;
  InvokeHelper(0x11, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WDocument::get_Sentences() {
  LPDISPATCH result;
  InvokeHelper(0x12, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WDocument::get_Characters() {
  LPDISPATCH result;
  InvokeHelper(0x13, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WDocument::get_Fields() {
  LPDISPATCH result;
  InvokeHelper(0x14, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WDocument::get_FormFields() {
  LPDISPATCH result;
  InvokeHelper(0x15, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WDocument::get_Styles() {
  LPDISPATCH result;
  InvokeHelper(0x16, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WDocument::get_Frames() {
  LPDISPATCH result;
  InvokeHelper(0x17, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WDocument::get_TablesOfFigures() {
  LPDISPATCH result;
  InvokeHelper(0x19, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WDocument::get_Variables() {
  LPDISPATCH result;
  InvokeHelper(0x1a, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WDocument::get_MailMerge() {
  LPDISPATCH result;
  InvokeHelper(0x1b, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WDocument::get_Envelope() {
  LPDISPATCH result;
  InvokeHelper(0x1c, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
CString WDocument::get_FullName() {
  CString result;
  InvokeHelper(0x1d, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WDocument::get_Revisions() {
  LPDISPATCH result;
  InvokeHelper(0x1e, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WDocument::get_TablesOfContents() {
  LPDISPATCH result;
  InvokeHelper(0x1f, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WDocument::get_TablesOfAuthorities() {
  LPDISPATCH result;
  InvokeHelper(0x20, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WDocument::get_PageSetup() {
  LPDISPATCH result;
  InvokeHelper(0x44d, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
void WDocument::put_PageSetup(LPDISPATCH newValue) {
  static BYTE parms[] = VTS_DISPATCH;
  InvokeHelper(0x44d, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
LPDISPATCH WDocument::get_Windows() {
  LPDISPATCH result;
  InvokeHelper(0x22, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
BOOL WDocument::get_HasRoutingSlip() {
  BOOL result;
  InvokeHelper(0x23, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_HasRoutingSlip(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x23, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
LPDISPATCH WDocument::get_RoutingSlip() {
  LPDISPATCH result;
  InvokeHelper(0x24, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
BOOL WDocument::get_Routed() {
  BOOL result;
  InvokeHelper(0x25, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WDocument::get_TablesOfAuthoritiesCategories() {
  LPDISPATCH result;
  InvokeHelper(0x26, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WDocument::get_Indexes() {
  LPDISPATCH result;
  InvokeHelper(0x27, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
BOOL WDocument::get_Saved() {
  BOOL result;
  InvokeHelper(0x28, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_Saved(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x28, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
LPDISPATCH WDocument::get_Content() {
  LPDISPATCH result;
  InvokeHelper(0x29, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WDocument::get_ActiveWindow() {
  LPDISPATCH result;
  InvokeHelper(0x2a, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
long WDocument::get_Kind() {
  long result;
  InvokeHelper(0x2b, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void WDocument::put_Kind(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x2b, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WDocument::get_ReadOnly() {
  BOOL result;
  InvokeHelper(0x2c, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WDocument::get_Subdocuments() {
  LPDISPATCH result;
  InvokeHelper(0x2d, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
BOOL WDocument::get_IsMasterDocument() {
  BOOL result;
  InvokeHelper(0x2e, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
float WDocument::get_DefaultTabStop() {
  float result;
  InvokeHelper(0x30, DISPATCH_PROPERTYGET, VT_R4, (void*)&result, nullptr);
  return result;
}
void WDocument::put_DefaultTabStop(float newValue) {
  static BYTE parms[] = VTS_R4;
  InvokeHelper(0x30, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WDocument::get_EmbedTrueTypeFonts() {
  BOOL result;
  InvokeHelper(0x32, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_EmbedTrueTypeFonts(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x32, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WDocument::get_SaveFormsData() {
  BOOL result;
  InvokeHelper(0x33, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_SaveFormsData(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x33, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WDocument::get_ReadOnlyRecommended() {
  BOOL result;
  InvokeHelper(0x34, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_ReadOnlyRecommended(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x34, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WDocument::get_SaveSubsetFonts() {
  BOOL result;
  InvokeHelper(0x35, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_SaveSubsetFonts(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x35, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WDocument::get_Compatibility(long Type) {
  BOOL result;
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x37, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, parms, Type);
  return result;
}
void WDocument::put_Compatibility(long Type, BOOL newValue) {
  static BYTE parms[] = VTS_I4 VTS_BOOL;
  InvokeHelper(0x37, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, Type, newValue);
}
LPDISPATCH WDocument::get_StoryRanges() {
  LPDISPATCH result;
  InvokeHelper(0x38, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WDocument::get_CommandBars() {
  LPDISPATCH result;
  InvokeHelper(0x39, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
BOOL WDocument::get_IsSubdocument() {
  BOOL result;
  InvokeHelper(0x3a, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
long WDocument::get_SaveFormat() {
  long result;
  InvokeHelper(0x3b, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
long WDocument::get_ProtectionType() {
  long result;
  InvokeHelper(0x3c, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WDocument::get_Hyperlinks() {
  LPDISPATCH result;
  InvokeHelper(0x3d, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WDocument::get_Shapes() {
  LPDISPATCH result;
  InvokeHelper(0x3e, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WDocument::get_ListTemplates() {
  LPDISPATCH result;
  InvokeHelper(0x3f, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WDocument::get_Lists() {
  LPDISPATCH result;
  InvokeHelper(0x40, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
BOOL WDocument::get_UpdateStylesOnOpen() {
  BOOL result;
  InvokeHelper(0x42, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_UpdateStylesOnOpen(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x42, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
VARIANT WDocument::get_AttachedTemplate() {
  VARIANT result;
  InvokeHelper(0x43, DISPATCH_PROPERTYGET, VT_VARIANT, (void*)&result, nullptr);
  return result;
}
void WDocument::put_AttachedTemplate(VARIANT * newValue) {
  static BYTE parms[] = VTS_PVARIANT;
  InvokeHelper(0x43, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
LPDISPATCH WDocument::get_InlineShapes() {
  LPDISPATCH result;
  InvokeHelper(0x44, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WDocument::get_Background() {
  LPDISPATCH result;
  InvokeHelper(0x45, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
void WDocument::put_Background(LPDISPATCH newValue) {
  static BYTE parms[] = VTS_DISPATCH;
  InvokeHelper(0x45, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WDocument::get_GrammarChecked() {
  BOOL result;
  InvokeHelper(0x46, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_GrammarChecked(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x46, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WDocument::get_SpellingChecked() {
  BOOL result;
  InvokeHelper(0x47, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_SpellingChecked(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x47, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WDocument::get_ShowGrammaticalErrors() {
  BOOL result;
  InvokeHelper(0x48, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_ShowGrammaticalErrors(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x48, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WDocument::get_ShowSpellingErrors() {
  BOOL result;
  InvokeHelper(0x49, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_ShowSpellingErrors(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x49, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
LPDISPATCH WDocument::get_Versions() {
  LPDISPATCH result;
  InvokeHelper(0x4b, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
BOOL WDocument::get_ShowSummary() {
  BOOL result;
  InvokeHelper(0x4c, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_ShowSummary(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x4c, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
long WDocument::get_SummaryViewMode() {
  long result;
  InvokeHelper(0x4d, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void WDocument::put_SummaryViewMode(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x4d, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
long WDocument::get_SummaryLength() {
  long result;
  InvokeHelper(0x4e, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void WDocument::put_SummaryLength(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x4e, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WDocument::get_PrintFractionalWidths() {
  BOOL result;
  InvokeHelper(0x4f, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_PrintFractionalWidths(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x4f, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WDocument::get_PrintPostScriptOverText() {
  BOOL result;
  InvokeHelper(0x50, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_PrintPostScriptOverText(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x50, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
LPDISPATCH WDocument::get_Container() {
  LPDISPATCH result;
  InvokeHelper(0x52, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
BOOL WDocument::get_PrintFormsData() {
  BOOL result;
  InvokeHelper(0x53, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_PrintFormsData(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x53, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
LPDISPATCH WDocument::get_ListParagraphs() {
  LPDISPATCH result;
  InvokeHelper(0x54, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
void WDocument::put_Password(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x55, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
void WDocument::put_WritePassword(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x56, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WDocument::get_HasPassword() {
  BOOL result;
  InvokeHelper(0x57, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
BOOL WDocument::get_WriteReserved() {
  BOOL result;
  InvokeHelper(0x58, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
CString WDocument::get_ActiveWritingStyle(VARIANT * LanguageID) {
  CString result;
  static BYTE parms[] = VTS_PVARIANT;
  InvokeHelper(0x5a, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, parms, LanguageID);
  return result;
}
void WDocument::put_ActiveWritingStyle(VARIANT * LanguageID, LPCTSTR newValue) {
  static BYTE parms[] = VTS_PVARIANT VTS_BSTR;
  InvokeHelper(0x5a, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, LanguageID, newValue);
}
BOOL WDocument::get_UserControl() {
  BOOL result;
  InvokeHelper(0x5c, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_UserControl(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x5c, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WDocument::get_HasMailer() {
  BOOL result;
  InvokeHelper(0x5d, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_HasMailer(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x5d, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
LPDISPATCH WDocument::get_Mailer() {
  LPDISPATCH result;
  InvokeHelper(0x5e, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WDocument::get_ReadabilityStatistics() {
  LPDISPATCH result;
  InvokeHelper(0x60, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WDocument::get_GrammaticalErrors() {
  LPDISPATCH result;
  InvokeHelper(0x61, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WDocument::get_SpellingErrors() {
  LPDISPATCH result;
  InvokeHelper(0x62, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WDocument::get_VBProject() {
  LPDISPATCH result;
  InvokeHelper(0x63, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
BOOL WDocument::get_FormsDesign() {
  BOOL result;
  InvokeHelper(0x64, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
CString WDocument::get__CodeName() {
  CString result;
  InvokeHelper(0x80010000, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
void WDocument::put__CodeName(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x80010000, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
CString WDocument::get_CodeName() {
  CString result;
  InvokeHelper(0x106, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
BOOL WDocument::get_SnapToGrid() {
  BOOL result;
  InvokeHelper(0x12c, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_SnapToGrid(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x12c, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WDocument::get_SnapToShapes() {
  BOOL result;
  InvokeHelper(0x12d, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_SnapToShapes(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x12d, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
float WDocument::get_GridDistanceHorizontal() {
  float result;
  InvokeHelper(0x12e, DISPATCH_PROPERTYGET, VT_R4, (void*)&result, nullptr);
  return result;
}
void WDocument::put_GridDistanceHorizontal(float newValue) {
  static BYTE parms[] = VTS_R4;
  InvokeHelper(0x12e, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
float WDocument::get_GridDistanceVertical() {
  float result;
  InvokeHelper(0x12f, DISPATCH_PROPERTYGET, VT_R4, (void*)&result, nullptr);
  return result;
}
void WDocument::put_GridDistanceVertical(float newValue) {
  static BYTE parms[] = VTS_R4;
  InvokeHelper(0x12f, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
float WDocument::get_GridOriginHorizontal() {
  float result;
  InvokeHelper(0x130, DISPATCH_PROPERTYGET, VT_R4, (void*)&result, nullptr);
  return result;
}
void WDocument::put_GridOriginHorizontal(float newValue) {
  static BYTE parms[] = VTS_R4;
  InvokeHelper(0x130, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
float WDocument::get_GridOriginVertical() {
  float result;
  InvokeHelper(0x131, DISPATCH_PROPERTYGET, VT_R4, (void*)&result, nullptr);
  return result;
}
void WDocument::put_GridOriginVertical(float newValue) {
  static BYTE parms[] = VTS_R4;
  InvokeHelper(0x131, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
long WDocument::get_GridSpaceBetweenHorizontalLines() {
  long result;
  InvokeHelper(0x132, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void WDocument::put_GridSpaceBetweenHorizontalLines(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x132, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
long WDocument::get_GridSpaceBetweenVerticalLines() {
  long result;
  InvokeHelper(0x133, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void WDocument::put_GridSpaceBetweenVerticalLines(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x133, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WDocument::get_GridOriginFromMargin() {
  BOOL result;
  InvokeHelper(0x134, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_GridOriginFromMargin(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x134, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WDocument::get_KerningByAlgorithm() {
  BOOL result;
  InvokeHelper(0x135, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_KerningByAlgorithm(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x135, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
long WDocument::get_JustificationMode() {
  long result;
  InvokeHelper(0x136, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void WDocument::put_JustificationMode(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x136, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
long WDocument::get_FarEastLineBreakLevel() {
  long result;
  InvokeHelper(0x137, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void WDocument::put_FarEastLineBreakLevel(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x137, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
CString WDocument::get_NoLineBreakBefore() {
  CString result;
  InvokeHelper(0x138, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
void WDocument::put_NoLineBreakBefore(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x138, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
CString WDocument::get_NoLineBreakAfter() {
  CString result;
  InvokeHelper(0x139, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
void WDocument::put_NoLineBreakAfter(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x139, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WDocument::get_TrackRevisions() {
  BOOL result;
  InvokeHelper(0x13a, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_TrackRevisions(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x13a, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WDocument::get_PrintRevisions() {
  BOOL result;
  InvokeHelper(0x13b, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_PrintRevisions(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x13b, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WDocument::get_ShowRevisions() {
  BOOL result;
  InvokeHelper(0x13c, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_ShowRevisions(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x13c, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
void WDocument::Close(VARIANT * SaveChanges, VARIANT * OriginalFormat, VARIANT * RouteDocument) {
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x451, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, SaveChanges, OriginalFormat, RouteDocument);
}
void WDocument::SaveAs2000(VARIANT * FileName, VARIANT * FileFormat, VARIANT * LockComments, VARIANT * Password, VARIANT * AddToRecentFiles, VARIANT * WritePassword, VARIANT * ReadOnlyRecommended, VARIANT * EmbedTrueTypeFonts, VARIANT * SaveNativePictureFormat, VARIANT * SaveFormsData, VARIANT * SaveAsAOCELetter) {
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x66, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, FileName, FileFormat, LockComments, Password, AddToRecentFiles, WritePassword, ReadOnlyRecommended, EmbedTrueTypeFonts, SaveNativePictureFormat, SaveFormsData, SaveAsAOCELetter);
}
void WDocument::Repaginate() {
  InvokeHelper(0x67, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WDocument::FitToPages() {
  InvokeHelper(0x68, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WDocument::ManualHyphenation() {
  InvokeHelper(0x69, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WDocument::Select() {
  InvokeHelper(0xffff, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WDocument::DataForm() {
  InvokeHelper(0x6a, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WDocument::Route() {
  InvokeHelper(0x6b, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WDocument::Save() {
  InvokeHelper(0x6c, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WDocument::PrintOutOld(VARIANT * Background, VARIANT * Append, VARIANT * Range, VARIANT * OutputFileName, VARIANT * From, VARIANT * To, VARIANT * Item, VARIANT * Copies, VARIANT * Pages, VARIANT * PageType, VARIANT * PrintToFile, VARIANT * Collate, VARIANT * ActivePrinterMacGX, VARIANT * ManualDuplexPrint) {
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x6d, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Background, Append, Range, OutputFileName, From, To, Item, Copies, Pages, PageType, PrintToFile, Collate, ActivePrinterMacGX, ManualDuplexPrint);
}
void WDocument::SendMail() {
  InvokeHelper(0x6e, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
LPDISPATCH WDocument::Range(VARIANT * Start, VARIANT * End) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x7d0, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, Start, End);
  return result;
}
void WDocument::RunAutoMacro(long Which) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x70, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Which);
}
void WDocument::Activate() {
  InvokeHelper(0x71, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WDocument::PrintPreview() {
  InvokeHelper(0x72, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
LPDISPATCH WDocument::GoTo(VARIANT * What, VARIANT * Which, VARIANT * Count, VARIANT * Name) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x73, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, What, Which, Count, Name);
  return result;
}
BOOL WDocument::Undo(VARIANT * Times) {
  BOOL result;
  static BYTE parms[] = VTS_PVARIANT;
  InvokeHelper(0x74, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms, Times);
  return result;
}
BOOL WDocument::Redo(VARIANT * Times) {
  BOOL result;
  static BYTE parms[] = VTS_PVARIANT;
  InvokeHelper(0x75, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms, Times);
  return result;
}
long WDocument::ComputeStatistics(long Statistic, VARIANT * IncludeFootnotesAndEndnotes) {
  long result;
  static BYTE parms[] = VTS_I4 VTS_PVARIANT;
  InvokeHelper(0x76, DISPATCH_METHOD, VT_I4, (void*)&result, parms, Statistic, IncludeFootnotesAndEndnotes);
  return result;
}
void WDocument::MakeCompatibilityDefault() {
  InvokeHelper(0x77, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WDocument::Protect2002(long Type, VARIANT * NoReset, VARIANT * Password) {
  static BYTE parms[] = VTS_I4 VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x78, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Type, NoReset, Password);
}
void WDocument::Unprotect(VARIANT * Password) {
  static BYTE parms[] = VTS_PVARIANT;
  InvokeHelper(0x79, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Password);
}
void WDocument::EditionOptions(long Type, long Option, LPCTSTR Name, VARIANT * Format) {
  static BYTE parms[] = VTS_I4 VTS_I4 VTS_BSTR VTS_PVARIANT;
  InvokeHelper(0x7a, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Type, Option, Name, Format);
}
void WDocument::RunLetterWizard(VARIANT * LetterContent, VARIANT * WizardMode) {
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x7b, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, LetterContent, WizardMode);
}
LPDISPATCH WDocument::GetLetterContent() {
  LPDISPATCH result;
  InvokeHelper(0x7c, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
void WDocument::SetLetterContent(VARIANT * LetterContent) {
  static BYTE parms[] = VTS_PVARIANT;
  InvokeHelper(0x7d, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, LetterContent);
}
void WDocument::CopyStylesFromTemplate(LPCTSTR Template) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x7e, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Template);
}
void WDocument::UpdateStyles() {
  InvokeHelper(0x7f, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WDocument::CheckGrammar() {
  InvokeHelper(0x83, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WDocument::CheckSpelling(VARIANT * CustomDictionary, VARIANT * IgnoreUppercase, VARIANT * AlwaysSuggest, VARIANT * CustomDictionary2, VARIANT * CustomDictionary3, VARIANT * CustomDictionary4, VARIANT * CustomDictionary5, VARIANT * CustomDictionary6, VARIANT * CustomDictionary7, VARIANT * CustomDictionary8, VARIANT * CustomDictionary9, VARIANT * CustomDictionary10) {
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x84, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, CustomDictionary, IgnoreUppercase, AlwaysSuggest, CustomDictionary2, CustomDictionary3, CustomDictionary4, CustomDictionary5, CustomDictionary6, CustomDictionary7, CustomDictionary8, CustomDictionary9, CustomDictionary10);
}
void WDocument::FollowHyperlink(VARIANT * Address, VARIANT * SubAddress, VARIANT * NewWindow, VARIANT * AddHistory, VARIANT * ExtraInfo, VARIANT * Method, VARIANT * HeaderInfo) {
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x87, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Address, SubAddress, NewWindow, AddHistory, ExtraInfo, Method, HeaderInfo);
}
void WDocument::AddToFavorites() {
  InvokeHelper(0x88, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WDocument::Reload() {
  InvokeHelper(0x89, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
LPDISPATCH WDocument::AutoSummarize(VARIANT * Length, VARIANT * Mode, VARIANT * UpdateProperties) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x8a, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, Length, Mode, UpdateProperties);
  return result;
}
void WDocument::RemoveNumbers(VARIANT * NumberType) {
  static BYTE parms[] = VTS_PVARIANT;
  InvokeHelper(0x8c, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, NumberType);
}
void WDocument::ConvertNumbersToText(VARIANT * NumberType) {
  static BYTE parms[] = VTS_PVARIANT;
  InvokeHelper(0x8d, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, NumberType);
}
long WDocument::CountNumberedItems(VARIANT * NumberType, VARIANT * Level) {
  long result;
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x8e, DISPATCH_METHOD, VT_I4, (void*)&result, parms, NumberType, Level);
  return result;
}
void WDocument::Post() {
  InvokeHelper(0x8f, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WDocument::ToggleFormsDesign() {
  InvokeHelper(0x90, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WDocument::Compare2000(LPCTSTR Name) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x91, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Name);
}
void WDocument::UpdateSummaryProperties() {
  InvokeHelper(0x92, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
VARIANT WDocument::GetCrossReferenceItems(VARIANT * ReferenceType) {
  VARIANT result;
  static BYTE parms[] = VTS_PVARIANT;
  InvokeHelper(0x93, DISPATCH_METHOD, VT_VARIANT, (void*)&result, parms, ReferenceType);
  return result;
}
void WDocument::AutoFormat() {
  InvokeHelper(0x94, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WDocument::ViewCode() {
  InvokeHelper(0x95, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WDocument::ViewPropertyBrowser() {
  InvokeHelper(0x96, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WDocument::ForwardMailer() {
  InvokeHelper(0xfa, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WDocument::Reply() {
  InvokeHelper(0xfb, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WDocument::ReplyAll() {
  InvokeHelper(0xfc, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WDocument::SendMailer(VARIANT * FileFormat, VARIANT * Priority) {
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0xfd, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, FileFormat, Priority);
}
void WDocument::UndoClear() {
  InvokeHelper(0xfe, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WDocument::PresentIt() {
  InvokeHelper(0xff, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WDocument::SendFax(LPCTSTR Address, VARIANT * Subject) {
  static BYTE parms[] = VTS_BSTR VTS_PVARIANT;
  InvokeHelper(0x100, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Address, Subject);
}
void WDocument::Merge2000(LPCTSTR FileName) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x101, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, FileName);
}
void WDocument::ClosePrintPreview() {
  InvokeHelper(0x102, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WDocument::CheckConsistency() {
  InvokeHelper(0x103, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
LPDISPATCH WDocument::CreateLetterContent(LPCTSTR DateFormat, BOOL IncludeHeaderFooter, LPCTSTR PageDesign, long LetterStyle, BOOL Letterhead, long LetterheadLocation, float LetterheadSize, LPCTSTR RecipientName, LPCTSTR RecipientAddress, LPCTSTR Salutation, long SalutationType, LPCTSTR RecipientReference, LPCTSTR MailingInstructions, LPCTSTR AttentionLine, LPCTSTR Subject, LPCTSTR CCList, LPCTSTR ReturnAddress, LPCTSTR SenderName, LPCTSTR Closing, LPCTSTR SenderCompany, LPCTSTR SenderJobTitle, LPCTSTR SenderInitials, long EnclosureNumber, VARIANT * InfoBlock, VARIANT * RecipientCode, VARIANT * RecipientGender, VARIANT * ReturnAddressShortForm, VARIANT * SenderCity, VARIANT * SenderCode, VARIANT * SenderGender, VARIANT * SenderReference) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_BSTR VTS_BOOL VTS_BSTR VTS_I4 VTS_BOOL VTS_I4 VTS_R4 VTS_BSTR VTS_BSTR VTS_BSTR VTS_I4 VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_I4 VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x104, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, DateFormat, IncludeHeaderFooter, PageDesign, LetterStyle, Letterhead, LetterheadLocation, LetterheadSize, RecipientName, RecipientAddress, Salutation, SalutationType, RecipientReference, MailingInstructions, AttentionLine, Subject, CCList, ReturnAddress, SenderName, Closing, SenderCompany, SenderJobTitle, SenderInitials, EnclosureNumber, InfoBlock, RecipientCode, RecipientGender, ReturnAddressShortForm, SenderCity, SenderCode, SenderGender, SenderReference);
  return result;
}
void WDocument::AcceptAllRevisions() {
  InvokeHelper(0x13d, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WDocument::RejectAllRevisions() {
  InvokeHelper(0x13e, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WDocument::DetectLanguage() {
  InvokeHelper(0x97, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WDocument::ApplyTheme(LPCTSTR Name) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x142, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Name);
}
void WDocument::RemoveTheme() {
  InvokeHelper(0x143, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WDocument::WebPagePreview() {
  InvokeHelper(0x145, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WDocument::ReloadAs(long Encoding) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x14b, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Encoding);
}
CString WDocument::get_ActiveTheme() {
  CString result;
  InvokeHelper(0x21c, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
CString WDocument::get_ActiveThemeDisplayName() {
  CString result;
  InvokeHelper(0x21d, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WDocument::get_Email() {
  LPDISPATCH result;
  InvokeHelper(0x13f, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WDocument::get_Scripts() {
  LPDISPATCH result;
  InvokeHelper(0x140, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
BOOL WDocument::get_LanguageDetected() {
  BOOL result;
  InvokeHelper(0x141, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_LanguageDetected(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x141, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
long WDocument::get_FarEastLineBreakLanguage() {
  long result;
  InvokeHelper(0x146, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void WDocument::put_FarEastLineBreakLanguage(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x146, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
LPDISPATCH WDocument::get_Frameset() {
  LPDISPATCH result;
  InvokeHelper(0x147, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
VARIANT WDocument::get_ClickAndTypeParagraphStyle() {
  VARIANT result;
  InvokeHelper(0x148, DISPATCH_PROPERTYGET, VT_VARIANT, (void*)&result, nullptr);
  return result;
}
void WDocument::put_ClickAndTypeParagraphStyle(VARIANT * newValue) {
  static BYTE parms[] = VTS_PVARIANT;
  InvokeHelper(0x148, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
LPDISPATCH WDocument::get_HTMLProject() {
  LPDISPATCH result;
  InvokeHelper(0x149, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WDocument::get_WebOptions() {
  LPDISPATCH result;
  InvokeHelper(0x14a, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
long WDocument::get_OpenEncoding() {
  long result;
  InvokeHelper(0x14c, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
long WDocument::get_SaveEncoding() {
  long result;
  InvokeHelper(0x14d, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void WDocument::put_SaveEncoding(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x14d, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WDocument::get_OptimizeForWord97() {
  BOOL result;
  InvokeHelper(0x14e, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_OptimizeForWord97(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x14e, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WDocument::get_VBASigned() {
  BOOL result;
  InvokeHelper(0x14f, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::PrintOut2000(VARIANT * Background, VARIANT * Append, VARIANT * Range, VARIANT * OutputFileName, VARIANT * From, VARIANT * To, VARIANT * Item, VARIANT * Copies, VARIANT * Pages, VARIANT * PageType, VARIANT * PrintToFile, VARIANT * Collate, VARIANT * ActivePrinterMacGX, VARIANT * ManualDuplexPrint, VARIANT * PrintZoomColumn, VARIANT * PrintZoomRow, VARIANT * PrintZoomPaperWidth, VARIANT * PrintZoomPaperHeight) {
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x1bc, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Background, Append, Range, OutputFileName, From, To, Item, Copies, Pages, PageType, PrintToFile, Collate, ActivePrinterMacGX, ManualDuplexPrint, PrintZoomColumn, PrintZoomRow, PrintZoomPaperWidth, PrintZoomPaperHeight);
}
void WDocument::sblt(LPCTSTR s) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x1bd, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, s);
}
void WDocument::ConvertVietDoc(long CodePageOrigin) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x1bf, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, CodePageOrigin);
}
void WDocument::PrintOut(VARIANT * Background, VARIANT * Append, VARIANT * Range, VARIANT * OutputFileName, VARIANT * From, VARIANT * To, VARIANT * Item, VARIANT * Copies, VARIANT * Pages, VARIANT * PageType, VARIANT * PrintToFile, VARIANT * Collate, VARIANT * ActivePrinterMacGX, VARIANT * ManualDuplexPrint, VARIANT * PrintZoomColumn, VARIANT * PrintZoomRow, VARIANT * PrintZoomPaperWidth, VARIANT * PrintZoomPaperHeight) {
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x1be, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Background, Append, Range, OutputFileName, From, To, Item, Copies, Pages, PageType, PrintToFile, Collate, ActivePrinterMacGX, ManualDuplexPrint, PrintZoomColumn, PrintZoomRow, PrintZoomPaperWidth, PrintZoomPaperHeight);
}
LPDISPATCH WDocument::get_MailEnvelope() {
  LPDISPATCH result;
  InvokeHelper(0x150, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
BOOL WDocument::get_DisableFeatures() {
  BOOL result;
  InvokeHelper(0x151, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_DisableFeatures(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x151, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WDocument::get_DoNotEmbedSystemFonts() {
  BOOL result;
  InvokeHelper(0x152, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_DoNotEmbedSystemFonts(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x152, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
LPDISPATCH WDocument::get_Signatures() {
  LPDISPATCH result;
  InvokeHelper(0x153, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
CString WDocument::get_DefaultTargetFrame() {
  CString result;
  InvokeHelper(0x154, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
void WDocument::put_DefaultTargetFrame(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x154, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
LPDISPATCH WDocument::get_HTMLDivisions() {
  LPDISPATCH result;
  InvokeHelper(0x156, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
long WDocument::get_DisableFeaturesIntroducedAfter() {
  long result;
  InvokeHelper(0x157, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void WDocument::put_DisableFeaturesIntroducedAfter(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x157, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WDocument::get_RemovePersonalInformation() {
  BOOL result;
  InvokeHelper(0x158, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_RemovePersonalInformation(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x158, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
LPDISPATCH WDocument::get_SmartTags() {
  LPDISPATCH result;
  InvokeHelper(0x15a, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
void WDocument::Compare2002(LPCTSTR Name, VARIANT * AuthorName, VARIANT * CompareTarget, VARIANT * DetectFormatChanges, VARIANT * IgnoreAllComparisonWarnings, VARIANT * AddToRecentFiles) {
  static BYTE parms[] = VTS_BSTR VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x159, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Name, AuthorName, CompareTarget, DetectFormatChanges, IgnoreAllComparisonWarnings, AddToRecentFiles);
}
void WDocument::CheckIn(BOOL SaveChanges, VARIANT * Comments, BOOL MakePublic) {
  static BYTE parms[] = VTS_BOOL VTS_PVARIANT VTS_BOOL;
  InvokeHelper(0x15d, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, SaveChanges, Comments, MakePublic);
}
BOOL WDocument::CanCheckin() {
  BOOL result;
  InvokeHelper(0x15f, DISPATCH_METHOD, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::Merge(LPCTSTR FileName, VARIANT * MergeTarget, VARIANT * DetectFormatChanges, VARIANT * UseFormattingFrom, VARIANT * AddToRecentFiles) {
  static BYTE parms[] = VTS_BSTR VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x16a, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, FileName, MergeTarget, DetectFormatChanges, UseFormattingFrom, AddToRecentFiles);
}
BOOL WDocument::get_EmbedSmartTags() {
  BOOL result;
  InvokeHelper(0x15b, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_EmbedSmartTags(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x15b, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WDocument::get_SmartTagsAsXMLProps() {
  BOOL result;
  InvokeHelper(0x15c, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_SmartTagsAsXMLProps(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x15c, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
long WDocument::get_TextEncoding() {
  long result;
  InvokeHelper(0x165, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void WDocument::put_TextEncoding(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x165, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
long WDocument::get_TextLineEnding() {
  long result;
  InvokeHelper(0x166, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void WDocument::put_TextLineEnding(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x166, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
void WDocument::SendForReview(VARIANT * Recipients, VARIANT * Subject, VARIANT * ShowMessage, VARIANT * IncludeAttachment) {
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x161, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Recipients, Subject, ShowMessage, IncludeAttachment);
}
void WDocument::ReplyWithChanges(VARIANT * ShowMessage) {
  static BYTE parms[] = VTS_PVARIANT;
  InvokeHelper(0x162, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, ShowMessage);
}
void WDocument::EndReview() {
  InvokeHelper(0x164, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
LPDISPATCH WDocument::get_StyleSheets() {
  LPDISPATCH result;
  InvokeHelper(0x168, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
VARIANT WDocument::get_DefaultTableStyle() {
  VARIANT result;
  InvokeHelper(0x16d, DISPATCH_PROPERTYGET, VT_VARIANT, (void*)&result, nullptr);
  return result;
}
CString WDocument::get_PasswordEncryptionProvider() {
  CString result;
  InvokeHelper(0x16f, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
CString WDocument::get_PasswordEncryptionAlgorithm() {
  CString result;
  InvokeHelper(0x170, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
long WDocument::get_PasswordEncryptionKeyLength() {
  long result;
  InvokeHelper(0x171, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
BOOL WDocument::get_PasswordEncryptionFileProperties() {
  BOOL result;
  InvokeHelper(0x172, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::SetPasswordEncryptionOptions(LPCTSTR PasswordEncryptionProvider, LPCTSTR PasswordEncryptionAlgorithm, long PasswordEncryptionKeyLength, VARIANT * PasswordEncryptionFileProperties) {
  static BYTE parms[] = VTS_BSTR VTS_BSTR VTS_I4 VTS_PVARIANT;
  InvokeHelper(0x169, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, PasswordEncryptionProvider, PasswordEncryptionAlgorithm, PasswordEncryptionKeyLength, PasswordEncryptionFileProperties);
}
void WDocument::RecheckSmartTags() {
  InvokeHelper(0x16b, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WDocument::RemoveSmartTags() {
  InvokeHelper(0x16c, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WDocument::SetDefaultTableStyle(VARIANT * Style, BOOL SetInTemplate) {
  static BYTE parms[] = VTS_PVARIANT VTS_BOOL;
  InvokeHelper(0x16e, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Style, SetInTemplate);
}
void WDocument::DeleteAllComments() {
  InvokeHelper(0x173, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WDocument::AcceptAllRevisionsShown() {
  InvokeHelper(0x174, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WDocument::RejectAllRevisionsShown() {
  InvokeHelper(0x175, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WDocument::DeleteAllCommentsShown() {
  InvokeHelper(0x176, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WDocument::ResetFormFields() {
  InvokeHelper(0x177, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WDocument::SaveAs(VARIANT * FileName, VARIANT * FileFormat, VARIANT * LockComments, VARIANT * Password, VARIANT * AddToRecentFiles, VARIANT * WritePassword, VARIANT * ReadOnlyRecommended, VARIANT * EmbedTrueTypeFonts, VARIANT * SaveNativePictureFormat, VARIANT * SaveFormsData, VARIANT * SaveAsAOCELetter, VARIANT * Encoding, VARIANT * InsertLineBreaks, VARIANT * AllowSubstitutions, VARIANT * LineEnding, VARIANT * AddBiDiMarks) {
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x178, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, FileName, FileFormat, LockComments, Password, AddToRecentFiles, WritePassword, ReadOnlyRecommended, EmbedTrueTypeFonts, SaveNativePictureFormat, SaveFormsData, SaveAsAOCELetter, Encoding, InsertLineBreaks, AllowSubstitutions, LineEnding, AddBiDiMarks);
}
BOOL WDocument::get_EmbedLinguisticData() {
  BOOL result;
  InvokeHelper(0x179, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_EmbedLinguisticData(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x179, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WDocument::get_FormattingShowFont() {
  BOOL result;
  InvokeHelper(0x1c0, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_FormattingShowFont(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x1c0, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WDocument::get_FormattingShowClear() {
  BOOL result;
  InvokeHelper(0x1c1, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_FormattingShowClear(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x1c1, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WDocument::get_FormattingShowParagraph() {
  BOOL result;
  InvokeHelper(0x1c2, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_FormattingShowParagraph(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x1c2, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WDocument::get_FormattingShowNumbering() {
  BOOL result;
  InvokeHelper(0x1c3, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_FormattingShowNumbering(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x1c3, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
long WDocument::get_FormattingShowFilter() {
  long result;
  InvokeHelper(0x1c4, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void WDocument::put_FormattingShowFilter(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x1c4, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
void WDocument::CheckNewSmartTags() {
  InvokeHelper(0x17a, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
LPDISPATCH WDocument::get_Permission() {
  LPDISPATCH result;
  InvokeHelper(0x1c5, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WDocument::get_XMLNodes() {
  LPDISPATCH result;
  InvokeHelper(0x1cc, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WDocument::get_XMLSchemaReferences() {
  LPDISPATCH result;
  InvokeHelper(0x1cd, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WDocument::get_SmartDocument() {
  LPDISPATCH result;
  InvokeHelper(0x1ce, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WDocument::get_SharedWorkspace() {
  LPDISPATCH result;
  InvokeHelper(0x1cf, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WDocument::get_Sync() {
  LPDISPATCH result;
  InvokeHelper(0x1d2, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
BOOL WDocument::get_EnforceStyle() {
  BOOL result;
  InvokeHelper(0x1d7, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_EnforceStyle(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x1d7, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WDocument::get_AutoFormatOverride() {
  BOOL result;
  InvokeHelper(0x1d8, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_AutoFormatOverride(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x1d8, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WDocument::get_XMLSaveDataOnly() {
  BOOL result;
  InvokeHelper(0x1d9, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_XMLSaveDataOnly(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x1d9, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WDocument::get_XMLHideNamespaces() {
  BOOL result;
  InvokeHelper(0x1dd, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_XMLHideNamespaces(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x1dd, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WDocument::get_XMLShowAdvancedErrors() {
  BOOL result;
  InvokeHelper(0x1de, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_XMLShowAdvancedErrors(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x1de, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WDocument::get_XMLUseXSLTWhenSaving() {
  BOOL result;
  InvokeHelper(0x1da, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_XMLUseXSLTWhenSaving(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x1da, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
CString WDocument::get_XMLSaveThroughXSLT() {
  CString result;
  InvokeHelper(0x1db, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
void WDocument::put_XMLSaveThroughXSLT(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x1db, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
LPDISPATCH WDocument::get_DocumentLibraryVersions() {
  LPDISPATCH result;
  InvokeHelper(0x1dc, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
BOOL WDocument::get_ReadingModeLayoutFrozen() {
  BOOL result;
  InvokeHelper(0x1e1, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_ReadingModeLayoutFrozen(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x1e1, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WDocument::get_RemoveDateAndTime() {
  BOOL result;
  InvokeHelper(0x1e4, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_RemoveDateAndTime(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x1e4, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
void WDocument::SendFaxOverInternet(VARIANT * Recipients, VARIANT * Subject, VARIANT * ShowMessage) {
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x1d0, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Recipients, Subject, ShowMessage);
}
void WDocument::TransformDocument(LPCTSTR Path, BOOL DataOnly) {
  static BYTE parms[] = VTS_BSTR VTS_BOOL;
  InvokeHelper(0x1f4, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Path, DataOnly);
}
void WDocument::Protect(long Type, VARIANT * NoReset, VARIANT * Password, VARIANT * UseIRM, VARIANT * EnforceStyleLock) {
  static BYTE parms[] = VTS_I4 VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x1d3, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Type, NoReset, Password, UseIRM, EnforceStyleLock);
}
void WDocument::SelectAllEditableRanges(VARIANT * EditorID) {
  static BYTE parms[] = VTS_PVARIANT;
  InvokeHelper(0x1d4, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, EditorID);
}
void WDocument::DeleteAllEditableRanges(VARIANT * EditorID) {
  static BYTE parms[] = VTS_PVARIANT;
  InvokeHelper(0x1d5, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, EditorID);
}
void WDocument::DeleteAllInkAnnotations() {
  InvokeHelper(0x1df, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WDocument::AddDocumentWorkspaceHeader(BOOL RichFormat, LPCTSTR Url, LPCTSTR Title, LPCTSTR Description, LPCTSTR ID) {
  static BYTE parms[] = VTS_BOOL VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR;
  InvokeHelper(0x1e2, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, RichFormat, Url, Title, Description, ID);
}
void WDocument::RemoveDocumentWorkspaceHeader(LPCTSTR ID) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x1e3, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, ID);
}
void WDocument::Compare(LPCTSTR Name, VARIANT * AuthorName, VARIANT * CompareTarget, VARIANT * DetectFormatChanges, VARIANT * IgnoreAllComparisonWarnings, VARIANT * AddToRecentFiles, VARIANT * RemovePersonalInformation, VARIANT * RemoveDateAndTime) {
  static BYTE parms[] = VTS_BSTR VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x1e5, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Name, AuthorName, CompareTarget, DetectFormatChanges, IgnoreAllComparisonWarnings, AddToRecentFiles, RemovePersonalInformation, RemoveDateAndTime);
}
void WDocument::RemoveLockedStyles() {
  InvokeHelper(0x1e7, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
LPDISPATCH WDocument::get_ChildNodeSuggestions() {
  LPDISPATCH result;
  InvokeHelper(0x1e6, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WDocument::SelectSingleNode(LPCTSTR XPath, LPCTSTR PrefixMapping, BOOL FastSearchSkippingTextNodes) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_BSTR VTS_BSTR VTS_BOOL;
  InvokeHelper(0x1e8, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, XPath, PrefixMapping, FastSearchSkippingTextNodes);
  return result;
}
LPDISPATCH WDocument::SelectNodes(LPCTSTR XPath, LPCTSTR PrefixMapping, BOOL FastSearchSkippingTextNodes) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_BSTR VTS_BSTR VTS_BOOL;
  InvokeHelper(0x1e9, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, XPath, PrefixMapping, FastSearchSkippingTextNodes);
  return result;
}
LPDISPATCH WDocument::get_XMLSchemaViolations() {
  LPDISPATCH result;
  InvokeHelper(0x1ea, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
long WDocument::get_ReadingLayoutSizeX() {
  long result;
  InvokeHelper(0x1eb, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void WDocument::put_ReadingLayoutSizeX(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x1eb, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
long WDocument::get_ReadingLayoutSizeY() {
  long result;
  InvokeHelper(0x1ec, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void WDocument::put_ReadingLayoutSizeY(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x1ec, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
long WDocument::get_StyleSortMethod() {
  long result;
  InvokeHelper(0x1ed, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void WDocument::put_StyleSortMethod(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x1ed, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
LPDISPATCH WDocument::get_ContentTypeProperties() {
  LPDISPATCH result;
  InvokeHelper(0x1f0, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
BOOL WDocument::get_TrackMoves() {
  BOOL result;
  InvokeHelper(0x1f3, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_TrackMoves(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x1f3, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WDocument::get_TrackFormatting() {
  BOOL result;
  InvokeHelper(0x1f6, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_TrackFormatting(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x1f6, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
void WDocument::get_Dummy1() {
  InvokeHelper(0x1f7, DISPATCH_PROPERTYGET, VT_EMPTY, nullptr, nullptr);
}
LPDISPATCH WDocument::get_OMaths() {
  LPDISPATCH result;
  InvokeHelper(0x1f8, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
void WDocument::RemoveDocumentInformation(long RemoveDocInfoType) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x1ef, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, RemoveDocInfoType);
}
void WDocument::CheckInWithVersion(BOOL SaveChanges, VARIANT * Comments, BOOL MakePublic, VARIANT * VersionType) {
  static BYTE parms[] = VTS_BOOL VTS_PVARIANT VTS_BOOL VTS_PVARIANT;
  InvokeHelper(0x1f5, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, SaveChanges, Comments, MakePublic, VersionType);
}
void WDocument::Dummy2() {
  InvokeHelper(0x1f9, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WDocument::get_Dummy3() {
  InvokeHelper(0x1fa, DISPATCH_PROPERTYGET, VT_EMPTY, nullptr, nullptr);
}
LPDISPATCH WDocument::get_ServerPolicy() {
  LPDISPATCH result;
  InvokeHelper(0x1fb, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WDocument::get_ContentControls() {
  LPDISPATCH result;
  InvokeHelper(0x1fc, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WDocument::get_DocumentInspectors() {
  LPDISPATCH result;
  InvokeHelper(0x1fe, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
void WDocument::LockServerFile() {
  InvokeHelper(0x1fd, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
LPDISPATCH WDocument::GetWorkflowTasks() {
  LPDISPATCH result;
  InvokeHelper(0x1ff, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WDocument::GetWorkflowTemplates() {
  LPDISPATCH result;
  InvokeHelper(0x200, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
void WDocument::Dummy4() {
  InvokeHelper(0x202, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WDocument::AddMeetingWorkspaceHeader(BOOL SkipIfAbsent, LPCTSTR Url, LPCTSTR Title, LPCTSTR Description, LPCTSTR ID) {
  static BYTE parms[] = VTS_BOOL VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR;
  InvokeHelper(0x203, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, SkipIfAbsent, Url, Title, Description, ID);
}
LPDISPATCH WDocument::get_Bibliography() {
  LPDISPATCH result;
  InvokeHelper(0x204, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
BOOL WDocument::get_LockTheme() {
  BOOL result;
  InvokeHelper(0x205, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_LockTheme(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x205, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WDocument::get_LockQuickStyleSet() {
  BOOL result;
  InvokeHelper(0x206, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_LockQuickStyleSet(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x206, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
CString WDocument::get_OriginalDocumentTitle() {
  CString result;
  InvokeHelper(0x207, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
CString WDocument::get_RevisedDocumentTitle() {
  CString result;
  InvokeHelper(0x208, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WDocument::get_CustomXMLParts() {
  LPDISPATCH result;
  InvokeHelper(0x209, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
BOOL WDocument::get_FormattingShowNextLevel() {
  BOOL result;
  InvokeHelper(0x20a, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_FormattingShowNextLevel(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x20a, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WDocument::get_FormattingShowUserStyleName() {
  BOOL result;
  InvokeHelper(0x20b, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_FormattingShowUserStyleName(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x20b, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
void WDocument::SaveAsQuickStyleSet(LPCTSTR FileName) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x20c, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, FileName);
}
void WDocument::ApplyQuickStyleSet(LPCTSTR Name) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x20d, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Name);
}
LPDISPATCH WDocument::get_Research() {
  LPDISPATCH result;
  InvokeHelper(0x20e, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
BOOL WDocument::get_Final() {
  BOOL result;
  InvokeHelper(0x20f, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_Final(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x20f, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
long WDocument::get_OMathBreakBin() {
  long result;
  InvokeHelper(0x210, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void WDocument::put_OMathBreakBin(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x210, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
long WDocument::get_OMathBreakSub() {
  long result;
  InvokeHelper(0x211, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void WDocument::put_OMathBreakSub(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x211, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
long WDocument::get_OMathJc() {
  long result;
  InvokeHelper(0x212, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void WDocument::put_OMathJc(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x212, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
float WDocument::get_OMathLeftMargin() {
  float result;
  InvokeHelper(0x213, DISPATCH_PROPERTYGET, VT_R4, (void*)&result, nullptr);
  return result;
}
void WDocument::put_OMathLeftMargin(float newValue) {
  static BYTE parms[] = VTS_R4;
  InvokeHelper(0x213, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
float WDocument::get_OMathRightMargin() {
  float result;
  InvokeHelper(0x214, DISPATCH_PROPERTYGET, VT_R4, (void*)&result, nullptr);
  return result;
}
void WDocument::put_OMathRightMargin(float newValue) {
  static BYTE parms[] = VTS_R4;
  InvokeHelper(0x214, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
float WDocument::get_OMathWrap() {
  float result;
  InvokeHelper(0x217, DISPATCH_PROPERTYGET, VT_R4, (void*)&result, nullptr);
  return result;
}
void WDocument::put_OMathWrap(float newValue) {
  static BYTE parms[] = VTS_R4;
  InvokeHelper(0x217, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WDocument::get_OMathIntSubSupLim() {
  BOOL result;
  InvokeHelper(0x218, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_OMathIntSubSupLim(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x218, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WDocument::get_OMathNarySupSubLim() {
  BOOL result;
  InvokeHelper(0x219, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_OMathNarySupSubLim(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x219, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WDocument::get_OMathSmallFrac() {
  BOOL result;
  InvokeHelper(0x21b, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_OMathSmallFrac(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x21b, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
CString WDocument::get_WordOpenXML() {
  CString result;
  InvokeHelper(0x21e, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WDocument::get_DocumentTheme() {
  LPDISPATCH result;
  InvokeHelper(0x221, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
void WDocument::ApplyDocumentTheme(LPCTSTR FileName) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x222, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, FileName);
}
BOOL WDocument::get_HasVBProject() {
  BOOL result;
  InvokeHelper(0x224, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
LPDISPATCH WDocument::SelectLinkedControls(LPDISPATCH Node) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_DISPATCH;
  InvokeHelper(0x225, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, Node);
  return result;
}
LPDISPATCH WDocument::SelectUnlinkedControls(LPDISPATCH Stream) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_DISPATCH;
  InvokeHelper(0x226, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, Stream);
  return result;
}
LPDISPATCH WDocument::SelectContentControlsByTitle(LPCTSTR Title) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x227, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, Title);
  return result;
}
void WDocument::ExportAsFixedFormat(LPCTSTR OutputFileName, long ExportFormat, BOOL OpenAfterExport, long OptimizeFor, long Range, long From, long To, long Item, BOOL IncludeDocProps, BOOL KeepIRM, long CreateBookmarks, BOOL DocStructureTags, BOOL BitmapMissingFonts, BOOL UseISO19005_1, VARIANT * FixedFormatExtClassPtr) {
  static BYTE parms[] = VTS_BSTR VTS_I4 VTS_BOOL VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BOOL VTS_BOOL VTS_I4 VTS_BOOL VTS_BOOL VTS_BOOL VTS_PVARIANT;
  InvokeHelper(0x228, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, OutputFileName, ExportFormat, OpenAfterExport, OptimizeFor, Range, From, To, Item, IncludeDocProps, KeepIRM, CreateBookmarks, DocStructureTags, BitmapMissingFonts, UseISO19005_1, FixedFormatExtClassPtr);
}
void WDocument::FreezeLayout() {
  InvokeHelper(0x229, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
void WDocument::UnfreezeLayout() {
  InvokeHelper(0x22a, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
CString WDocument::get_OMathFontName() {
  CString result;
  InvokeHelper(0x22b, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
void WDocument::put_OMathFontName(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x22b, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
void WDocument::DowngradeDocument() {
  InvokeHelper(0x22e, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
CString WDocument::get_EncryptionProvider() {
  CString result;
  InvokeHelper(0x22f, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}
void WDocument::put_EncryptionProvider(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x22f, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WDocument::get_UseMathDefaults() {
  BOOL result;
  InvokeHelper(0x230, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_UseMathDefaults(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x230, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
long WDocument::get_CurrentRsid() {
  long result;
  InvokeHelper(0x233, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void WDocument::Convert() {
  InvokeHelper(0x231, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
LPDISPATCH WDocument::SelectContentControlsByTag(LPCTSTR Tag) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x232, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, Tag);
  return result;
}
void WDocument::ConvertAutoHyphens() {
  InvokeHelper(0x28a, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}
long WDocument::get_DocID() {
  long result;
  InvokeHelper(0x234, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void WDocument::ApplyQuickStyleSet2(VARIANT * Style) {
  static BYTE parms[] = VTS_PVARIANT;
  InvokeHelper(0x236, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Style);
}
long WDocument::get_CompatibilityMode() {
  long result;
  InvokeHelper(0x237, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}
void WDocument::SaveAs2(VARIANT * FileName, VARIANT * FileFormat, VARIANT * LockComments, VARIANT * Password, VARIANT * AddToRecentFiles, VARIANT * WritePassword, VARIANT * ReadOnlyRecommended, VARIANT * EmbedTrueTypeFonts, VARIANT * SaveNativePictureFormat, VARIANT * SaveFormsData, VARIANT * SaveAsAOCELetter, VARIANT * Encoding, VARIANT * InsertLineBreaks, VARIANT * AllowSubstitutions, VARIANT * LineEnding, VARIANT * AddBiDiMarks, VARIANT * CompatibilityMode) {
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x238, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, FileName, FileFormat, LockComments, Password, AddToRecentFiles, WritePassword, ReadOnlyRecommended, EmbedTrueTypeFonts, SaveNativePictureFormat, SaveFormsData, SaveAsAOCELetter, Encoding, InsertLineBreaks, AllowSubstitutions, LineEnding, AddBiDiMarks, CompatibilityMode);
}
LPDISPATCH WDocument::get_CoAuthoring() {
  LPDISPATCH result;
  InvokeHelper(0x258, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
void WDocument::SetCompatibilityMode(long Mode) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x23b, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Mode);
}
LPDISPATCH WDocument::get_Broadcast() {
  LPDISPATCH result;
  InvokeHelper(0x262, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}
long WDocument::ReturnToLastReadPosition() {
  long result;
  InvokeHelper(0x23c, DISPATCH_METHOD, VT_I4, (void*)&result, nullptr);
  return result;
}
BOOL WDocument::get_ChartDataPointTrack() {
  BOOL result;
  InvokeHelper(0x26a, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::put_ChartDataPointTrack(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x26a, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}
BOOL WDocument::get_IsInAutosave() {
  BOOL result;
  InvokeHelper(0x26b, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}
void WDocument::SaveCopyAs(VARIANT * FileName, VARIANT * FileFormat, VARIANT * LockComments, VARIANT * Password, VARIANT * AddToRecentFiles, VARIANT * WritePassword, VARIANT * ReadOnlyRecommended, VARIANT * EmbedTrueTypeFonts, VARIANT * SaveNativePictureFormat, VARIANT * SaveFormsData, VARIANT * SaveAsAOCELetter, VARIANT * Encoding, VARIANT * InsertLineBreaks, VARIANT * AllowSubstitutions, VARIANT * LineEnding, VARIANT * AddBiDiMarks, VARIANT * CompatibilityMode) {
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x26d, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, FileName, FileFormat, LockComments, Password, AddToRecentFiles, WritePassword, ReadOnlyRecommended, EmbedTrueTypeFonts, SaveNativePictureFormat, SaveFormsData, SaveAsAOCELetter, Encoding, InsertLineBreaks, AllowSubstitutions, LineEnding, AddBiDiMarks, CompatibilityMode);
}
void WDocument::InsertAppForOfficeTest(LPCTSTR ID, long Type, LPCTSTR Version, long StoreType, LPCTSTR StoreId, LPCTSTR AssetId, LPCTSTR AssetStoreId, long Width, long Height) {
  static BYTE parms[] = VTS_BSTR VTS_I4 VTS_BSTR VTS_I4 VTS_BSTR VTS_BSTR VTS_BSTR VTS_I4 VTS_I4;
  InvokeHelper(0x26e, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, ID, Type, Version, StoreType, StoreId, AssetId, AssetStoreId, Width, Height);
}

} // namespace MSO::Word

#pragma warning( pop )