#include "stdafx.h"

#include "office/word/WRange.h"

#include "office/word/WApplication.h"
#include "office/word/WComments.h"
#include "office/word/WTables.h"

#pragma warning( push )
#pragma warning( disable : 26493 26485 26494 )

namespace MSO::Word {

CString WRange::get_Text() {
  CString result;
  InvokeHelper(0x0, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}

void WRange::put_Text(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x0, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

LPDISPATCH WRange::get_FormattedText() {
  LPDISPATCH result;
  InvokeHelper(0x2, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

void WRange::put_FormattedText(LPDISPATCH newValue) {
  static BYTE parms[] = VTS_DISPATCH;
  InvokeHelper(0x2, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

long WRange::get_Start() {
  long result;
  InvokeHelper(0x3, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

void WRange::put_Start(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x3, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

long WRange::get_End() {
  long result;
  InvokeHelper(0x4, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

void WRange::put_End(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x4, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

LPDISPATCH WRange::get_Font() {
  LPDISPATCH result;
  InvokeHelper(0x5, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

void WRange::put_Font(LPDISPATCH newValue) {
  static BYTE parms[] = VTS_DISPATCH;
  InvokeHelper(0x5, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

LPDISPATCH WRange::get_Duplicate() {
  LPDISPATCH result;
  InvokeHelper(0x6, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

long WRange::get_StoryType() {
  long result;
  InvokeHelper(0x7, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

WTables WRange::get_Tables() {
  LPDISPATCH result;
  InvokeHelper(0x32, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH WRange::get_Words() {
  LPDISPATCH result;
  InvokeHelper(0x33, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH WRange::get_Sentences() {
  LPDISPATCH result;
  InvokeHelper(0x34, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH WRange::get_Characters() {
  LPDISPATCH result;
  InvokeHelper(0x35, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH WRange::get_Footnotes() {
  LPDISPATCH result;
  InvokeHelper(0x36, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH WRange::get_Endnotes() {
  LPDISPATCH result;
  InvokeHelper(0x37, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

WComments WRange::get_Comments() {
  LPDISPATCH result;
  InvokeHelper(0x38, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH WRange::get_Cells() {
  LPDISPATCH result;
  InvokeHelper(0x39, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH WRange::get_Sections() {
  LPDISPATCH result;
  InvokeHelper(0x3a, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH WRange::get_Paragraphs() {
  LPDISPATCH result;
  InvokeHelper(0x3b, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH WRange::get_Borders() {
  LPDISPATCH result;
  InvokeHelper(0x44c, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

void WRange::put_Borders(LPDISPATCH newValue) {
  static BYTE parms[] = VTS_DISPATCH;
  InvokeHelper(0x44c, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

LPDISPATCH WRange::get_Shading() {
  LPDISPATCH result;
  InvokeHelper(0x3d, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH WRange::get_TextRetrievalMode() {
  LPDISPATCH result;
  InvokeHelper(0x3e, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

void WRange::put_TextRetrievalMode(LPDISPATCH newValue) {
  static BYTE parms[] = VTS_DISPATCH;
  InvokeHelper(0x3e, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

LPDISPATCH WRange::get_Fields() {
  LPDISPATCH result;
  InvokeHelper(0x40, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH WRange::get_FormFields() {
  LPDISPATCH result;
  InvokeHelper(0x41, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH WRange::get_Frames() {
  LPDISPATCH result;
  InvokeHelper(0x42, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH WRange::get_ParagraphFormat() {
  LPDISPATCH result;
  InvokeHelper(0x44e, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

void WRange::put_ParagraphFormat(LPDISPATCH newValue) {
  static BYTE parms[] = VTS_DISPATCH;
  InvokeHelper(0x44e, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

LPDISPATCH WRange::get_ListFormat() {
  LPDISPATCH result;
  InvokeHelper(0x44, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH WRange::get_Bookmarks() {
  LPDISPATCH result;
  InvokeHelper(0x4b, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

WApplication WRange::get_Application() {
  LPDISPATCH result;
  InvokeHelper(0x3e8, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

long WRange::get_Creator() {
  long result;
  InvokeHelper(0x3e9, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

LPDISPATCH WRange::get_Parent() {
  LPDISPATCH result;
  InvokeHelper(0x3ea, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

long WRange::get_Bold() {
  long result;
  InvokeHelper(0x82, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

void WRange::put_Bold(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x82, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

long WRange::get_Italic() {
  long result;
  InvokeHelper(0x83, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

void WRange::put_Italic(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x83, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

long WRange::get_Underline() {
  long result;
  InvokeHelper(0x8b, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

void WRange::put_Underline(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x8b, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

long WRange::get_EmphasisMark() {
  long result;
  InvokeHelper(0x8c, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

void WRange::put_EmphasisMark(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x8c, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

BOOL WRange::get_DisableCharacterSpaceGrid() {
  BOOL result;
  InvokeHelper(0x8d, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void WRange::put_DisableCharacterSpaceGrid(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x8d, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

LPDISPATCH WRange::get_Revisions() {
  LPDISPATCH result;
  InvokeHelper(0x96, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

VARIANT WRange::get_Style() {
  VARIANT result;
  InvokeHelper(0x97, DISPATCH_PROPERTYGET, VT_VARIANT, (void*)&result, nullptr);
  return result;
}

void WRange::put_Style(VARIANT * newValue) {
  static BYTE parms[] = VTS_PVARIANT;
  InvokeHelper(0x97, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

long WRange::get_StoryLength() {
  long result;
  InvokeHelper(0x98, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

long WRange::get_LanguageID() {
  long result;
  InvokeHelper(0x99, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

void WRange::put_LanguageID(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x99, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

LPDISPATCH WRange::get_SynonymInfo() {
  LPDISPATCH result;
  InvokeHelper(0x9b, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH WRange::get_Hyperlinks() {
  LPDISPATCH result;
  InvokeHelper(0x9c, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH WRange::get_ListParagraphs() {
  LPDISPATCH result;
  InvokeHelper(0x9d, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH WRange::get_Subdocuments() {
  LPDISPATCH result;
  InvokeHelper(0x9f, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

BOOL WRange::get_GrammarChecked() {
  BOOL result;
  InvokeHelper(0x104, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void WRange::put_GrammarChecked(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x104, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

BOOL WRange::get_SpellingChecked() {
  BOOL result;
  InvokeHelper(0x105, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void WRange::put_SpellingChecked(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x105, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

long WRange::get_HighlightColorIndex() {
  long result;
  InvokeHelper(0x12d, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

void WRange::put_HighlightColorIndex(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x12d, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

LPDISPATCH WRange::get_Columns() {
  LPDISPATCH result;
  InvokeHelper(0x12e, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH WRange::get_Rows() {
  LPDISPATCH result;
  InvokeHelper(0x12f, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

long WRange::get_CanEdit() {
  long result;
  InvokeHelper(0x130, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

long WRange::get_CanPaste() {
  long result;
  InvokeHelper(0x131, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

BOOL WRange::get_IsEndOfRowMark() {
  BOOL result;
  InvokeHelper(0x133, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

long WRange::get_BookmarkID() {
  long result;
  InvokeHelper(0x134, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

long WRange::get_PreviousBookmarkID() {
  long result;
  InvokeHelper(0x135, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

LPDISPATCH WRange::get_Find() {
  LPDISPATCH result;
  InvokeHelper(0x106, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH WRange::get_PageSetup() {
  LPDISPATCH result;
  InvokeHelper(0x44d, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

void WRange::put_PageSetup(LPDISPATCH newValue) {
  static BYTE parms[] = VTS_DISPATCH;
  InvokeHelper(0x44d, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

LPDISPATCH WRange::get_ShapeRange() {
  LPDISPATCH result;
  InvokeHelper(0x137, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

long WRange::get_Case() {
  long result;
  InvokeHelper(0x138, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

void WRange::put_Case(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x138, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

VARIANT WRange::get_Information(long Type) {
  VARIANT result;
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x139, DISPATCH_PROPERTYGET, VT_VARIANT, (void*)&result, parms, Type);
  return result;
}

LPDISPATCH WRange::get_ReadabilityStatistics() {
  LPDISPATCH result;
  InvokeHelper(0x13a, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH WRange::get_GrammaticalErrors() {
  LPDISPATCH result;
  InvokeHelper(0x13b, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH WRange::get_SpellingErrors() {
  LPDISPATCH result;
  InvokeHelper(0x13c, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

long WRange::get_Orientation() {
  long result;
  InvokeHelper(0x13d, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

void WRange::put_Orientation(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x13d, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

LPDISPATCH WRange::get_InlineShapes() {
  LPDISPATCH result;
  InvokeHelper(0x13f, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH WRange::get_NextStoryRange() {
  LPDISPATCH result;
  InvokeHelper(0x140, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

long WRange::get_LanguageIDFarEast() {
  long result;
  InvokeHelper(0x141, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

void WRange::put_LanguageIDFarEast(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x141, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

long WRange::get_LanguageIDOther() {
  long result;
  InvokeHelper(0x142, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

void WRange::put_LanguageIDOther(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x142, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

void WRange::Select() {
  InvokeHelper(0xffff, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}

void WRange::SetRange(long Start, long End) {
  static BYTE parms[] = VTS_I4 VTS_I4;
  InvokeHelper(0x64, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Start, End);
}

void WRange::Collapse(VARIANT * Direction) {
  static BYTE parms[] = VTS_PVARIANT;
  InvokeHelper(0x65, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Direction);
}

void WRange::InsertBefore(LPCTSTR Text) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x66, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Text);
}

void WRange::InsertAfter(LPCTSTR Text) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x68, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Text);
}

LPDISPATCH WRange::Next(VARIANT * Unit, VARIANT * Count) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x69, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, Unit, Count);
  return result;
}

LPDISPATCH WRange::Previous(VARIANT * Unit, VARIANT * Count) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x6a, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, Unit, Count);
  return result;
}

long WRange::StartOf(VARIANT * Unit, VARIANT * Extend) {
  long result;
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x6b, DISPATCH_METHOD, VT_I4, (void*)&result, parms, Unit, Extend);
  return result;
}

long WRange::EndOf(VARIANT * Unit, VARIANT * Extend) {
  long result;
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x6c, DISPATCH_METHOD, VT_I4, (void*)&result, parms, Unit, Extend);
  return result;
}

long WRange::Move(VARIANT * Unit, VARIANT * Count) {
  long result;
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x6d, DISPATCH_METHOD, VT_I4, (void*)&result, parms, Unit, Count);
  return result;
}

long WRange::MoveStart(VARIANT * Unit, VARIANT * Count) {
  long result;
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x6e, DISPATCH_METHOD, VT_I4, (void*)&result, parms, Unit, Count);
  return result;
}

long WRange::MoveEnd(VARIANT * Unit, VARIANT * Count) {
  long result;
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x6f, DISPATCH_METHOD, VT_I4, (void*)&result, parms, Unit, Count);
  return result;
}

long WRange::MoveWhile(VARIANT * Cset, VARIANT * Count) {
  long result;
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x70, DISPATCH_METHOD, VT_I4, (void*)&result, parms, Cset, Count);
  return result;
}

long WRange::MoveStartWhile(VARIANT * Cset, VARIANT * Count) {
  long result;
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x71, DISPATCH_METHOD, VT_I4, (void*)&result, parms, Cset, Count);
  return result;
}

long WRange::MoveEndWhile(VARIANT * Cset, VARIANT * Count) {
  long result;
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x72, DISPATCH_METHOD, VT_I4, (void*)&result, parms, Cset, Count);
  return result;
}

long WRange::MoveUntil(VARIANT * Cset, VARIANT * Count) {
  long result;
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x73, DISPATCH_METHOD, VT_I4, (void*)&result, parms, Cset, Count);
  return result;
}

long WRange::MoveStartUntil(VARIANT * Cset, VARIANT * Count) {
  long result;
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x74, DISPATCH_METHOD, VT_I4, (void*)&result, parms, Cset, Count);
  return result;
}

long WRange::MoveEndUntil(VARIANT * Cset, VARIANT * Count) {
  long result;
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x75, DISPATCH_METHOD, VT_I4, (void*)&result, parms, Cset, Count);
  return result;
}

void WRange::Cut() {
  InvokeHelper(0x77, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}

void WRange::Copy() {
  InvokeHelper(0x78, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}

void WRange::Paste() {
  InvokeHelper(0x79, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}

void WRange::InsertBreak(VARIANT * Type) {
  static BYTE parms[] = VTS_PVARIANT;
  InvokeHelper(0x7a, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Type);
}

void WRange::InsertFile(LPCTSTR FileName, VARIANT * Range, VARIANT * ConfirmConversions, VARIANT * Link, VARIANT * Attachment) {
  static BYTE parms[] = VTS_BSTR VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x7b, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, FileName, Range, ConfirmConversions, Link, Attachment);
}

BOOL WRange::InStory(LPDISPATCH Range) {
  BOOL result;
  static BYTE parms[] = VTS_DISPATCH;
  InvokeHelper(0x7d, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms, Range);
  return result;
}

BOOL WRange::InRange(LPDISPATCH Range) {
  BOOL result;
  static BYTE parms[] = VTS_DISPATCH;
  InvokeHelper(0x7e, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms, Range);
  return result;
}

long WRange::Delete(VARIANT * Unit, VARIANT * Count) {
  long result;
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x7f, DISPATCH_METHOD, VT_I4, (void*)&result, parms, Unit, Count);
  return result;
}

void WRange::WholeStory() {
  InvokeHelper(0x80, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}

long WRange::Expand(VARIANT * Unit) {
  long result;
  static BYTE parms[] = VTS_PVARIANT;
  InvokeHelper(0x81, DISPATCH_METHOD, VT_I4, (void*)&result, parms, Unit);
  return result;
}

void WRange::InsertParagraph() {
  InvokeHelper(0xa0, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}

void WRange::InsertParagraphAfter() {
  InvokeHelper(0xa1, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}

LPDISPATCH WRange::ConvertToTableOld(VARIANT * Separator, VARIANT * NumRows, VARIANT * NumColumns, VARIANT * InitialColumnWidth, VARIANT * Format, VARIANT * ApplyBorders, VARIANT * ApplyShading, VARIANT * ApplyFont, VARIANT * ApplyColor, VARIANT * ApplyHeadingRows, VARIANT * ApplyLastRow, VARIANT * ApplyFirstColumn, VARIANT * ApplyLastColumn, VARIANT * AutoFit) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0xa2, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, Separator, NumRows, NumColumns, InitialColumnWidth, Format, ApplyBorders, ApplyShading, ApplyFont, ApplyColor, ApplyHeadingRows, ApplyLastRow, ApplyFirstColumn, ApplyLastColumn, AutoFit);
  return result;
}

void WRange::InsertDateTimeOld(VARIANT * DateTimeFormat, VARIANT * InsertAsField, VARIANT * InsertAsFullWidth) {
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0xa3, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, DateTimeFormat, InsertAsField, InsertAsFullWidth);
}

void WRange::InsertSymbol(long CharacterNumber, VARIANT * Font, VARIANT * Unicode, VARIANT * Bias) {
  static BYTE parms[] = VTS_I4 VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0xa4, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, CharacterNumber, Font, Unicode, Bias);
}

void WRange::InsertCrossReference_2002(VARIANT * ReferenceType, long ReferenceKind, VARIANT * ReferenceItem, VARIANT * InsertAsHyperlink, VARIANT * IncludePosition) {
  static BYTE parms[] = VTS_PVARIANT VTS_I4 VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0xa5, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, ReferenceType, ReferenceKind, ReferenceItem, InsertAsHyperlink, IncludePosition);
}

void WRange::InsertCaptionXP(VARIANT * Label, VARIANT * Title, VARIANT * TitleAutoText, VARIANT * Position) {
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0xa6, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Label, Title, TitleAutoText, Position);
}

void WRange::CopyAsPicture() {
  InvokeHelper(0xa7, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}

void WRange::SortOld(VARIANT * ExcludeHeader, VARIANT * FieldNumber, VARIANT * SortFieldType, VARIANT * SortOrder, VARIANT * FieldNumber2, VARIANT * SortFieldType2, VARIANT * SortOrder2, VARIANT * FieldNumber3, VARIANT * SortFieldType3, VARIANT * SortOrder3, VARIANT * SortColumn, VARIANT * Separator, VARIANT * CaseSensitive, VARIANT * LanguageID) {
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0xa8, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, ExcludeHeader, FieldNumber, SortFieldType, SortOrder, FieldNumber2, SortFieldType2, SortOrder2, FieldNumber3, SortFieldType3, SortOrder3, SortColumn, Separator, CaseSensitive, LanguageID);
}

void WRange::SortAscending() {
  InvokeHelper(0xa9, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}

void WRange::SortDescending() {
  InvokeHelper(0xaa, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}

BOOL WRange::IsEqual(LPDISPATCH Range) {
  BOOL result;
  static BYTE parms[] = VTS_DISPATCH;
  InvokeHelper(0xab, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms, Range);
  return result;
}

float WRange::Calculate() {
  float result;
  InvokeHelper(0xac, DISPATCH_METHOD, VT_R4, (void*)&result, nullptr);
  return result;
}

LPDISPATCH WRange::GoTo(VARIANT * What, VARIANT * Which, VARIANT * Count, VARIANT * Name) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0xad, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, What, Which, Count, Name);
  return result;
}

LPDISPATCH WRange::GoToNext(long What) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0xae, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, What);
  return result;
}

LPDISPATCH WRange::GoToPrevious(long What) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0xaf, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, What);
  return result;
}

void WRange::PasteSpecial(VARIANT * IconIndex, VARIANT * Link, VARIANT * Placement, VARIANT * DisplayAsIcon, VARIANT * DataType, VARIANT * IconFileName, VARIANT * IconLabel) {
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0xb0, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, IconIndex, Link, Placement, DisplayAsIcon, DataType, IconFileName, IconLabel);
}

void WRange::LookupNameProperties() {
  InvokeHelper(0xb1, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}

long WRange::ComputeStatistics(long Statistic) {
  long result;
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0xb2, DISPATCH_METHOD, VT_I4, (void*)&result, parms, Statistic);
  return result;
}

void WRange::Relocate(long Direction) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0xb3, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Direction);
}

void WRange::CheckSynonyms() {
  InvokeHelper(0xb4, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}

void WRange::SubscribeTo(LPCTSTR Edition, VARIANT * Format) {
  static BYTE parms[] = VTS_BSTR VTS_PVARIANT;
  InvokeHelper(0xb5, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Edition, Format);
}

void WRange::CreatePublisher(VARIANT * Edition, VARIANT * ContainsPICT, VARIANT * ContainsRTF, VARIANT * ContainsText) {
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0xb6, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Edition, ContainsPICT, ContainsRTF, ContainsText);
}

void WRange::InsertAutoText() {
  InvokeHelper(0xb7, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}

void WRange::InsertDatabase(VARIANT * Format, VARIANT * Style, VARIANT * LinkToSource, VARIANT * Connection, VARIANT * SQLStatement, VARIANT * SQLStatement1, VARIANT * PasswordDocument, VARIANT * PasswordTemplate, VARIANT * WritePasswordDocument, VARIANT * WritePasswordTemplate, VARIANT * DataSource, VARIANT * From, VARIANT * To, VARIANT * IncludeFields) {
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0xc2, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Format, Style, LinkToSource, Connection, SQLStatement, SQLStatement1, PasswordDocument, PasswordTemplate, WritePasswordDocument, WritePasswordTemplate, DataSource, From, To, IncludeFields);
}

void WRange::AutoFormat() {
  InvokeHelper(0xc3, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}

void WRange::CheckGrammar() {
  InvokeHelper(0xcc, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}

void WRange::CheckSpelling(VARIANT * CustomDictionary, VARIANT * IgnoreUppercase, VARIANT * AlwaysSuggest, VARIANT * CustomDictionary2, VARIANT * CustomDictionary3, VARIANT * CustomDictionary4, VARIANT * CustomDictionary5, VARIANT * CustomDictionary6, VARIANT * CustomDictionary7, VARIANT * CustomDictionary8, VARIANT * CustomDictionary9, VARIANT * CustomDictionary10) {
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0xcd, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, CustomDictionary, IgnoreUppercase, AlwaysSuggest, CustomDictionary2, CustomDictionary3, CustomDictionary4, CustomDictionary5, CustomDictionary6, CustomDictionary7, CustomDictionary8, CustomDictionary9, CustomDictionary10);
}

LPDISPATCH WRange::GetSpellingSuggestions(VARIANT * CustomDictionary, VARIANT * IgnoreUppercase, VARIANT * MainDictionary, VARIANT * SuggestionMode, VARIANT * CustomDictionary2, VARIANT * CustomDictionary3, VARIANT * CustomDictionary4, VARIANT * CustomDictionary5, VARIANT * CustomDictionary6, VARIANT * CustomDictionary7, VARIANT * CustomDictionary8, VARIANT * CustomDictionary9, VARIANT * CustomDictionary10) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0xd1, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, CustomDictionary, IgnoreUppercase, MainDictionary, SuggestionMode, CustomDictionary2, CustomDictionary3, CustomDictionary4, CustomDictionary5, CustomDictionary6, CustomDictionary7, CustomDictionary8, CustomDictionary9, CustomDictionary10);
  return result;
}

void WRange::InsertParagraphBefore() {
  InvokeHelper(0xd4, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}

void WRange::NextSubdocument() {
  InvokeHelper(0xdb, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}

void WRange::PreviousSubdocument() {
  InvokeHelper(0xdc, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}

void WRange::ConvertHangulAndHanja(VARIANT * ConversionsMode, VARIANT * FastConversion, VARIANT * CheckHangulEnding, VARIANT * EnableRecentOrdering, VARIANT * CustomDictionary) {
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0xdd, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, ConversionsMode, FastConversion, CheckHangulEnding, EnableRecentOrdering, CustomDictionary);
}

void WRange::PasteAsNestedTable() {
  InvokeHelper(0xde, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}

void WRange::ModifyEnclosure(VARIANT * Style, VARIANT * Symbol, VARIANT * EnclosedText) {
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0xdf, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Style, Symbol, EnclosedText);
}

void WRange::PhoneticGuide(LPCTSTR Text, long Alignment, long Raise, long FontSize, LPCTSTR FontName) {
  static BYTE parms[] = VTS_BSTR VTS_I4 VTS_I4 VTS_I4 VTS_BSTR;
  InvokeHelper(0xe0, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Text, Alignment, Raise, FontSize, FontName);
}

void WRange::InsertDateTime(VARIANT * DateTimeFormat, VARIANT * InsertAsField, VARIANT * InsertAsFullWidth, VARIANT * DateLanguage, VARIANT * CalendarType) {
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x1bc, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, DateTimeFormat, InsertAsField, InsertAsFullWidth, DateLanguage, CalendarType);
}

void WRange::Sort(VARIANT * ExcludeHeader, VARIANT * FieldNumber, VARIANT * SortFieldType, VARIANT * SortOrder, VARIANT * FieldNumber2, VARIANT * SortFieldType2, VARIANT * SortOrder2, VARIANT * FieldNumber3, VARIANT * SortFieldType3, VARIANT * SortOrder3, VARIANT * SortColumn, VARIANT * Separator, VARIANT * CaseSensitive, VARIANT * BidiSort, VARIANT * IgnoreThe, VARIANT * IgnoreKashida, VARIANT * IgnoreDiacritics, VARIANT * IgnoreHe, VARIANT * LanguageID) {
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x1e4, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, ExcludeHeader, FieldNumber, SortFieldType, SortOrder, FieldNumber2, SortFieldType2, SortOrder2, FieldNumber3, SortFieldType3, SortOrder3, SortColumn, Separator, CaseSensitive, BidiSort, IgnoreThe, IgnoreKashida, IgnoreDiacritics, IgnoreHe, LanguageID);
}

void WRange::DetectLanguage() {
  InvokeHelper(0xcb, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}

LPDISPATCH WRange::ConvertToTable(VARIANT * Separator, VARIANT * NumRows, VARIANT * NumColumns, VARIANT * InitialColumnWidth, VARIANT * Format, VARIANT * ApplyBorders, VARIANT * ApplyShading, VARIANT * ApplyFont, VARIANT * ApplyColor, VARIANT * ApplyHeadingRows, VARIANT * ApplyLastRow, VARIANT * ApplyFirstColumn, VARIANT * ApplyLastColumn, VARIANT * AutoFit, VARIANT * AutoFitBehavior, VARIANT * DefaultTableBehavior) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x1f2, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, Separator, NumRows, NumColumns, InitialColumnWidth, Format, ApplyBorders, ApplyShading, ApplyFont, ApplyColor, ApplyHeadingRows, ApplyLastRow, ApplyFirstColumn, ApplyLastColumn, AutoFit, AutoFitBehavior, DefaultTableBehavior);
  return result;
}

void WRange::TCSCConverter(long WdTCSCConverterDirection, BOOL CommonTerms, BOOL UseVariants) {
  static BYTE parms[] = VTS_I4 VTS_BOOL VTS_BOOL;
  InvokeHelper(0x1f3, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, WdTCSCConverterDirection, CommonTerms, UseVariants);
}

BOOL WRange::get_LanguageDetected() {
  BOOL result;
  InvokeHelper(0x107, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void WRange::put_LanguageDetected(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x107, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

float WRange::get_FitTextWidth() {
  float result;
  InvokeHelper(0x108, DISPATCH_PROPERTYGET, VT_R4, (void*)&result, nullptr);
  return result;
}

void WRange::put_FitTextWidth(float newValue) {
  static BYTE parms[] = VTS_R4;
  InvokeHelper(0x108, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

long WRange::get_HorizontalInVertical() {
  long result;
  InvokeHelper(0x109, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

void WRange::put_HorizontalInVertical(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x109, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

long WRange::get_TwoLinesInOne() {
  long result;
  InvokeHelper(0x10a, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

void WRange::put_TwoLinesInOne(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x10a, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

BOOL WRange::get_CombineCharacters() {
  BOOL result;
  InvokeHelper(0x10b, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void WRange::put_CombineCharacters(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x10b, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

long WRange::get_NoProofing() {
  long result;
  InvokeHelper(0x143, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

void WRange::put_NoProofing(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x143, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

LPDISPATCH WRange::get_TopLevelTables() {
  LPDISPATCH result;
  InvokeHelper(0x144, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH WRange::get_Scripts() {
  LPDISPATCH result;
  InvokeHelper(0x145, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

long WRange::get_CharacterWidth() {
  long result;
  InvokeHelper(0x146, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

void WRange::put_CharacterWidth(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x146, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

long WRange::get_Kana() {
  long result;
  InvokeHelper(0x147, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

void WRange::put_Kana(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x147, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

long WRange::get_BoldBi() {
  long result;
  InvokeHelper(0x190, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

void WRange::put_BoldBi(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x190, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

long WRange::get_ItalicBi() {
  long result;
  InvokeHelper(0x191, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

void WRange::put_ItalicBi(long newValue) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x191, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

CString WRange::get_ID() {
  CString result;
  InvokeHelper(0x195, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}

void WRange::put_ID(LPCTSTR newValue) {
  static BYTE parms[] = VTS_BSTR;
  InvokeHelper(0x195, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

LPDISPATCH WRange::get_HTMLDivisions() {
  LPDISPATCH result;
  InvokeHelper(0x196, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH WRange::get_SmartTags() {
  LPDISPATCH result;
  InvokeHelper(0x197, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

BOOL WRange::get_ShowAll() {
  BOOL result;
  InvokeHelper(0x198, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, nullptr);
  return result;
}

void WRange::put_ShowAll(BOOL newValue) {
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x198, DISPATCH_PROPERTYPUT, VT_EMPTY, nullptr, parms, newValue);
}

LPDISPATCH WRange::get_Document() {
  LPDISPATCH result;
  InvokeHelper(0x199, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH WRange::get_FootnoteOptions() {
  LPDISPATCH result;
  InvokeHelper(0x19a, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH WRange::get_EndnoteOptions() {
  LPDISPATCH result;
  InvokeHelper(0x19b, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

void WRange::PasteAndFormat(long Type) {
  static BYTE parms[] = VTS_I4;
  InvokeHelper(0x19c, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Type);
}

void WRange::PasteExcelTable(BOOL LinkedToExcel, BOOL WordFormatting, BOOL RTF) {
  static BYTE parms[] = VTS_BOOL VTS_BOOL VTS_BOOL;
  InvokeHelper(0x19d, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, LinkedToExcel, WordFormatting, RTF);
}

void WRange::PasteAppendTable() {
  InvokeHelper(0x19e, DISPATCH_METHOD, VT_EMPTY, nullptr, nullptr);
}

LPDISPATCH WRange::get_XMLNodes() {
  LPDISPATCH result;
  InvokeHelper(0x154, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH WRange::get_XMLParentNode() {
  LPDISPATCH result;
  InvokeHelper(0x155, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH WRange::get_Editors() {
  LPDISPATCH result;
  InvokeHelper(0x157, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

CString WRange::get_XML(BOOL DataOnly) {
  CString result;
  static BYTE parms[] = VTS_BOOL;
  InvokeHelper(0x158, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, parms, DataOnly);
  return result;
}

VARIANT WRange::get_EnhMetaFileBits() {
  VARIANT result;
  InvokeHelper(0x159, DISPATCH_PROPERTYGET, VT_VARIANT, (void*)&result, nullptr);
  return result;
}

LPDISPATCH WRange::GoToEditableRange(VARIANT * EditorID) {
  LPDISPATCH result;
  static BYTE parms[] = VTS_PVARIANT;
  InvokeHelper(0x19f, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, EditorID);
  return result;
}

void WRange::InsertXML(LPCTSTR XML, VARIANT * Transform) {
  static BYTE parms[] = VTS_BSTR VTS_PVARIANT;
  InvokeHelper(0x1a0, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, XML, Transform);
}

void WRange::InsertCaption(VARIANT * Label, VARIANT * Title, VARIANT * TitleAutoText, VARIANT * Position, VARIANT * ExcludeLabel) {
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x1a1, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Label, Title, TitleAutoText, Position, ExcludeLabel);
}

void WRange::InsertCrossReference(VARIANT * ReferenceType, long ReferenceKind, VARIANT * ReferenceItem, VARIANT * InsertAsHyperlink, VARIANT * IncludePosition, VARIANT * SeparateNumbers, VARIANT * SeparatorString) {
  static BYTE parms[] = VTS_PVARIANT VTS_I4 VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x1a2, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, ReferenceType, ReferenceKind, ReferenceItem, InsertAsHyperlink, IncludePosition, SeparateNumbers, SeparatorString);
}

LPDISPATCH WRange::get_OMaths() {
  LPDISPATCH result;
  InvokeHelper(0x15a, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

VARIANT WRange::get_CharacterStyle() {
  VARIANT result;
  InvokeHelper(0x1a4, DISPATCH_PROPERTYGET, VT_VARIANT, (void*)&result, nullptr);
  return result;
}

VARIANT WRange::get_ParagraphStyle() {
  VARIANT result;
  InvokeHelper(0x1a5, DISPATCH_PROPERTYGET, VT_VARIANT, (void*)&result, nullptr);
  return result;
}

VARIANT WRange::get_ListStyle() {
  VARIANT result;
  InvokeHelper(0x1a6, DISPATCH_PROPERTYGET, VT_VARIANT, (void*)&result, nullptr);
  return result;
}

VARIANT WRange::get_TableStyle() {
  VARIANT result;
  InvokeHelper(0x1a7, DISPATCH_PROPERTYGET, VT_VARIANT, (void*)&result, nullptr);
  return result;
}

LPDISPATCH WRange::get_ContentControls() {
  LPDISPATCH result;
  InvokeHelper(0x1a8, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

void WRange::ExportFragment(LPCTSTR FileName, long Format) {
  static BYTE parms[] = VTS_BSTR VTS_I4;
  InvokeHelper(0x1a9, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, FileName, Format);
}

CString WRange::get_WordOpenXML() {
  CString result;
  InvokeHelper(0x1aa, DISPATCH_PROPERTYGET, VT_BSTR, (void*)&result, nullptr);
  return result;
}

void WRange::SetListLevel(short Level) {
  static BYTE parms[] = VTS_I2;
  InvokeHelper(0x1ab, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Level);
}

void WRange::InsertAlignmentTab(long Alignment, long RelativeTo) {
  static BYTE parms[] = VTS_I4 VTS_I4;
  InvokeHelper(0x1f4, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, Alignment, RelativeTo);
}

LPDISPATCH WRange::get_ParentContentControl() {
  LPDISPATCH result;
  InvokeHelper(0x1f5, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

void WRange::ImportFragment(LPCTSTR FileName, BOOL MatchDestination) {
  static BYTE parms[] = VTS_BSTR VTS_BOOL;
  InvokeHelper(0x1f6, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, FileName, MatchDestination);
}

void WRange::ExportAsFixedFormat(LPCTSTR OutputFileName, long ExportFormat, BOOL OpenAfterExport, long OptimizeFor, BOOL ExportCurrentPage, long Item, BOOL IncludeDocProps, BOOL KeepIRM, long CreateBookmarks, BOOL DocStructureTags, BOOL BitmapMissingFonts, BOOL UseISO19005_1, VARIANT * FixedFormatExtClassPtr) {
  static BYTE parms[] = VTS_BSTR VTS_I4 VTS_BOOL VTS_I4 VTS_BOOL VTS_I4 VTS_BOOL VTS_BOOL VTS_I4 VTS_BOOL VTS_BOOL VTS_BOOL VTS_PVARIANT;
  InvokeHelper(0x1f7, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, OutputFileName, ExportFormat, OpenAfterExport, OptimizeFor, ExportCurrentPage, Item, IncludeDocProps, KeepIRM, CreateBookmarks, DocStructureTags, BitmapMissingFonts, UseISO19005_1, FixedFormatExtClassPtr);
}

LPDISPATCH WRange::get_Locks() {
  LPDISPATCH result;
  InvokeHelper(0x1f8, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH WRange::get_Updates() {
  LPDISPATCH result;
  InvokeHelper(0x1f9, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

LPDISPATCH WRange::get_Conflicts() {
  LPDISPATCH result;
  InvokeHelper(0x1fa, DISPATCH_PROPERTYGET, VT_DISPATCH, (void*)&result, nullptr);
  return result;
}

long WRange::get_TextVisibleOnScreen() {
  long result;
  InvokeHelper(0x1fb, DISPATCH_PROPERTYGET, VT_I4, (void*)&result, nullptr);
  return result;
}

void WRange::SortByHeadings(VARIANT * SortFieldType, VARIANT * SortOrder, VARIANT * CaseSensitive, VARIANT * BidiSort, VARIANT * IgnoreThe, VARIANT * IgnoreKashida, VARIANT * IgnoreDiacritics, VARIANT * IgnoreHe, VARIANT * LanguageID) {
  static BYTE parms[] = VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT;
  InvokeHelper(0x1fc, DISPATCH_METHOD, VT_EMPTY, nullptr, parms, SortFieldType, SortOrder, CaseSensitive, BidiSort, IgnoreThe, IgnoreKashida, IgnoreDiacritics, IgnoreHe, LanguageID);
}

} // namespace MSO::Word

#pragma warning( pop )